<?php

namespace AppBundle\Controller;

use AppBundle\Entity\JoueurNtScout;
use AppBundle\Form\JoueurNtScoutSearchType;
use AppBundle\Repository\TranscoTailleRepository;
use AppBundle\Repository\TranscoPotentielRepository;
use AppBundle\Repository\TranscoPositionRepository;
use AppBundle\Repository\PaysRepository;
use AppBundle\Repository\NationnaliteRepository;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

use Symfony\Component\Security\Core\Authentication\Token\UsernamePasswordToken;
use Symfony\Component\Security\Core\Authentication\Token\Storage\TokenStorage;
/**
 * Joueur controller.
 *
 * @Route("NTSO/acount")
 */
class AccountController extends Controller
{
    /**
     *
     * @Route("/accountindex", name="accountindex")
     */
    public function accountindexAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
       
        $maintenace = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'maintenance',
            ));
        if($maintenace->getValParam() == 'on')
        {
            echo "Maintenance of 'NT Scout Online' in progress, thank you for your understanding";
            die();
        }
        
        $nbElemAfficheDefault = $em->getRepository('AppBundle:Configuration')->findOneBy(
          array(
              'idParam'=>'nbElemAfficheDefault',
          ));
        $nbElemAfficheDefaultVal = $nbElemAfficheDefault->getValParam();
        $account = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'account',
            ));
        $accountVal = $account->getValParam();
        
        $user = $tokenStorage->getToken()->getUser();       
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);

        $session->remove('idRoster');
        $session->remove('lectureSeule');
        
        if($connexionOk == 'oui')
        {
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            
            if($infoUser)
            {
                $monAccount = $em->getRepository('AppBundle:Account')->find($infoUser->getId());
                $tabRoster = $em->getRepository('AppBundle:Roster')->findByIdAccount($infoUser->getId());
                $tabRosterShareByMe = $em->getRepository('AppBundle:RosterShare')->shareListByMe($infoUser->getId());
                $tabRosterShareForMe = $em->getRepository('AppBundle:RosterShare')->shareListForMe($infoUser->getId());
                $tabTrainingSimulator = $em->getRepository('AppBundle:TrainingSimulator')->findByIdAccount($infoUser->getId());
                $tabGameAnalysis = $em->getRepository('AppBundle:GameAnalysis')->findByIdAccount($infoUser->getId());
                
                $messageAccountError = $session->get('messageAccountError');
                $session->remove('messageAccountError');

                $messageAccountSuccess = $session->get('messageAccountSuccess');
                $session->remove('messageAccountSuccess');

                return $this->render('joueurntscout/accountIndex.html.twig', array(
                    'monAccount' => $monAccount,
                    'tabRoster' => $tabRoster,
                    'tabRosterShareByMe' => $tabRosterShareByMe,
                    'tabRosterShareForMe' => $tabRosterShareForMe,
                    'tabTrainingSimulator' => $tabTrainingSimulator,
                    'tabGameAnalysis' => $tabGameAnalysis,
                    'nbElemAfficheDefaultVal' => $nbElemAfficheDefaultVal,
                    'messageAccountError' => $messageAccountError,
                    'messageAccountSuccess' => $messageAccountSuccess,
                    'accountActif' => $accountVal,
                    'infoUser' => $infoUser,
                  ));
            }           
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        }
    }

    /**
     *
     * @Route("/accountcreation", name="accountcreation")
     */
    public function accountcreationAction(Request $request)
    {
      $em = $this->getDoctrine()->getManager();
      $session = $request->getSession();
      
      $login = $request->query->get('loginNTSO');
      $password = $request->query->get('passwordNTSO');
      $messageAccount = $em->getRepository('AppBundle:Account')->create($login,$password);
      $session->set('messageAccount', $messageAccount);
      return $this->redirect($this->generateUrl('accountindex'));
    }
    
    /**
     *
     * @Route("/accountlogin", name="accountlogin")
     */
    public function accountloginAction(Request $request)
    {
      $em = $this->getDoctrine()->getManager();
      $session = $request->getSession();
      $tokenStorage = $this->get('security.token_storage');
      $login = $request->query->get('loginNTSO');
      $password = $request->query->get('passwordNTSO');
      
      $messageAccount = $em->getRepository('AppBundle:Account')->login($login,$password);
      $session->set('messageAccount', $messageAccount);

      if($messageAccount == 'OK')
      {
          $token = new UsernamePasswordToken($login, $password, ['ROLE_ADMINISTRATOR']);
          $tokenStorage->setToken($token);
          
          $user = $tokenStorage->getToken()->getUser();  
          
          $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
          if($infoUser)
          {
            //tout va bien
          }
          else
          {
              $messageAccount = $infoUser;
              $session->set('messageAccount', $messageAccount);
              $em->getRepository('AppBundle:Account')->logout($tokenStorage);
          }
      }
      return $this->redirect($this->generateUrl('accountindex'));
    }
    
    /**
     *
     * @Route("/accountlogout", name="accountlogout")
     */
    public function accountlogoutAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $tokenStorage = $this->get('security.token_storage');
        $session = $request->getSession();
        
        $user = $tokenStorage->getToken()->getUser();
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        $ip = $_SERVER['REMOTE_ADDR'];
        $em->getRepository('AppBundle:ChatUserOnline')->remove($infoUser,$ip);
        
        $session->remove('idTrainingSimulation');
        $session->remove('lectureSeule');
                
        $tokenStorage = $em->getRepository('AppBundle:Account')->logout($tokenStorage);
        return $this->redirect($this->generateUrl('accountindex'));
    }
    
    /**
     *
     * @Route("/accountloadlinkntso", name="accountloadlinkntso")
     */
    public function accountloadlinkntsoAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {
            $linkNtso = $request->query->get('linkNtso');
            $nomChoisi = $request->query->get('nomChoisi');
            $em->getRepository('AppBundle:Account')->loadLinkNtso($linkNtso,$nomChoisi,$user,$session);
            return $this->redirect($this->generateUrl('accountindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/accountshareroster", name="accountshareroster")
     */
    public function accountsharerosterAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        { 
            $nomCompte = $request->query->get('nomCompte');
            $idRoster = $request->query->get('idRoster');
            
            $retour = $em->getRepository('AppBundle:RosterShare')->share($user,$idRoster,$nomCompte,$session);

            return $this->redirect($this->generateUrl('accountindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/accountunsharerosterforme", name="accountunsharerosterforme")
     */
    public function accountunsharerosterformeAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        { 
            $idRoster = $request->query->get('idRoster');
            $retour = $em->getRepository('AppBundle:RosterShare')->unshareForMe($user,$idRoster,$session);

            return $this->redirect($this->generateUrl('accountindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/accountunshareroster", name="accountunshareroster")
     */
    public function accountunsharerosterAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {
            $idUserShared = $request->query->get('idUserShared');
            $idRoster = $request->query->get('idRoster');
            
            $retour = $em->getRepository('AppBundle:RosterShare')->unshare($user,$idRoster,$idUserShared,$session);

            return $this->redirect($this->generateUrl('accountindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/accountdupliqueroster", name="accountdupliqueroster")
     */
    public function accountdupliquerosterAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        { 
            $nomChoisi = $request->query->get('nomChoisi');
            $idRoster = $request->query->get('idRoster');
            
            $typeDuplique = 'duplicateRoster';
            $retour = $em->getRepository('AppBundle:Account')->dupliqueRoster($nomChoisi,$idRoster,$user,$session,$typeDuplique);

            return $this->redirect($this->generateUrl('accountindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/accountcreateroster", name="accountcreateroster")
     */
    public function accountcreaterosterAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        { 
            $nomChoisi = $request->query->get('nomChoisi');
      
            $em->getRepository('AppBundle:Account')->createRoster($nomChoisi,$user,$session);

            return $this->redirect($this->generateUrl('accountindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }

    /**
     *
     * @Route("/accountcreatetraining", name="accountcreatetraining")
     */
    public function accountcreatetraining(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        { 
            $nomChoisi = $request->query->get('nomChoisi');
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            $idAccount = $infoUser->getId();
            $lvlEntraineur = 'avance';
            $dateDebutSimulation = '20/04/2018';
            $em->getRepository('AppBundle:TrainingSimulator')->create($idAccount,$nomChoisi,$lvlEntraineur,$dateDebutSimulation,$session);

            return $this->redirect($this->generateUrl('accountindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/accountcreatetanalyse", name="accountcreatetanalyse")
     */
    public function accountcreatetanalyse(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        { 
            $nomChoisi = $request->query->get('nomChoisi');
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            $idAccount = $infoUser->getId();
            $em->getRepository('AppBundle:GameAnalysis')->create($idAccount,$nomChoisi,$session);

            return $this->redirect($this->generateUrl('accountindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/accountdeleteroster", name="accountdeleteroster")
     */
    public function accountdeleterosterAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        { 
            $idRoster = $request->query->get('idRoster');
            $em->getRepository('AppBundle:Roster')->deleteRoster($idRoster,$user);
            return $this->redirect($this->generateUrl('accountindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/accountdeletetraining", name="accountdeletetraining")
     */
    public function accountdeletetrainingAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        { 
            $idTrainingSimulation = $request->query->get('idTrainingSimulation');
            $em->getRepository('AppBundle:TrainingSimulator')->remove($idTrainingSimulation,$user);
            return $this->redirect($this->generateUrl('accountindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
      
    /**
     *
     * @Route("/accountdeleteanalyse", name="accountdeleteanalyse")
     */
    public function accountdeleteanalyseAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        { 
            $idAnalyse = $request->query->get('idAnalyse');
            $em->getRepository('AppBundle:GameAnalysis')->remove($idAnalyse,$user);
            return $this->redirect($this->generateUrl('accountindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/accountupdateoption", name="accountupdateoption")
     */
    public function accountupdateoptionAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        { 
            $optionName = $request->get('optionName');
            $afficheOption = $request->get('afficheOption');
            $em->getRepository('AppBundle:Account')->updateOption($user,$optionName,$afficheOption);
        }
    }
    
    /**
     *
     * @Route("/accountformulenote", name="accountformulenote")
     */
    public function accountformulenote(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        { 
            $type = $request->query->get('type');
            $formule = base64_decode($request->query->get('formule'));
      
            echo $formule;
            
            $js = 10;
            $pe = 5;
            $pa = 10.5;
            $di = 8;
            $formule = str_replace("js", $js, $formule);
            $formule = str_replace("pe", $pe, $formule);
            $formule = str_replace("pa", $pa, $formule);
            $formule = str_replace("di", $di, $formule);
            
            $valeur = $this->evalmath($formule);
            echo $valeur;
            die();
            return $this->redirect($this->generateUrl('accountindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    function evalmath($equation)
    {
        $result = 0;
        // sanitize imput
        $equation = preg_replace("/[^a-z0-9+\-.*\/()%]/","",$equation);
        // convert alphabet to $variabel 
        $equation = preg_replace("/([a-z])+/i", "\$$0", $equation); 
        // convert percentages to decimal
        $equation = preg_replace("/([+-])([0-9]{1})(%)/","*(1\$1.0\$2)",$equation);
        $equation = preg_replace("/([+-])([0-9]+)(%)/","*(1\$1.\$2)",$equation);
        $equation = preg_replace("/([0-9]{1})(%)/",".0\$1",$equation);
        $equation = preg_replace("/([0-9]+)(%)/",".\$1",$equation);
        
        substr("testers", -1);
        
        echo $equation;
        if ( $equation != "" ){
            $result = @eval("return " . $equation . ";" );
        }
        if ($result == null) {
            throw new Exception("Unable to calculate equation");
        }
        return $result;
    }
    
    
}
