<?php

namespace AppBundle\Controller;

use AppBundle\Form\BugSendType;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

use Symfony\Component\Security\Core\Authentication\Token\UsernamePasswordToken;
use Symfony\Component\Security\Core\Authentication\Token\Storage\TokenStorage;
/**
 * Roster controller.
 *
 * @Route("NTSO/bug")
 */
class BugController extends Controller
{
       
    /**
     *
     * @Route("/bugindex", name="bugindex")
     */
    public function bugindexAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');

        $maintenace = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'maintenance',
            ));
        if($maintenace->getValParam() == 'on')
        {
            echo "Maintenance of 'NT Scout Online' in progress, thank you for your understanding";
            die();
        }
        
        $account = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'account',
            ));
        $accountVal = $account->getValParam();
        
        $user = $tokenStorage->getToken()->getUser();       
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        
        if($connexionOk == 'oui')
        {
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            
            $formBugSend = $this->createForm(BugSendType::class,null,array(
                'action' => $this->generateUrl('bugsend'),
                'method' => 'POST',
                'attr' => array(
                    )
                )
            );
            
            $messageAccountError = $session->get('messageAccountError');
            $session->remove('messageAccountError');

            $messageAccountSuccess = $session->get('messageAccountSuccess');
            $session->remove('messageAccountSuccess');
                    
            return $this->render('joueurntscout/bugIndex.html.twig', array(
                'accountActif' => $accountVal,
                'infoUser' => $infoUser,
                'formBugSend' => $formBugSend->createView(),
                'messageAccountError' => $messageAccountError,
                'messageAccountSuccess' => $messageAccountSuccess,
              ));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/bugsend", name="bugsend")
     */
    public function bugsend(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {
            $description = $request->request->get('bug_send')['description'];
            $em->getRepository('AppBundle:Bug')->send($user,$description);
            
            $messageAccountSuccess = 'Bug send ! Thanks';
            $session->set('messageAccountSuccess',$messageAccountSuccess);
            
            return $this->redirect($this->generateUrl('bugindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
}
