<?php

namespace AppBundle\Controller;

use AppBundle\Form\ChatSendType;
use AppBundle\Form\ChatWithSendType;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

use Symfony\Component\Security\Core\Authentication\Token\UsernamePasswordToken;
use Symfony\Component\Security\Core\Authentication\Token\Storage\TokenStorage;
/**
 * Roster controller.
 *
 * @Route("NTSO/chat")
 */
class ChatController extends Controller
{
    /**
     *
     * @Route("/chatindex", name="chatindex")
     */
    public function chatindexAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        
        $maintenace = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'maintenance',
            ));
        if($maintenace->getValParam() == 'on')
        {
            echo "Maintenance of 'NT Scout Online' in progress, thank you for your understanding";
            die();
        }
        
        $account = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'account',
            ));
        $accountVal = $account->getValParam();
        
        $user = $tokenStorage->getToken()->getUser();       
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        
        if($connexionOk == 'oui')
        {
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            
            $formChatSend = $this->createForm(ChatSendType::class,null,array(
                'action' => $this->generateUrl('chatsend'),
                'method' => 'POST',
                'attr' => array(
                    )
                )
            );
            
            $tabMessages = $em->getRepository('AppBundle:Chat')->lastsMessagesFromGlobal();

            $tabUsersOnline = $em->getRepository('AppBundle:ChatUserOnline')->userOnline();
            $tabListeUser = $tabUsersOnline['tabListeUser'];
            $cptUnknowAccount = $tabUsersOnline['cptUnknowAccount'];
            
            $messageAccountError = $session->get('messageAccountError');
            $session->remove('messageAccountError');

            $messageAccountSuccess = $session->get('messageAccountSuccess');
            $session->remove('messageAccountSuccess');
                    
            return $this->render('joueurntscout/chatIndex.html.twig', array(
                'accountActif' => $accountVal,
                'infoUser' => $infoUser,
                'tabMessages' => $tabMessages,
                'tabListeUser' => $tabListeUser,
                'cptUnknowAccount' => $cptUnknowAccount,
                'formChatSend' => $formChatSend->createView(),
                'messageAccountError' => $messageAccountError,
                'messageAccountSuccess' => $messageAccountSuccess,
              ));
        }
        else
        {
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            
            $formChatSend = $this->createForm(ChatSendType::class,null,array(
                'action' => $this->generateUrl('chatsend'),
                'method' => 'POST',
                'attr' => array(
                    )
                )
            );
            
            $tabMessages = $em->getRepository('AppBundle:Chat')->lastsMessagesFromGlobal();

            $tabUsersOnline = $em->getRepository('AppBundle:ChatUserOnline')->userOnline();
            $tabListeUser = $tabUsersOnline['tabListeUser'];
            $cptUnknowAccount = $tabUsersOnline['cptUnknowAccount'];
            
            $messageAccountError = $session->get('messageAccountError');
            $session->remove('messageAccountError');

            $messageAccountSuccess = $session->get('messageAccountSuccess');
            $session->remove('messageAccountSuccess');
                    
            return $this->render('joueurntscout/chatIndex.html.twig', array(
                'accountActif' => $accountVal,
                'infoUser' => $infoUser,
                'tabMessages' => $tabMessages,
                'tabListeUser' => $tabListeUser,
                'cptUnknowAccount' => $cptUnknowAccount,
                'formChatSend' => $formChatSend->createView(),
                'messageAccountError' => $messageAccountError,
                'messageAccountSuccess' => $messageAccountSuccess,
              ));
           
            //$tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            //return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/chatsend", name="chatsend")
     */
    public function chatsend(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        $ip = $_SERVER['REMOTE_ADDR'];
        
        if($connexionOk == 'oui')
        {
            $message = $request->request->get('chat_send')['message'];
            $em->getRepository('AppBundle:Chat')->send($user,'tous',$message);

            $em->getRepository('AppBundle:ChatUserOnline')->refresh($infoUser,$ip);
            
            return $this->redirect($this->generateUrl('chatindex'));
        }
        else
        {
            $message = $request->request->get('chat_send')['message'];
            $em->getRepository('AppBundle:Chat')->send($user,'tous',$message);

            $em->getRepository('AppBundle:ChatUserOnline')->refresh($infoUser,$ip);
            
            return $this->redirect($this->generateUrl('chatindex'));
            
            //$tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            //return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/chatadduser", name="chatadduser")
     */
    public function chatadduser(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        $ip = $_SERVER['REMOTE_ADDR'];

        $em->getRepository('AppBundle:ChatUserOnline')->add($infoUser,$ip);
                
        return $this->redirect($this->generateUrl('chatindex'));
    }
    
    /**
     *
     * @Route("/chatremoveuser", name="chatremoveuser")
     */
    public function chatremoveuser(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        $ip = $_SERVER['REMOTE_ADDR'];
        
        $em->getRepository('AppBundle:ChatUserOnline')->remove($infoUser,$ip);
        
        return $this->redirect($this->generateUrl('chatindex'));
    }
       
    /**
     *
     * @Route("/chatuseronline", name="chatuseronline")
     */
    public function chatuseronline(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $tabUsersOnline = $em->getRepository('AppBundle:ChatUserOnline')->userOnline();
        $tabListeUser = $tabUsersOnline['tabListeUser'];
        $cptUnknowAccount = $tabUsersOnline['cptUnknowAccount'];
        
        return $this->render('joueurntscout/chatUserOnline.html.twig', array(
                'tabListeUser' => $tabListeUser,
                'cptUnknowAccount' => $cptUnknowAccount,
              ));
    }
    
    /**
     *
     * @Route("/chatmessage", name="chatmessage")
     */
    public function chatmessage(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $tabMessages = $em->getRepository('AppBundle:Chat')->lastsMessagesFromGlobal();
        return $this->render('joueurntscout/chatMessage.html.twig', array(
                'tabMessages' => $tabMessages,
              ));
    }
    
    /**
     *
     * @Route("/chatwithindex", name="chatwithindex")
     */
    public function chatwithindexAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');

        $maintenace = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'maintenance',
            ));
        if($maintenace->getValParam() == 'on')
        {
            echo "Maintenance of 'NT Scout Online' in progress, thank you for your understanding";
            die();
        }
        
        $account = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'account',
            ));
        $accountVal = $account->getValParam();
        
        $user = $tokenStorage->getToken()->getUser();       
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        
        if($connexionOk == 'oui')
        {
            $nomCoach = $request->query->get('nomCoach');
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            $otherCoach = $em->getRepository('AppBundle:Account')->infoAccount($nomCoach);
            
            $formChatSend = $this->createForm(ChatWithSendType::class,null,array(
                'action' => $this->generateUrl('chatwithsend'),
                'method' => 'POST',
                'attr' => array(
                    )
                )
            );
            
            $tabMessages = $em->getRepository('AppBundle:Chat')->lastsMessagesBetween($infoUser,$otherCoach);

            $messageAccountError = $session->get('messageAccountError');
            $session->remove('messageAccountError');

            $messageAccountSuccess = $session->get('messageAccountSuccess');
            $session->remove('messageAccountSuccess');
                    
            return $this->render('joueurntscout/chatwithIndex.html.twig', array(
                'accountActif' => $accountVal,
                'infoUser' => $infoUser,
                'otherCoach' => $otherCoach,
                'tabMessages' => $tabMessages,
                'formChatSend' => $formChatSend->createView(),
                'messageAccountError' => $messageAccountError,
                'messageAccountSuccess' => $messageAccountSuccess,
              ));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        }
    }
    
    /**
     *
     * @Route("/chatwithsend", name="chatwithsend")
     */
    public function chatwithsend(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {
            $message = $request->request->get('chat_with_send')['message'];
            $nomCoach = $request->request->get('chat_with_send')['nomCoach'];
            $em->getRepository('AppBundle:Chat')->send($user,$nomCoach,$message);

            return $this->redirect($this->generateUrl('chatwithindex', array('nomCoach' => $nomCoach)));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/chatwithmessage", name="chatwithmessage")
     */
    public function chatwithmessage(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();       
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        
        if($connexionOk == 'oui')
        {
            $nomCoach = $request->query->get('nomCoach');
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            $otherCoach = $em->getRepository('AppBundle:Account')->infoAccount($nomCoach);
            $tabMessages = $em->getRepository('AppBundle:Chat')->lastsMessagesBetween($infoUser,$otherCoach);
            return $this->render('joueurntscout/chatMessage.html.twig', array(
                    'tabMessages' => $tabMessages,
                  ));
        }
    }
    
}
