<?php

namespace AppBundle\Controller;

use AppBundle\Form\SaveNameAnalysisType;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

/**
 * Roster controller.
 *
 * @Route("NTSO/gameanalysis")
 */
class GameAnalysisController extends Controller
{
    /**
     *
     * @Route("/gameanalysispreindex", name="gameanalysispreindex")
     */
    public function gameanalysispreindexAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        
        $user = $tokenStorage->getToken()->getUser();       
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);

        if($connexionOk == 'oui')
        {
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            $idAnalyse = $request->query->get('idAnalyse');
            $uneAnalyse = $em->getRepository('AppBundle:GameAnalysis')->findOneBy(
                array(
                    'id'=>$idAnalyse,
                    'idAccount'=>$infoUser->getId(),
                ));
            
            if($uneAnalyse)
            {
                $session->remove('idAnalyse');
                $session->set('idAnalyse',$idAnalyse);
                $session->remove('lectureSeule');
                $session->set('lectureSeule','off');
                return $this->redirect($this->generateUrl('gameanalysisindex'));
            }
            else
            {
                $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
                return $this->render($tabRetour['page'], $tabRetour['param']);
            }
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        }
    }
    
    /**
     *
     * @Route("/gameanalysisindex", name="gameanalysisindex")
     */
    public function gameanalysisindexAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
         
        $maintenace = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'maintenance',
            ));
        if($maintenace->getValParam() == 'on')
        {
            echo "Maintenance of 'NT Scout Online' in progress, thank you for your understanding";
            die();
        }
        $account = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'account',
            ));
        $accountVal = $account->getValParam();
        
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);

        if($connexionOk == 'oui')
        { 
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);

            $idAnalyse = $session->get('idAnalyse');
            $lectureSeule = $session->get('lectureSeule');
            
            if($lectureSeule == 'off')
            {
                $uneAnalyse = $em->getRepository('AppBundle:GameAnalysis')->findOneBy(
                    array(
                        'id'=>$idAnalyse,
                        'idAccount'=>$infoUser->getId(),
                    ));
            }
            else
            {
                $uneAnalyse = $em->getRepository('AppBundle:GameAnalysis')->findOneBy(
                    array(
                        'id'=>$idAnalyse,
                    ));
            }
            if($uneAnalyse)
            {
                if($infoUser)
                {
                    $messageAccountError = $session->get('messageAccountError');
                    $session->remove('messageAccountError');
                    
                    $messageAccountSuccess = $session->get('messageAccountSuccess');
                    $session->remove('messageAccountSuccess');

                    $messageError = $session->get('messageError');
                    $session->remove('messageError');

                    $messageSuccess = $session->get('messageSuccess');
                    $session->remove('messageSuccess');
                    
                    $formSaveNameAnalyse = $this->createForm(SaveNameAnalysisType::class,null,array(
                        'action' => $this->generateUrl('gameanalysismajname'),
                        'method' => 'POST',
                        'attr' => array(
                            )
                        )
                    );

                    $tabData = $em->getRepository('AppBundle:GameAnalysisMatchNt')->findDataMatchs(
                        array(
                            'idAnalyse'=>$idAnalyse,
                        ));
                    $tabGame = $tabData['fullData'];
                    $tabDataTeam = $tabData['tabDataTeamFinal'];
                    
                    $tabCouleurCarac = $em->getRepository('AppBundle:TranscoCarac')->findAll();
                    echo "<pre>";
                    //print_r($tabGame);
                    //print_r($tabDataTeam);
                    echo "</pre>";
                    
                    return $this->render('joueurntscout/gameAnalysisIndex.html.twig', array(
                        'accountActif' => $accountVal,
                        'infoUser' => $infoUser,
                        'uneAnalyse' => $uneAnalyse,
                        'tabGame' => $tabGame,
                        'tabDataTeam' => $tabDataTeam,
                        'tabCouleurCarac' => $tabCouleurCarac,
                        'lectureSeule' => $lectureSeule,
                        'formSaveNameAnalysis' => $formSaveNameAnalyse->createView(),
                        'messageAccountError' => $messageAccountError,
                        'messageAccountSuccess' => $messageAccountSuccess,
                        'messageError' => $messageError,
                        'messageSuccess' => $messageSuccess,
                      ));
                }
            }
            else
            {
                echo "Not your analysis ...";
                die();
            }
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($accountVal,$session);
            return $this->render($tabRetour['page'], $tabRetour['param']);
        }
    }

    /**
     *
     * @Route("/gameanalysismajname", name="gameanalysismajname")
     */
    public function gameanalysismajname(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {            
            $nomAnalyse = $request->request->get('save_name_analysis')['nom'];
            $commentaireAnalyse = $request->request->get('save_name_analysis')['commentaire'];
            $idAnalyse = $session->get('idAnalyse');
            $em->getRepository('AppBundle:GameAnalysis')->update($idAnalyse,$nomAnalyse,$commentaireAnalyse);
            return $this->redirect($this->generateUrl('gameanalysisindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/gameanalysisaddmatch", name="gameanalysisaddmatch")
     */
    public function gameanalysisaddmatch(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $idMatch = $request->get('idMatch');
        $idAnalyse = $session->get('idAnalyse');
        $unMatch = $em->getRepository('AppBundle:Api')->getBoxScore($idMatch);
        if($unMatch)
        {    
            $em->getRepository('AppBundle:GameAnalysisMatchNt')->addMatchToAnalysis($unMatch->getId(),$idAnalyse,$session);
        }
        else
        {
            $session->set('messageError','Game not found');
        }
        return $this->redirect($this->generateUrl('gameanalysisindex'));
    }
    
    /**
     *
     * @Route("/gameanalysisremovematch", name="gameanalysisremovematch")
     */
    public function gameanalysisremovematch(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $idGameAnalysisMatchNt = $request->get('idGameAnalysisMatchNt');
        $idAnalyse = $session->get('idAnalyse');
        $em->getRepository('AppBundle:GameAnalysisMatchNt')->removeMatchFromAnalysis($idGameAnalysisMatchNt,$idAnalyse,$session);
        return $this->redirect($this->generateUrl('gameanalysisindex'));
    }
    
    /**
     *
     * @Route("/gameanalysismovematch", name="gameanalysismovematch")
     */
    public function gameanalysismovematch(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $idGameAnalysisMatchNt = $request->get('idGameAnalysisMatchNt');
        $sens = $request->get('sens');
        $idAnalyse = $session->get('idAnalyse');
        $em->getRepository('AppBundle:GameAnalysisMatchNt')->moveMatch($idGameAnalysisMatchNt,$idAnalyse,$sens);
        return $this->redirect($this->generateUrl('gameanalysisindex'));
    }
    
}
