<?php

namespace AppBundle\Controller;

use AppBundle\Entity\Joueur;
use AppBundle\Form\JoueurSearchType;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Component\HttpFoundation\Request;

/**
 * Joueur controller.
 *
 * @Route("joueur")
 */
class JoueurController extends Controller
{
    /**
     * Lists all joueur entities.
     *
     * @Route("/", name="joueur_index")
     */
    public function indexAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();

        $form = $this->createForm(JoueurSearchType::class);

        $dataSearch = null;
        if ($request->getMethod() == 'POST') {
            $form->handleRequest($request);
            $dataSearch = $form->getData();
        }
        
        $joueurs = $em->getRepository('AppBundle:Joueur')->findJoueurs($dataSearch);

        return $this->render('joueur/index.html.twig', array(
            'form' => $form->createView(),
            'joueurs' => $joueurs,
        ));
    }
}
