<?php

namespace AppBundle\Controller;

use AppBundle\Entity\JoueurNtScout;
use AppBundle\Form\JoueurNtScoutSearchType;
use AppBundle\Form\ExportOptionType;
use AppBundle\Repository\TranscoTailleRepository;
use AppBundle\Repository\TranscoPotentielRepository;
use AppBundle\Repository\TranscoPositionRepository;
use AppBundle\Repository\PaysRepository;
use AppBundle\Repository\NationnaliteRepository;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

use Symfony\Component\Security\Core\Authentication\Token\UsernamePasswordToken;
use Symfony\Component\Security\Core\Authentication\Token\Storage\TokenStorage;
/**
 * Joueur controller.
 *
 * @Route("NTSO/index")
 */
class JoueurNtScoutController extends Controller
{
    /**
     *
     * @Route("/venteperso", name="venteperso")
     */
    public function ventepersoAction(Request $request)
    {
      $em = $this->getDoctrine()->getManager();
        
      $bbId = $request->query->get('bbId');
      $em->getRepository('AppBundle:JoueurVenteByManager')->venteJoueur($bbId);
    }

    /**
     *
     * @Route("/nbUsersEvol", name="nbUsersEvol")
     */
    public function nbUsersEvolAction(Request $request)
    {
      $em = $this->getDoctrine()->getManager();

      $pays = $request->query->get('pays');
      $nbAllUserEvol = $em->getRepository('AppBundle:PaysNbUsers')->getNbAllUserEvol($pays);
      
      $nomPays = '';
      if($pays <> 'all')
      {
          $objPays = $em->getRepository('AppBundle:Pays')->find($pays);
          $nomPays = $objPays->getNom();
      }
      
      return $this->render('joueurntscout/nbUsersEvol.html.twig', array(
          'nbAllUserEvol' => $nbAllUserEvol,
          'nomPays' => $nomPays
        ));
    }
    
    /**
     * Lists all joueur entities.
     *
     * @Route("/{codeAdmin}", defaults={"codeAdmin"= null}, name="joueurntscout_index")
     */
    public function indexAction(Request $request, $codeAdmin)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        
        $maintenace = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'maintenance',
            ));
        if($maintenace->getValParam() == 'on')
        {
            echo "Maintenance of 'NT Scout Online' in progress, thank you for your understanding";
            die();
        }
        
        $forSale = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'forSale',
            ));
        $forSaleVal = $forSale->getValParam();
        $forSaleByManager = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'forSaleByManager',
            ));
        $forSaleByManagerVal = $forSaleByManager->getValParam();
        $nationalTeam = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'nationalTeam',
            ));
        $nationalTeamVal = $nationalTeam->getValParam();
        $showSkills = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'showSkills',
            ));
        $showSkillsVal = $showSkills->getValParam();
        $actions = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'actions',
            ));
        $actionsVal = $actions->getValParam();
        $export = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'export',
            ));
        $exportVal = $export->getValParam();
        $nbElemAfficheDefault = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'nbElemAfficheDefault',
            ));
        $nbElemAfficheDefaultVal = $nbElemAfficheDefault->getValParam();
        $paysLancement = $em->getRepository('AppBundle:Configuration')->findOneBy(
                array(
                    'idParam'=>'paysLancement',
                ));
        $paysLancementVal = $paysLancement->getValParam();
        $account = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'account',
            ));
        $accountVal = $account->getValParam();
        
        if($paysLancementVal == 'on')
        {
            $ip = $_SERVER['REMOTE_ADDR'];
            if($ip == '127.0.0.1')
            {
                $codePaysLancement = "FR";
            }
            else
            {
                $fileGetContents = file_get_contents("http://ipinfo.io/{$ip}");
                $details = json_decode($fileGetContents);
                $codePaysLancement = $details->country;
            }
            
            $objPaysLancement = $em->getRepository('AppBundle:Nationalite')->findOneBy(array('codePaysIso'=>$codePaysLancement));
            $idPaysLancement = $objPaysLancement->getId();
            $idPaysUser = $idPaysLancement;
        }
            
        if($codeAdmin == "showmethemoney")
        {
            $forSaleVal = 'on';
            $forSaleByManagerVal = 'off';
            $nationalTeamVal = 'on';
            $showSkillsVal = 'on';
            $exportVal = 'off';
            $actionsVal = 'off';
            \ini_set('memory_limit', '2048M');
        }
        
        $form = $this->createForm(JoueurNtScoutSearchType::class,null,array(
            'attr' => array(
                'forSale'=>$forSaleVal,
                'forSaleByManager'=>$forSaleByManagerVal,
                'nationalTeam'=>$nationalTeamVal,
                'showSkills'=>$showSkillsVal
                )
            )
        );

        $dataSearch = null;
        if ($request->getMethod() == 'POST') {
            
            $form->handleRequest($request);
            $dataSearch = $form->getData();
            
            $dataSearch['paysLancement'] = $codePaysLancement;
            $dataSearch['ageMin'] = $request->request->get('joueur_nt_scout_search')['ageMin'];
            $dataSearch['ageMax'] = $request->request->get('joueur_nt_scout_search')['ageMax'];
            $dataSearch['salaireMin'] = $request->request->get('joueur_nt_scout_search')['salaireMin'];
            $dataSearch['salaireMax'] = $request->request->get('joueur_nt_scout_search')['salaireMax'];
            $dataSearch['tailleMin'] = $request->request->get('joueur_nt_scout_search')['tailleMin'];
            $dataSearch['tailleMax'] = $request->request->get('joueur_nt_scout_search')['tailleMax'];
            $dataSearch['potentielMin'] = $request->request->get('joueur_nt_scout_search')['potentielMin'];
            $dataSearch['potentielMax'] = $request->request->get('joueur_nt_scout_search')['potentielMax'];
            $dataSearch['pays'] = $request->request->get('joueur_nt_scout_search')['pays'];
            $dataSearch['nationalite'] = $request->request->get('joueur_nt_scout_search')['nationalite'];
            $idPaysLancement = $dataSearch['nationalite'];
            if(isset($request->request->get('joueur_nt_scout_search')['position']))
            {
                $listePosition = implode('_', $request->request->get('joueur_nt_scout_search')['position']);
                $dataSearch['position'] = $listePosition;
            }
            else
            {
                $dataSearch['position'] = '';
            }
            
            $dataSearch['dmiMin'] = $request->request->get('joueur_nt_scout_search')['dmiMin'];
            $dataSearch['dmiMax'] = $request->request->get('joueur_nt_scout_search')['dmiMax'];
            $dataSearch['formeMin'] = $request->request->get('joueur_nt_scout_search')['formeMin'];
            $dataSearch['formeMax'] = $request->request->get('joueur_nt_scout_search')['formeMax'];
            $dataSearch['requeteCustom'] = $request->request->get('joueur_nt_scout_search')['requeteCustom'];
            if($nationalTeamVal == 'on')
            {
                $dataSearch['equipeNationale'] = $request->request->get('joueur_nt_scout_search')['equipeNationale'];
            }
            if($showSkillsVal == 'on')
            {
                $dataSearch['caracConnues'] = $request->request->get('joueur_nt_scout_search')['caracConnues'];
            }
            $dataSearch['botBientot'] = $request->request->get('joueur_nt_scout_search')['botBientot'];
            $dataSearch['tabBbId'] = '';
        }

        $session->remove('dataSearch');
        $session->set('dataSearch', $dataSearch);
            
        if($dataSearch['ownerBbId'] <> '' || $dataSearch['teamIdDraft'] <> '')
        {
            $ownerBbId = $dataSearch['ownerBbId'];
            $teamIdDraft = $dataSearch['teamIdDraft'];
            
            $session->remove('dataSearch');
            
            $dataSearch = null;
            $dataSearch['ownerBbId'] = '';
            $dataSearch['nom'] = '';
            $dataSearch['prenom'] = '';
            $dataSearch['ageMin'] = '';
            $dataSearch['ageMax'] = '';
            $dataSearch['salaireMin'] = '';
            $dataSearch['salaireMax'] = '';
            $dataSearch['tailleMin'] = '';
            $dataSearch['tailleMax'] = '';
            $dataSearch['potentielMin'] = '';
            $dataSearch['potentielMax'] = '';
            $dataSearch['nationalite'] = '';
            $dataSearch['pays'] = '';
            $dataSearch['position'] = '';
            $dataSearch['dmiMin'] = '';
            $dataSearch['dmiMax'] = '';
            $dataSearch['blessure'] = '';
            $dataSearch['formeMin'] = '';
            $dataSearch['formeMax'] = '';
            $dataSearch['equipeNationale'] = '';
            $dataSearch['aVendre'] = '';
            $dataSearch['aVendreByManager'] = '';
            $dataSearch['caracConnues'] = '';
            $dataSearch['botBientot'] = '';
            $dataSearch['requeteCustom'] = '';
            $dataSearch['draftId'] = '';
            $dataSearch['teamIdDraft'] = '';
                
            if($ownerBbId <> '')
            {
                $dataSearch['ownerBbId'] = $ownerBbId;
                $dataSearch['teamIdDraft'] = '';
            }
            
            if($teamIdDraft <> '')
            {
               $dataSearch['ownerBbId'] = '';
               $dataSearch['teamIdDraft'] = $teamIdDraft;
            }
            if($paysLancementVal == 'on')
            {
                $dataSearch['paysLancement'] = $codePaysLancement;
            }
            $dataSearch['tabBbId'] = '';
            
            $session->set('dataSearch', $dataSearch);
            $joueurs = $em->getRepository('AppBundle:JoueurNtScout')->findJoueursNtScout(
                        $dataSearch,
                        $forSaleVal,
                        $forSaleByManagerVal,
                        $nationalTeamVal,
                        $showSkillsVal
                        );
        }
        else
        {
            if($dataSearch['requeteCustom'] == '')
            {
                $joueurs = $em->getRepository('AppBundle:JoueurNtScout')->findJoueursNtScout(
                        $dataSearch,
                        $forSaleVal,
                        $forSaleByManagerVal,
                        $nationalTeamVal,
                        $showSkillsVal
                        );
            }
            else
            {
                $joueurs = $em->getRepository('AppBundle:JoueurNtScout')->findJoueursNtScoutReqCustom(
                        $dataSearch,
                        $session,
                        $forSaleVal,
                        $forSaleByManagerVal,
                        $nationalTeamVal,
                        $showSkillsVal
                        );
            }
        }
        $dateDernierLancementNTScout = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'lastLaunchNTScout',
            ));
        $dateDernierLancementInfoJoueur = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'lastLaunchInfoJoueur',
            ));
        $nbJoueurs = $em->getRepository('AppBundle:JoueurNtScout')->count();
        $nbCaracs = $em->getRepository('AppBundle:JoueurCarac')->count();
        $nbRecherche = $em->getRepository('AppBundle:Recherche')->countRecherche($dateDernierLancementNTScout->getValParam());
        $tabCouleurCarac = $em->getRepository('AppBundle:TranscoCarac')->findAll();
        $randomStat = $em->getRepository('AppBundle:Recherche')->randomStat();
        $nbAllUserLast = $em->getRepository('AppBundle:PaysNbUsers')->getNbAllUserLast();
        
        $queryExportOption = $em->getRepository('AppBundle:ExportAffichage')->getExportAffichage($nationalTeamVal);
        $exportsOptions = $queryExportOption->getQuery()->getResult();
        
        $dateDuJour = new \DateTime();
                       
        $user = $tokenStorage->getToken()->getUser();       
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        $utilisateurEnLigne = 'non';
        $utilisateurChatIndex = 'non';
        $tabRosterGeneration = array();
        if($connexionOk == 'oui')
        {
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            if($infoUser)
            {
                $idRoster = $session->get('idRoster');
                $utilisateurChatIndex = 'oui';
                if($idRoster <> '')
                {
                    $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
                        array(
                            'id'=>$idRoster,
                            'idAccount'=>$infoUser->getId(),
                        ));

                    if($unRoster)
                    {
                        $utilisateurEnLigne = 'oui';

                        $tabAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findBy(
                            array(
                                'id'=>$idRoster,
                                'idAccount'=>$infoUser->getId(),
                            ));
                        foreach($tabAccountJoueur as $unAccountJoueur)
                        {
                            $tabRosterGeneration[$unAccountJoueur->getBbId()] = 'on';
                        }
                    }
                }
            }
        }
        
        $formExport = $this->createForm(ExportOptionType::class,null,array(
            'action' => $this->generateUrl('joueurntscout_export'),
            'method' => 'POST',
            'attr' => array(
                'forSale'=>$forSaleVal,
                'forSaleByManagerVal'=>$forSaleByManagerVal,
                'nationalTeam'=>$nationalTeamVal,
                'showSkills'=>$showSkillsVal,
                'exportVal'=>$exportVal,
                'nbJoueurs'=>count($joueurs),
                )
            )
        );

        return $this->render('joueurntscout/index.html.twig', array(
            'form' => $form->createView(),
            'formExport' => $formExport->createView(),
            'joueurs' => $joueurs,
            'lastLaunchNTScout' => $dateDernierLancementNTScout->getValParam(),
            'lastLaunchInfoJoueur' => $dateDernierLancementInfoJoueur->getValParam(),
            'nbJoueursTotal' => $nbJoueurs['nb'],
            'nbCaracsTotal' => $nbCaracs['nb'],
            'nbRecherche' => $nbRecherche['nbRecherche'],
            'randomStat' => $randomStat,
            'forSaleActif' => $forSaleVal,
            'forSaleByManagerActif' => $forSaleByManagerVal,
            'nationalTeamActif' => $nationalTeamVal,
            'showSkillsActif' => $showSkillsVal,
            'actionsActif' => $actionsVal,
            'exportActif' => $exportVal,
            'tabCouleurCarac' => $tabCouleurCarac,
            'dateDuJour' => $dateDuJour,
            'nbElemAfficheDefaultVal' => $nbElemAfficheDefaultVal,
            'exportsOptions' => $exportsOptions,
            'idPaysLancement' => $idPaysLancement,
            'idPaysUser' => $idPaysUser,
            'nbAllUserLast' => $nbAllUserLast,
            'tabRosterGeneration' => $tabRosterGeneration,
            'accountActif' => $accountVal,
            'utilisateurEnLigne' => $utilisateurEnLigne,
            'utilisateurChatIndex' => $utilisateurChatIndex,
        ));
    }
    
    /**
     * Lists all joueur entities.
     *
     * @Route("/export/csv", name="joueurntscout_export")
     */
    public function exportAction(Request $request)
    {
        \ini_set('memory_limit', '2048M');
        
        $em = $this->getDoctrine()->getEntityManager();
        
        $session = $request->getSession();
        $dataSearch = $session->get('dataSearch');
        
        $forSale = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'forSale',
            ));
        $forSaleVal = $forSale->getValParam();
        $forSaleByManager = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'forSaleByManager',
            ));
        $forSaleByManagerVal = $forSaleByManager->getValParam();
        $nationalTeam = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'nationalTeam',
            ));
        $nationalTeamVal = $nationalTeam->getValParam();
        $showSkills = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'showSkills',
            ));
        $showSkillsVal = $showSkills->getValParam();
        $export = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'export',
            ));
        $exportVal = $export->getValParam();

        $critereRecherche = $request->request->get('export_option')['critereRecherche'];
        $enteteColonne = $request->request->get('export_option')['enteteColonne'];
        $colonneExport = $request->request->get('export_option')['colonneExport'];
        $exportAffichage = $em->getRepository('AppBundle:ExportAffichage')->find($colonneExport);
        
        $joueurs = $em->getRepository('AppBundle:JoueurNtScout')->findJoueursNtScout(
                $dataSearch,
                $forSaleVal,
                $forSaleByManagerVal,
                $nationalTeamVal,
                $showSkillsVal
                );

        $handle = fopen('php://memory', 'r+');

        if($critereRecherche == 1)
        {
            if($nationalTeamVal == 'on')
            {
                fputcsv(
                        $handle, 
                        array(
                            'Nationality',
                            'Play In',
                            'Botification Soon',
                            'Draft Team BB Id', 
                            'Owner BB Id', 
                            'Name', 
                            'First Name', 
                            'Best Position',
                            'Injury',
                            'Draft Season',
                            'National Team',
                            'Age Min',
                            'Age Max',
                            'Height Min',
                            'Height Max',
                            'Potential Min',
                            'Potential Max', 
                            'Salary Min',
                            'Salary Max',
                            'Dmin Min',
                            'Dmin Max',
                            'Game Shape Min',
                            'Game Shape Max',
                        ),
                        ';');
            }
            else
            {
               fputcsv(
                        $handle, 
                        array(
                            'Nationality',
                            'Play In',
                            'Botification Soon',
                            'Draft Team BB Id',
                            'Owner BB Id', 
                            'Name', 
                            'First Name', 
                            'Best Position',
                            'Injury',
                            'Draft Season',
                            'Age Min',
                            'Age Max',
                            'Height Min',
                            'Height Max',
                            'Potential Min',
                            'Potential Max', 
                            'Salary Min',
                            'Salary Max',
                            'Dmin Min',
                            'Dmin Max',
                            'Game Shape Min',
                            'Game Shape Max',
                        ),
                        ';'); 
            }
            $tailleMin = $em->getRepository('AppBundle:TranscoTaille')->find($dataSearch['tailleMin']);
            $tailleMax = $em->getRepository('AppBundle:TranscoTaille')->find($dataSearch['tailleMax']);
            if($dataSearch['potentielMin'] == '')
            {
                $potentielMin = '';
            }
            else
            {
                $potentielMin = $em->getRepository('AppBundle:TranscoPotentiel')->find($dataSearch['potentielMin']);
            }
            if($dataSearch['potentielMax'] == '')
            {
                $potentielMax = '';
            }
            else
            {
                $potentielMax = $em->getRepository('AppBundle:TranscoPotentiel')->find($dataSearch['potentielMax']);
            }
            
            $tabPosition = explode('_',$dataSearch['position']);   
            if(count($tabPosition) > 1)
            {
                $position = '';
                foreach($tabPosition as $unePosition)
                {
                    $objPosition = $em->getRepository('AppBundle:TranscoPosition')->find($unePosition);
                    $position .= $objPosition."/";
                }
                $position = substr($position, 0, -1);
            }
            else
            {
                $position = $em->getRepository('AppBundle:TranscoPosition')->find($dataSearch['position']);
            }
            
            $pays = $em->getRepository('AppBundle:Pays')->find($dataSearch['pays']);
            $nationalite = $em->getRepository('AppBundle:Nationalite')->find($dataSearch['nationalite']);
            if($dataSearch['formeMin'] == '')
            {
                $formeMin = '';
            }
            else
            {
                $formeMin = $em->getRepository('AppBundle:TranscoCarac')->find($dataSearch['formeMin']);
            }
            if($dataSearch['formeMax'] == '')
            {
                $formeMax = '';
            }
            else
            {
                $formeMax = $em->getRepository('AppBundle:TranscoCarac')->find($dataSearch['formeMax']);
            }
            if($dataSearch['blessure'] == '')
            {
                $blessure = '';
            }
            else
            {
                if($dataSearch['blessure'] == '0')
                {
                    $blessure = "No";
                }
                else
                {
                    $blessure = "Yes";
                }
            }
            if($dataSearch['botBientot'] == '')
            {
                $botBientot = '';
            }
            else
            {
                if($dataSearch['botBientot'] == '0')
                {
                    $botBientot = "No";
                }
                else
                {
                    $botBientot = "Yes";
                }
            }
            if($nationalTeamVal == 'on')
            {
                fputcsv(
                        $handle, 
                        array(
                            $nationalite, 
                            $pays,
                            $botBientot,
                            $dataSearch['teamIdDraft'],
                            $dataSearch['ownerBbId'], 
                            $dataSearch['nom'], 
                            $dataSearch['prenom'], 
                            $position, 
                            $blessure,
                            $dataSearch['draftId'],
                            $dataSearch['equipeNationale'], 
                            $dataSearch['ageMin'], 
                            $dataSearch['ageMax'], 
                            $tailleMin, 
                            $tailleMax, 
                            $potentielMin, 
                            $potentielMax, 
                            $dataSearch['salaireMin'], 
                            $dataSearch['salaireMax'], 
                            $dataSearch['dmiMin'], 
                            $dataSearch['dmiMax'], 
                            $formeMin, 
                            $formeMax, 
                        ),
                        ';');
            }
            else
            {
                fputcsv(
                        $handle, 
                        array(
                            $nationalite, 
                            $pays,
                            $botBientot,
                            $dataSearch['teamIdDraft'],
                            $dataSearch['ownerBbId'], 
                            $dataSearch['nom'], 
                            $dataSearch['prenom'], 
                            $position, 
                            $blessure,
                            $dataSearch['draftId'],
                            $dataSearch['ageMin'], 
                            $dataSearch['ageMax'], 
                            $tailleMin, 
                            $tailleMax, 
                            $potentielMin, 
                            $potentielMax, 
                            $dataSearch['salaireMin'], 
                            $dataSearch['salaireMax'], 
                            $dataSearch['dmiMin'], 
                            $dataSearch['dmiMax'], 
                            $formeMin, 
                            $formeMax, 
                        ),
                        ';');
            }
            fputcsv(
                    $handle, 
                    array(
                    ),
                    ';');
        }
        
        if($enteteColonne == 1)
        {
            $tabEntete = explode("#",$exportAffichage->getEntete());
            fputcsv(
                $handle, 
                $tabEntete,
                ';');
        }
        
        $tabColonne = explode("#",$exportAffichage->getColonne());
        foreach ($joueurs as $unJoueur) {
            
            $tabData = array();
            
            foreach($tabColonne as $uneColonne)
            {
                if($uneColonne == 'link')
                {
                    $tabData[] = "http://www.buzzerbeater.com/player/".$unJoueur['bbId']."/overview.aspx";
                }
                else
                {
                    $tabData[] = $unJoueur[$uneColonne];
                }
            }
           
            fputcsv(
               $handle, // The file pointer
               $tabData,
               ';');
        }
        
        rewind($handle);
        $content = stream_get_contents($handle);
        fclose($handle);
        
        return new Response($content, 200, array(
            'Content-Type' => 'application/force-download',
            'Content-Disposition' => 'attachment; filename="export.csv"'
        ));
    }
}
