<?php

namespace AppBundle\Controller;

use AppBundle\Entity\JoueurNtScout;
use AppBundle\Form\JoueurNtScoutSearchType;
use AppBundle\Form\ExportOptionType;
use AppBundle\Form\SaveCommentPlayerType;
use AppBundle\Repository\TranscoTailleRepository;
use AppBundle\Repository\TranscoPotentielRepository;
use AppBundle\Repository\TranscoPositionRepository;
use AppBundle\Repository\PaysRepository;
use AppBundle\Repository\NationnaliteRepository;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

use Symfony\Component\Security\Core\Authentication\Token\UsernamePasswordToken;
use Symfony\Component\Security\Core\Authentication\Token\Storage\TokenStorage;
/**
 * Roster controller.
 *
 * @Route("NTSO/minutes")
 */
class MinutesController extends Controller
{
       
    /**
     *
     * @Route("/minutesindex", name="minutesindex")
     */
    public function minutesindexAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');

        $maintenace = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'maintenance',
            ));
        if($maintenace->getValParam() == 'on')
        {
            echo "Maintenance of 'NT Scout Online' in progress, thank you for your understanding";
            die();
        }
        
        $account = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'account',
            ));
        $accountVal = $account->getValParam();
        
        $user = $tokenStorage->getToken()->getUser();       
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        
        if($connexionOk == 'oui')
        {
            $bbId = $request->query->get('bbId');
            
            $idRoster = $session->get('idRoster');
            $lectureSeule = $session->get('lectureSeule');
            
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            
            if($lectureSeule == 'off')
            {
                $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
                    array(
                        'id'=>$idRoster,
                        'idAccount'=>$infoUser->getId(),
                    ));
            }
            else
            {
                $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
                    array(
                        'id'=>$idRoster,
                    ));
            }
            if($unRoster)
            {
                if($infoUser)
                {
                    if($lectureSeule == 'off')
                    {
                        $objAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findOneBy(
                            array(
                                'idRoster'=>$idRoster,
                                'idAccount'=>$infoUser->getId(),
                                'bbId' => $bbId,
                            ));
                    }
                    else
                    {
                        $objAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findOneBy(
                            array(
                                'idRoster'=>$idRoster,
                                'bbId' => $bbId,
                            ));
                    }
                    if($objAccountJoueur)
                    {
                        $unJoueur = $em->getRepository('AppBundle:JoueurNtScout')->findOneByBbId($bbId);
                        
                        $objAccountJoueurMinutes = $em->getRepository('AppBundle:AccountJoueurMinutes')->findBy(
                                array(
                                    'bbId' => $bbId,
                                ));
                        
                        $totalMinuteSemaineEnCours = $em->getRepository('AppBundle:AccountJoueurMinutes')->calculMinuteSemaineEnCours($bbId);
                    }
                    else
                    {
                        $unJoueur = null;
                    }
                }
                else
                {
                    $unJoueur = null;
                }
            }
            else
            {
                $unJoueur = null;
            }
            
            $messageAccountError = $session->get('messageAccountError');
            $session->remove('messageAccountError');

            $messageAccountSuccess = $session->get('messageAccountSuccess');
            $session->remove('messageAccountSuccess');
                 
            return $this->render('joueurntscout/minutesIndex.html.twig', array(
                'joueur' => $unJoueur,
                'objAccountJoueurMinutes' => $objAccountJoueurMinutes,
                'totalMinuteSemaineEnCours' => $totalMinuteSemaineEnCours,
                'accountActif' => $accountVal,
                'infoUser' => $infoUser,
                'unRoster' => $unRoster,
                'messageAccountError' => $messageAccountError,
                'messageAccountSuccess' => $messageAccountSuccess,
                'lectureSeule' => $lectureSeule,
              ));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
}
