<?php

namespace AppBundle\Controller;

use AppBundle\Entity\JoueurNtScout;
use AppBundle\Form\JoueurNtScoutSearchType;
use AppBundle\Form\ExportOptionType;
use AppBundle\Form\SaveCommentPlayerType;
use AppBundle\Repository\TranscoTailleRepository;
use AppBundle\Repository\TranscoPotentielRepository;
use AppBundle\Repository\TranscoPositionRepository;
use AppBundle\Repository\PaysRepository;
use AppBundle\Repository\NationnaliteRepository;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

use Symfony\Component\Security\Core\Authentication\Token\UsernamePasswordToken;
use Symfony\Component\Security\Core\Authentication\Token\Storage\TokenStorage;
/**
 * Roster controller.
 *
 * @Route("NTSO/player")
 */
class PlayerController extends Controller
{
       
    /**
     *
     * @Route("/playerindex", name="playerindex")
     */
    public function playerindexAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');

        $maintenace = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'maintenance',
            ));
        if($maintenace->getValParam() == 'on')
        {
            echo "Maintenance of 'NT Scout Online' in progress, thank you for your understanding";
            die();
        }
        
        $account = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'account',
            ));
        $accountVal = $account->getValParam();
        
        $nbJourAlarmeBot = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'nbJourAlarmeBot',
            ));
        $nbJourAlarmeBotVal = $nbJourAlarmeBot->getValParam();
        $alerBot = 'non';
        $dateDuJour = new \DateTime();
        
        $user = $tokenStorage->getToken()->getUser();       
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        
        if($connexionOk == 'oui')
        {
            $bbId = $request->query->get('bbId');
            
            $idRoster = $session->get('idRoster');
            $lectureSeule = $session->get('lectureSeule');
            
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            
            if($lectureSeule == 'off')
            {
                $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
                    array(
                        'id'=>$idRoster,
                        'idAccount'=>$infoUser->getId(),
                    ));
            }
            else
            {
                $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
                    array(
                        'id'=>$idRoster,
                    ));
            }
            if($unRoster)
            {
                if($infoUser)
                {
                    if($lectureSeule == 'off')
                    {
                        $objAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findOneBy(
                            array(
                                'idRoster'=>$idRoster,
                                'idAccount'=>$infoUser->getId(),
                                'bbId' => $bbId,
                            ));
                    }
                    else
                    {
                        $objAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findOneBy(
                            array(
                                'idRoster'=>$idRoster,
                                'bbId' => $bbId,
                            ));
                    }
                    if($objAccountJoueur)
                    {
                        $unJoueur = $em->getRepository('AppBundle:JoueurNtScout')->findOneByBbId($bbId);
                        
                        if($lectureSeule == 'off')
                        {
                            $objAccountJoueurCarac = $em->getRepository('AppBundle:AccountJoueurCarac')->findOneBy(
                                array(
                                    'idRoster'=>$idRoster,
                                    'idAccount'=>$infoUser->getId(),
                                    'bbId' => $bbId,
                                ));
                        }
                        else
                        {
                            $objAccountJoueurCarac = $em->getRepository('AppBundle:AccountJoueurCarac')->findOneBy(
                                array(
                                    'idRoster'=>$idRoster,
                                    'bbId' => $bbId,
                                ));
                        }
                        
                        $idProprio = $unJoueur->getProprietaireBbId();
                        $dateAlarmeBotification = clone $unJoueur->getDerniereConnexion();
                        $plusNbJourAlarmeBotVal = new \DateInterval( "P".$nbJourAlarmeBotVal."D" );
                        $dateAlarmeBotification->add($plusNbJourAlarmeBotVal);
                        if($dateDuJour >= $dateAlarmeBotification)
                        {
                            $alerBot = 'oui';
                        }
                              
                         //liste des autres joueurs possèdes par ce coach et present dans le roster
                        $objAccountListeJoueur = $em->getRepository('AppBundle:AccountJoueur')->findBy(
                            array(
                                'idRoster'=>$idRoster,
                            ));
                        $tabAutreJoueurMemeProprio = array();
                        foreach($objAccountListeJoueur as $unAccountListeJoueur)
                        {
                            $unJoueurDeLaListe = $em->getRepository('AppBundle:JoueurNtScout')->findOneByBbId($unAccountListeJoueur->getBbId());
                            
                            if($unJoueurDeLaListe)
                            {
                                if($unJoueurDeLaListe->getBbId() == $unJoueur->getBbId())
                                {
                                }
                                else
                                {
                                    if($unJoueurDeLaListe->getProprietaireBbId() == $idProprio)
                                    {
                                       $tabAutreJoueurMemeProprio[] = $unJoueurDeLaListe; 
                                    }
                                }
                            }
                        }
                    }
                    else
                    {
                        $unJoueur = null;
                        $tabAutreJoueurMemeProprio = null;
                    }
                }
                else
                {
                    $unJoueur = null;
                    $tabAutreJoueurMemeProprio = null;
                }
            }
            else
            {
                $unJoueur = null;
                $tabAutreJoueurMemeProprio = null;
            }
            
            $formCommentaireJoueur = $this->createForm(SaveCommentPlayerType::class,null,array(
                'action' => $this->generateUrl('playersave'),
                'method' => 'POST',
                'attr' => array(
                    )
                )
            );

            $messageAccountError = $session->get('messageAccountError');
            $session->remove('messageAccountError');

            $messageAccountSuccess = $session->get('messageAccountSuccess');
            $session->remove('messageAccountSuccess');
                    
            return $this->render('joueurntscout/playerIndex.html.twig', array(
                'joueur' => $unJoueur,
                'tabAutreJoueurMemeProprio' => $tabAutreJoueurMemeProprio,
                'objAccountJoueurCarac' => $objAccountJoueurCarac,
                'accountActif' => $accountVal,
                'infoUser' => $infoUser,
                'formCommentaireJoueur' => $formCommentaireJoueur->createView(),
                'unRoster' => $unRoster,
                'messageAccountError' => $messageAccountError,
                'messageAccountSuccess' => $messageAccountSuccess,
                'lectureSeule' => $lectureSeule,
                'alerBot'=>$alerBot,
              ));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/playersave", name="playersave")
     */
    public function playersave(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {
            $bbId = $request->request->get('save_comment_player')['bbId'];
            $commentaire = $request->request->get('save_comment_player')['commentaire'];
            $idRoster = $session->get('idRoster');
            $em->getRepository('AppBundle:AccountJoueurCarac')->updateCommentaire($user,$bbId,$commentaire,$idRoster);
            return $this->redirect($this->generateUrl('playerindex', array('bbId' => $bbId)));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
}
