<?php

namespace AppBundle\Controller;

use AppBundle\Entity\JoueurNtScout;
use AppBundle\Form\JoueurNtScoutSearchType;
use AppBundle\Form\ExportOptionType;
use AppBundle\Form\SaveAllCaracType;
use AppBundle\Form\SaveNameRosterType;
use AppBundle\Form\SaveCommentPlayerType;
use AppBundle\Repository\TranscoTailleRepository;
use AppBundle\Repository\TranscoPotentielRepository;
use AppBundle\Repository\TranscoPositionRepository;
use AppBundle\Repository\PaysRepository;
use AppBundle\Repository\NationnaliteRepository;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

use Symfony\Component\Security\Core\Authentication\Token\UsernamePasswordToken;
use Symfony\Component\Security\Core\Authentication\Token\Storage\TokenStorage;
/**
 * Roster controller.
 *
 * @Route("NTSO/roster")
 */
class RosterController extends Controller
{
    /**
     *
     * @Route("/rosterpreview", name="rosterpreview")
     */
    public function rosterpreviewAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        
        $user = $tokenStorage->getToken()->getUser();       
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            $idRoster = $request->query->get('idRoster');
            $unRosterShare = $em->getRepository('AppBundle:RosterShare')->findOneBy(
                array(
                    'idRoster'=>$idRoster,
                    'idAccountShare'=>$infoUser->getId(),
                ));

            if($unRosterShare)
            {
                $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
                array(
                    'id'=>$idRoster,
                    'idAccount'=>$unRosterShare->getIdAccountOwner(),
                ));
            
                if($unRoster)
                {
                    $session->remove('idRoster');
                    $session->set('idRoster',$idRoster);
                    $session->remove('lectureSeule');
                    $session->set('lectureSeule','on');
                    return $this->redirect($this->generateUrl('rosterindex'));
                }
                else
                {
                    $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
                    return $this->render($tabRetour['page'], $tabRetour['param']);
                }
            }
            else
            {
                $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
                return $this->render($tabRetour['page'], $tabRetour['param']);
            }
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        }

    }

    /**
     *
     * @Route("/rosterpreindex", name="rosterpreindex")
     */
    public function rosterpreindexAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        
        $user = $tokenStorage->getToken()->getUser();       
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);

        if($connexionOk == 'oui')
        {
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            $idRoster = $request->query->get('idRoster');
            $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
                array(
                    'id'=>$idRoster,
                    'idAccount'=>$infoUser->getId(),
                ));
            
            if($unRoster)
            {
                $session->remove('idRoster');
                $session->set('idRoster',$idRoster);
                $session->remove('lectureSeule');
                $session->set('lectureSeule','off');
                return $this->redirect($this->generateUrl('rosterindex'));
            }
            else
            {
                $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
                return $this->render($tabRetour['page'], $tabRetour['param']);
            }
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        }
    }
    
    /**
     *
     * @Route("/rosterindex", name="rosterindex")
     */
    public function rosterindexAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        
        $maintenace = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'maintenance',
            ));
        if($maintenace->getValParam() == 'on')
        {
            echo "Maintenance of 'NT Scout Online' in progress, thank you for your understanding";
            die();
        }
        
        $forSale = $em->getRepository('AppBundle:Configuration')->findOneBy(
          array(
              'idParam'=>'forSale',
          ));
        $forSaleVal = $forSale->getValParam();
        $forSaleByManager = $em->getRepository('AppBundle:Configuration')->findOneBy(
          array(
              'idParam'=>'forSaleByManager',
          ));
        $forSaleByManagerVal = $forSaleByManager->getValParam();
        $nationalTeam = $em->getRepository('AppBundle:Configuration')->findOneBy(
          array(
              'idParam'=>'nationalTeam',
          ));
        $nationalTeamVal = $nationalTeam->getValParam();
        $nbElemAfficheDefault = $em->getRepository('AppBundle:Configuration')->findOneBy(
          array(
              'idParam'=>'nbElemAfficheDefault',
          ));
        $nbElemAfficheDefaultVal = $nbElemAfficheDefault->getValParam();
        $account = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'account',
            ));
        $accountVal = $account->getValParam();
        
        $user = $tokenStorage->getToken()->getUser();       
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);

        if($connexionOk == 'oui')
        {
            $idRoster = $session->get('idRoster');
            $lectureSeule = $session->get('lectureSeule');
            
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            
            if($lectureSeule == 'off')
            {
                $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
                    array(
                        'id'=>$idRoster,
                        'idAccount'=>$infoUser->getId(),
                    ));
            }
            else
            {
                $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
                    array(
                        'id'=>$idRoster,
                    ));
            }
            if($unRoster)
            {
                if($infoUser)
                {
                    if($lectureSeule == 'off')
                    {
                        $tabAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findBy(
                            array(
                                'idRoster'=>$idRoster,
                                'idAccount'=>$infoUser->getId(),
                            ));
                    }
                    else
                    {
                        $tabAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findBy(
                            array(
                                'idRoster'=>$idRoster,
                            ));
                    }
                    $tabRosterGeneration = array();
                    if($tabAccountJoueur)
                    {
                        foreach($tabAccountJoueur as $unAccountJoueur)
                        {
                            $tabRosterGeneration[$unAccountJoueur->getBbId()] = 'on';
                        }
                    }
                    $dataSearch['nom'] = '';
                    $dataSearch['prenom'] = '';
                    $dataSearch['ownerBbId'] = '';
                    $dataSearch['pays'] = '';
                    $dataSearch['blessure'] = '';
                    $dataSearch['paysLancement'] = '';
                    $dataSearch['ageMin'] = '';
                    $dataSearch['ageMax'] = '';
                    $dataSearch['salaireMin'] = '';
                    $dataSearch['salaireMax'] = '';
                    $dataSearch['tailleMin'] = '';
                    $dataSearch['tailleMax'] = '';
                    $dataSearch['potentielMin'] = '';
                    $dataSearch['potentielMax'] = '';
                    $dataSearch['pays'] = '';
                    $dataSearch['nationalite'] = '';
                    $dataSearch['position'] = '';
                    $dataSearch['dmiMin'] = '';
                    $dataSearch['dmiMax'] = '';
                    $dataSearch['formeMin'] = '';
                    $dataSearch['formeMax'] = '';
                    $dataSearch['requeteCustom'] = '';
                    $dataSearch['equipeNationale'] = '';
                    $dataSearch['caracConnues'] = '';
                    $dataSearch['botBientot'] = '';
                    $dataSearch['aVendre'] = '';
                    $dataSearch['draftId'] = '';
                    $dataSearch['teamIdDraft'] = '';
                    $dataSearch['aVendreByManager'] = ''; 
                    $dataSearch['tabBbId'] = $tabRosterGeneration;

                    if(count($tabRosterGeneration) > 0)
                    {
                        $joueurs = $em->getRepository('AppBundle:JoueurNtScout')->findJoueursNtScout(
                                      $dataSearch,
                                      $forSaleVal,
                                      $forSaleByManagerVal,
                                      $nationalTeamVal,
                                      'off'
                                      );

                        $tabCaracJoueur = array();
                        $tabPositionJoueur = array();
                        $tabNomJoueur = array();
                        $tabNomJoueurPool = array();
                        $tabMinutesSemaine = array();
                        $tabListeProprio = array();
                        foreach($joueurs as $unJoueur)
                        {
                            if($lectureSeule == 'off')
                            {
                                $accountJoueurCarac = $em->getRepository('AppBundle:AccountJoueurCarac')->findOneBy(
                                    array(
                                        'idAccount' => $infoUser->getId(),
                                        'bbId' => $unJoueur['bbId'],
                                        'idRoster'=>$idRoster,
                                    )
                                );

                                $tabPositionJoueur = $em->getRepository('AppBundle:AccountJoueurPosition')->findBy(
                                    array(
                                        'idAccount' => $infoUser->getId(),
                                        'bbId' => $unJoueur['bbId'],
                                        'idRoster'=>$idRoster,
                                    )
                                );
                            }
                            else
                            {
                                $accountJoueurCarac = $em->getRepository('AppBundle:AccountJoueurCarac')->findOneBy(
                                    array(
                                        'bbId' => $unJoueur['bbId'],
                                        'idRoster'=>$idRoster,
                                    )
                                );

                                $tabPositionJoueur = $em->getRepository('AppBundle:AccountJoueurPosition')->findBy(
                                    array(
                                        'bbId' => $unJoueur['bbId'],
                                        'idRoster'=>$idRoster,
                                    )
                                );
                            }
                            
                            $tabCaracJoueur[$unJoueur['bbId']] = $accountJoueurCarac;

                            $totalMinuteSemaineEnCours = $em->getRepository('AppBundle:AccountJoueurMinutes')->calculMinuteSemaineEnCours($unJoueur['bbId']);
                            $tabMinutesSemaine[$unJoueur['bbId']] = $totalMinuteSemaineEnCours;
                            
                            if($tabPositionJoueur)
                            {
                                $nomJoueur = $em->getRepository('AppBundle:JoueurNtScout')->findOneByBbId($unJoueur['bbId']);
                                foreach($tabPositionJoueur as $unePositionJoueur)
                                {
                                    if($unePositionJoueur->getPosition() == 'pool')
                                    {
                                        $tabNomJoueurPool[] = $nomJoueur;
                                    }
                                    else
                                    {
                                        $tabNomJoueur[$unePositionJoueur->getPosition()] = $nomJoueur;
                                    }
                                }
                            }
                            
                            $tabListeProprio[] = $unJoueur['proprietaireNom'];
                        }
                        
                        $tabListeProprio = array_unique($tabListeProprio);
                        asort($tabListeProprio);
                    }
                    else
                    {
                        $joueurs = null;
                        $tabCaracJoueur = null;
                        $tabPositionJoueur = null;
                        $tabNomJoueur = null;
                        $tabNomJoueurPool = null;
                        $tabListeProprio = null;
                    }

                    $tabCouleurCarac = $em->getRepository('AppBundle:TranscoCarac')->findAll();

                    $messageAccountError = $session->get('messageAccountError');
                    $session->remove('messageAccountError');

                    $messageAccountSuccess = $session->get('messageAccountSuccess');
                    $session->remove('messageAccountSuccess');

                    $messageError = $session->get('messageError');
                    $session->remove('messageError');

                    $messageSuccess = $session->get('$messageSuccess');
                    $session->remove('messageSuccess');

                    $formSaveAll = $this->createForm(SaveAllCaracType::class,null,array(
                        'action' => $this->generateUrl('rostermajallcarac'),
                        'method' => 'POST',
                        'attr' => array(
                            )
                        )
                    );

                    $formSaveNameRoster = $this->createForm(SaveNameRosterType::class,null,array(
                        'action' => $this->generateUrl('rostermajnameroster'),
                        'method' => 'POST',
                        'attr' => array(
                            )
                        )
                    );

                    $formuleExt = '((js+jr+od+pa+(ha+dr+is+id)/2+(rb+sb)/4)/6.5) * gs';
                    $formuleAs = '((js+od+is+id+(jr+ha+dr+pa+rb+sb)/2)/7) * gs';
                    $formuleInt = '((is+id+rb+cb+(jr+od)/4+(jr+ha+dr+pa)/8)/5) * gs';
                    
                    $myRosters = $em->getRepository('AppBundle:Roster')->findBy(array('idAccount'=>$infoUser->getId()),array('nom'=>'ASC'));
                    
                    return $this->render('joueurntscout/rosterIndex.html.twig', array(
                        'joueurs' => $joueurs,
                        'tabCaracJoueur' => $tabCaracJoueur,
                        'nbElemAfficheDefaultVal' => $nbElemAfficheDefaultVal,
                        'messageAccountError' => $messageAccountError,
                        'messageAccountSuccess' => $messageAccountSuccess,
                        'accountActif' => $accountVal,
                        'infoUser' => $infoUser,
                        'tabCouleurCarac' => $tabCouleurCarac,
                        'formSaveAll' => $formSaveAll->createView(),
                        'formSaveNameRoster' => $formSaveNameRoster->createView(),
                        'messageError' => $messageError,
                        'messageSuccess' => $messageSuccess,
                        'tabNomJoueur' => $tabNomJoueur,
                        'tabNomJoueurPool' => $tabNomJoueurPool,
                        'unRoster' => $unRoster,
                        'myRosters' => $myRosters,
                        'formuleExt' => $formuleExt,
                        'formuleAs' => $formuleAs,
                        'formuleInt' => $formuleInt,
                        'lectureSeule' => $lectureSeule,
                        'tabMinutesSemaine' => $tabMinutesSemaine,
                        'tabListeProprio' => $tabListeProprio,
                      ));
                }   
            }
            else
            {
                echo "Not your roster ...";
                die();
            }
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($accountVal,$session);
            return $this->render($tabRetour['page'], $tabRetour['param']);
        }
    }
    
    /**
     *
     * @Route("/rostermajallcarac", name="rostermajallcarac")
     */
    public function rostermajallcarac(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {            
            $allBbId = $request->request->get('save_all_carac')['allBbId'];
            $allChaineCarac = $request->request->get('save_all_carac')['allCarac'];
            $idRoster = $session->get('idRoster');    
            $em->getRepository('AppBundle:AccountJoueurCarac')->updateAll($user,$allBbId,$allChaineCarac,$idRoster);
            return $this->redirect($this->generateUrl('rosterindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/rostermajcarac", name="rostermajcarac")
     */
    public function rostermajcarac(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {
            $bbId = $request->query->get('bbId');
            $chaineCarac = $request->query->get('chaineCarac');
            $idRoster = $session->get('idRoster');
            
            $em->getRepository('AppBundle:AccountJoueurCarac')->update($user,$bbId,$chaineCarac,$idRoster);
            return $this->redirect($this->generateUrl('rosterindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }

    /**
     *
     * @Route("/rostermajnameroster", name="rostermajnameroster")
     */
    public function rostermajnameroster(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {            
            $nomRoster = $request->request->get('save_name_roster')['nameRoster'];
            $idRoster = $session->get('idRoster');
            $em->getRepository('AppBundle:Roster')->updateRoster($user,$nomRoster,$idRoster,$session);
            return $this->redirect($this->generateUrl('rosterindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/rostertocsv", name="rostertocsv")
     */
    public function rostertocsvAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
              
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {
            $content = $em->getRepository('AppBundle:Roster')->exportRosterCsv($session,$user);

            return new Response($content, 200, array(
                  'Content-Type' => 'application/force-download',
                  'Content-Disposition' => 'attachment; filename="exportRoster.csv"'
              ));
        }
    }
    
    /**
     *
     * @Route("/rosterloadplayerntso", name="rosterloadplayerntso")
     */
    public function rosterloadplayerntsoAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {
            $bbId = $request->query->get('bbId');
            $em->getRepository('AppBundle:Account')->loadPlayerNtso($bbId,$user,$session);
            return $this->redirect($this->generateUrl('rosterindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/rosterremovefromselection", name="rosterremovefromselection")
     */
    public function rosterremovefromselectionAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {
            $idRoster = $session->get('idRoster');
            $bbId = $request->query->get('bbId');
            $em->getRepository('AppBundle:AccountJoueur')->remove($user,$bbId,$idRoster);
            return $this->redirect($this->generateUrl('rosterindex'));
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        } 
    }
    
    /**
     *
     * @Route("/resetselection", name="resetselection")
     */
    public function resetselectionAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
      
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            $idRoster = $session->get('idRoster');
            $em->getRepository('AppBundle:Roster')->resetSelection($user,$idRoster);
        }
        return $this->redirect($this->generateUrl('rosterindex'));
    }
    
    /**
     *
     * @Route("/removefromposition", name="removefromposition")
     */
    public function removefromposition(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
      
        $position = $request->query->get('position');
      
        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {
            $em->getRepository('AppBundle:Roster')->removeFromPosition($position,$session,$user);
        }
        return $this->redirect($this->generateUrl('rosterindex'));
    }

    /**
     *
     * @Route("/addpersotoroster", name="addpersotoroster")
     */
    public function addpersotorosterAction(Request $request)
    {
      $em = $this->getDoctrine()->getManager();
      $session = $request->getSession();
      
      $bbId = $request->query->get('bbId');
      $position = $request->query->get('position');
      
      $tokenStorage = $this->get('security.token_storage');
      $user = $tokenStorage->getToken()->getUser();  
      $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
      if($connexionOk == 'oui')
      {
            $idRoster = $session->get('idRoster');
            $em->getRepository('AppBundle:Roster')->addPersoToRoster($bbId,$position,$idRoster,$user);
      }
      
      return $this->redirect($this->generateUrl('rosterindex'));
    }
    
    /**
     *
     * @Route("/removefrompool", name="removefrompool")
     */
    public function removefrompool(Request $request)
    {
      $em = $this->getDoctrine()->getManager();
      $session = $request->getSession();
      
      $bbId = $request->query->get('bbId');
      $tokenStorage = $this->get('security.token_storage');
      $user = $tokenStorage->getToken()->getUser();  
      $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
      if($connexionOk == 'oui')
      {
            $idRoster = $session->get('idRoster');
            $em->getRepository('AppBundle:Roster')->removeFromPool($bbId,$user,$idRoster);
      }
      return $this->redirect($this->generateUrl('rosterindex'));
    }
    
    /**
     *
     * @Route("/addpersotopool", name="addpersotopool")
     */
    public function addpersotopoolAction(Request $request)
    {
      $em = $this->getDoctrine()->getManager();
      $session = $request->getSession();
      
      $bbId = $request->query->get('bbId');
      $tokenStorage = $this->get('security.token_storage');
      $user = $tokenStorage->getToken()->getUser();  
      $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
      if($connexionOk == 'oui')
      {
        $em->getRepository('AppBundle:Roster')->addPersoToPool($bbId,$session,$user);
      }
      
      return $this->redirect($this->generateUrl('rosterindex'));
    }
    
    /**
     *
     * @Route("/rostergeneration", name="rostergeneration")
     */
    public function rostergenerationAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        
        $bbId = $request->query->get('bbId');

        $tokenStorage = $this->get('security.token_storage');
        $user = $tokenStorage->getToken()->getUser();  
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        if($connexionOk == 'oui')
        {
            $idRoster = $session->get('idRoster');
            
            if($idRoster <> '')
            {
                $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
                $unAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findOneBy(
                       array(
                           'idRoster' => $idRoster,
                           'idAccount' => $infoUser->getId(),
                           'bbId' => $bbId,
                       )
                   );
                if($unAccountJoueur)
                {
                    $em->getRepository('AppBundle:AccountJoueur')->remove($user,$bbId,$idRoster);
                }
                else
                {
                    $em->getRepository('AppBundle:AccountJoueur')->create($infoUser->getId(),$bbId,$idRoster);
                }
            }
        }  
        
        return $this->redirect($this->generateUrl('joueurntscout_index'));
    }
    
    /**
     *
     * @Route("/copymovepersotoroster", name="copymovepersotoroster")
     */
    public function copymovepersotorosterAction(Request $request)
    {
      $em = $this->getDoctrine()->getManager();
      $session = $request->getSession();
      
      $bbId = $request->query->get('bbId');
      $rosterDestination = $request->query->get('rosterDestination');
      $type = $request->query->get('type');
      
      $tokenStorage = $this->get('security.token_storage');
      $user = $tokenStorage->getToken()->getUser();  
      $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
      if($connexionOk == 'oui')
      {
          $idRoster = $session->get('idRoster');
          $em->getRepository('AppBundle:Roster')->copyMovePersoToRoster($type,$user,$session,$bbId,$idRoster,$rosterDestination);
      }
      
      return $this->redirect($this->generateUrl('rosterindex'));
    }
}
