<?php

namespace AppBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Method;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\Route;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;

/**
 * Roster controller.
 *
 * @Route("NTSO/trainingsimulator")
 */
class TrainingSimulatorController extends Controller
{
    /**
     *
     * @Route("/trainingsimulatorpreindex", name="trainingsimulatorpreindex")
     */
    public function rosterpreindexAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        
        $user = $tokenStorage->getToken()->getUser();       
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);

        if($connexionOk == 'oui')
        {
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            $idTrainingSimulation = $request->query->get('idTrainingSimulation');
            $uneTrainingSimulation = $em->getRepository('AppBundle:TrainingSimulator')->findOneBy(
                array(
                    'id'=>$idTrainingSimulation,
                    'idAccount'=>$infoUser->getId(),
                ));
            
            if($uneTrainingSimulation)
            {
                $session->remove('idTrainingSimulation');
                $session->set('idTrainingSimulation',$idTrainingSimulation);
                $session->remove('lectureSeule');
                $session->set('lectureSeule','off');
                return $this->redirect($this->generateUrl('trainingsimulatorindex'));
            }
            else
            {
                $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
                return $this->render($tabRetour['page'], $tabRetour['param']);
            }
        }
        else
        {
            $tabRetour = $em->getRepository('AppBundle:Account')->erreurConnexion($session);            
            return $this->render($tabRetour['page'], $tabRetour['param']);
        }
    }
    
    /**
     *
     * @Route("/trainingsimulatorindex", name="trainingsimulatorindex")
     */
    public function trainingsimulatorindexAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
         
        $maintenace = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'maintenance',
            ));
        if($maintenace->getValParam() == 'on')
        {
            echo "Maintenance of 'NT Scout Online' in progress, thank you for your understanding";
            die();
        }
        
        $user = $tokenStorage->getToken()->getUser();  
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        
        $idTrainingSimulation = $session->get('idTrainingSimulation');
        if($idTrainingSimulation)
        {
            $unTrainingSimulator = $em->getRepository('AppBundle:TrainingSimulator')->find($idTrainingSimulation);
            $myClefNTSO = $unTrainingSimulator->getClefNtso();
        }
        else
        {
            $myClefNTSO = '';
        }
        $lectureSeule = $session->get('lectureSeule');
        
        $tabCoefAge = $this->container->getParameter('_TABLEAU_COEF_AGE');   
        $tabCoefTaille = $this->container->getParameter('_TABLEAU_COEF_TAILLE');
        $tabCoefEntraineur = $this->container->getParameter('_TABLEAU_COEF_ENTRAINEUR');   
        $tabCoefElasticEffect = $this->container->getParameter('_TABLEAU_ELASTIC_EFFECT');
        $tabValeurEntrainementTailleMini = $this->container->getParameter('_TABLEAU_VALEUR_ENTRAINEMENT_TAILLE_MINI');
        $tabValeurEntrainementTailleMaxi = $this->container->getParameter('_TABLEAU_VALEUR_ENTRAINEMENT_TAILLE_MAXI');
        $tabCoefCap = $this->container->getParameter('_TABLEAU_COEF_CAP');
        $tabCoefSalaire = $this->container->getParameter('_TABLEAU_COEF_SALAIRE');
        
        return $this->render('joueurntscout/trainingSimulatorIndex.html.twig', array(
            'tabCoefAge' => $tabCoefAge,
            'tabCoefTaille' => $tabCoefTaille,
            'tabCoefEntraineur' => $tabCoefEntraineur,  
            'tabCoefElasticEffect' => $tabCoefElasticEffect,
            'tabValeurEntrainementTailleMini' => $tabValeurEntrainementTailleMini,
            'tabValeurEntrainementTailleMaxi' => $tabValeurEntrainementTailleMaxi,
            'tabCoefCap' => $tabCoefCap,
            'tabCoefSalaire' => $tabCoefSalaire,
            'infoUser' => $infoUser,
            'idTrainingSimulation' => $idTrainingSimulation,
            'lectureSeule' => $lectureSeule,
            'myClefNTSO' => $myClefNTSO,
          ));
    }
    
    /**
     *
     * @Route("/trainingsimulatorcreate", name="trainingsimulatorcreate")
     */
    public function trainingsimulatorcreateAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $tokenStorage = $this->get('security.token_storage');
        $session = $request->getSession();
        
        $user = $tokenStorage->getToken()->getUser();       
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);

        if($connexionOk == 'oui')
        {
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            $idAccount = $infoUser->getId();
        }
        else
        {
            $idAccount = 0;
        }
        
        $nomChoisi = $request->get('nomChoisi');
        $lvlEntraineur = $request->get('lvlEntraineur');
        $dateDebutSimulation = $request->get('dateDebutSimulation');

        $unTrainingSimulator = $em->getRepository('AppBundle:TrainingSimulator')->create($idAccount,$nomChoisi,$lvlEntraineur,$dateDebutSimulation,$session);

        $tabJoueurs = $request->get('tabJoueurs');
        $em->getRepository('AppBundle:TrainingSimulatorPlayer')->addPlayers($tabJoueurs,$unTrainingSimulator);
 
        $tabTrainingSaison1 = $request->get('tabTrainingSaison1');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison1,$unTrainingSimulator);
        $tabTrainingSaison2 = $request->get('tabTrainingSaison2');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison2,$unTrainingSimulator);
        $tabTrainingSaison3 = $request->get('tabTrainingSaison3');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison3,$unTrainingSimulator);
        $tabTrainingSaison4 = $request->get('tabTrainingSaison4');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison4,$unTrainingSimulator);
        $tabTrainingSaison5 = $request->get('tabTrainingSaison5');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison5,$unTrainingSimulator);
        $tabTrainingSaison6 = $request->get('tabTrainingSaison6');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison6,$unTrainingSimulator);
        $tabTrainingSaison7 = $request->get('tabTrainingSaison7');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison7,$unTrainingSimulator);
        $tabTrainingSaison8 = $request->get('tabTrainingSaison8');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison8,$unTrainingSimulator);
        $tabTrainingSaison9 = $request->get('tabTrainingSaison9');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison9,$unTrainingSimulator);
        $tabTrainingSaison10 = $request->get('tabTrainingSaison10');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison10,$unTrainingSimulator);

        return $this->render('joueurntscout/trainingSimulatorTrainingNtsoClef.html.twig', array(
                'trainingNtsoClef' => $unTrainingSimulator->getClefNtso(),
              ));
    }
    
    /**
     *
     * @Route("/trainingsimulatorsave", name="trainingsimulatorsave")
     */
    public function trainingsimulatorsaveAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        
        $nomChoisi = $request->get('nomChoisi');
        $lvlEntraineur = $request->get('lvlEntraineur');
        $dateDebutSimulation = $request->get('dateDebutSimulation');
        $clefNtso = $request->get('clefNtso');
        $tabJoueurs = $request->get('tabJoueurs');

        $unTrainingSimulator = $em->getRepository('AppBundle:TrainingSimulator')->update($nomChoisi,$lvlEntraineur,$dateDebutSimulation,$clefNtso);
        $em->getRepository('AppBundle:TrainingSimulatorPlayer')->removePlayers($unTrainingSimulator);
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->removeTrainings($unTrainingSimulator);
        $em->getRepository('AppBundle:TrainingSimulatorPlayer')->addPlayers($tabJoueurs,$unTrainingSimulator);
        
        $tabTrainingSaison1 = $request->get('tabTrainingSaison1');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison1,$unTrainingSimulator);
        $tabTrainingSaison2 = $request->get('tabTrainingSaison2');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison2,$unTrainingSimulator);
        $tabTrainingSaison3 = $request->get('tabTrainingSaison3');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison3,$unTrainingSimulator);
        $tabTrainingSaison4 = $request->get('tabTrainingSaison4');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison4,$unTrainingSimulator);
        $tabTrainingSaison5 = $request->get('tabTrainingSaison5');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison5,$unTrainingSimulator);
        $tabTrainingSaison6 = $request->get('tabTrainingSaison6');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison6,$unTrainingSimulator);
        $tabTrainingSaison7 = $request->get('tabTrainingSaison7');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison7,$unTrainingSimulator);
        $tabTrainingSaison8 = $request->get('tabTrainingSaison8');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison8,$unTrainingSimulator);
        $tabTrainingSaison9 = $request->get('tabTrainingSaison9');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison9,$unTrainingSimulator);
        $tabTrainingSaison10 = $request->get('tabTrainingSaison10');
        $em->getRepository('AppBundle:TrainingSimulatorCalendar')->addTrainings($tabTrainingSaison10,$unTrainingSimulator);
    }
    
    /**
     *
     * @Route("/trainingsimulatorload", name="trainingsimulatorload")
     */
    public function trainingsimulatorloadAction(Request $request)
    {
        $em = $this->getDoctrine()->getManager();
        $session = $request->getSession();
        $tokenStorage = $this->get('security.token_storage');
        
        $clefNtso = $request->query->get('clefNtso');
        $user = $tokenStorage->getToken()->getUser();
        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        
        if($connexionOk == 'oui')
        {
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            $unTrainingSimulator = $em->getRepository('AppBundle:TrainingSimulator')->findOneBy(
            array(
                'idAccount'=>$infoUser->getId(),
                'clefNtso'=>$clefNtso,
            ));
        }
        else
        {
            $unTrainingSimulator = $em->getRepository('AppBundle:TrainingSimulator')->findOneBy(
            array(
                'idAccount'=>0,
                'clefNtso'=>$clefNtso,
            ));
        }
        
        if(is_object($unTrainingSimulator))
        {
            $tabTrainingSimulatorPlayer = $em->getRepository('AppBundle:TrainingSimulatorPlayer')->getPlayers($unTrainingSimulator);
            $tabTrainingSimulatorCalendar = $em->getRepository('AppBundle:TrainingSimulatorCalendar')->getTrainings($unTrainingSimulator);
            $json = json_encode(array(
                'nomSimulation' => $unTrainingSimulator->getNom(),
                'lvlEntraineur' => $unTrainingSimulator->getLvlEntraineur(),
                'dateDebutSimulation' => $unTrainingSimulator->getDateDebutSimulation(),
                'clefNtso' => $unTrainingSimulator->getClefNtso(),
                'tabJoueurs' => $tabTrainingSimulatorPlayer,
                'tabTrainings' => $tabTrainingSimulatorCalendar,
            ));
        }
        else
        {
            $json = json_encode(array(
                'nomSimulation' => 'ko',
                'lvlEntraineur' => 'ko',
                'dateDebutSimulation' => 'ko',
                'clefNtso' => 'ko',
                'tabPlayer' => 'ko',
                'tabTrainings' => 'ko',
            ));
        }
        
        $response = new Response();
        $response->headers->set('Content-Type', 'application/json');
        $response->setContent($json);
        return $response;
    }
}
