<?php
 
namespace AppBundle\Dql;
 
use Doctrine\ORM\Query\AST\Functions\FunctionNode;
use Doctrine\ORM\Query\Lexer;
use Doctrine\ORM\Query\Parser;
use Doctrine\ORM\Query\SqlWalker;
 
class Substr extends FunctionNode
{
    public $val1;
    public $val2;
    public $val3;
    
    public function parse(Parser $parser)
    {
      $parser->match(Lexer::T_IDENTIFIER);
      $parser->match(Lexer::T_OPEN_PARENTHESIS);
      $this->val1 = $parser->ArithmeticPrimary();
      $parser->match(Lexer::T_COMMA);
      $this->val2 = $parser->ArithmeticPrimary();
      $parser->match(Lexer::T_COMMA);
      $this->val3 = $parser->ArithmeticPrimary();
      $parser->match(Lexer::T_CLOSE_PARENTHESIS);
    }
 
    public function getSql(SqlWalker $sqlWalker)
    {
      return "SUBSTR(".$this->val1->dispatch($sqlWalker).",".$this->val2->dispatch($sqlWalker).",".$this->val3->dispatch($sqlWalker).")";
    }
}