<?php
 
namespace AppBundle\Dql;
 
use Doctrine\ORM\Query\AST\Functions\FunctionNode;
use Doctrine\ORM\Query\Lexer;
use Doctrine\ORM\Query\Parser;
use Doctrine\ORM\Query\SqlWalker;
 
class ToDate extends FunctionNode
{
    public $string;
    public $format;
 
    public function parse(Parser $parser)
    {
      $parser->match(Lexer::T_IDENTIFIER);
      $parser->match(Lexer::T_OPEN_PARENTHESIS);
      $this->string = $parser->ArithmeticPrimary();
      $parser->match(Lexer::T_COMMA);
      $this->format = $parser->ArithmeticPrimary();
      $parser->match(Lexer::T_CLOSE_PARENTHESIS);
    }
 
    public function getSql(SqlWalker $sqlWalker)
    {    	 
      return "STR_TO_DATE(".$this->string->dispatch($sqlWalker).",".$this->format->dispatch($sqlWalker).")";
    }
}