<?php

namespace AppBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Roster
 *
 * @ORM\Table(name="account")
 * @ORM\Entity(repositoryClass="AppBundle\Repository\AccountRepository")
 */
class Account
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;
    
    /**
     * @var string
     *
     * @ORM\Column(name="login", type="string", length=20, nullable=false)
     */
    private $login;
    
    /**
     * @var string
     *
     * @ORM\Column(name="password", type="string", length=20, nullable=false)
     */
    private $password;
    
    /**
     * @var datetime
     *
     * @ORM\Column(name="date_creation", type="datetime", nullable=false)
     */
    private $dateCreation;  
    
    /**
     * @var datetime
     *
     * @ORM\Column(name="date_derniere_connexion", type="datetime", nullable=false)
     */
    private $dateDerniereConnexion; 
    
    /**
     * @var string
     *
     * @ORM\Column(name="roster", type="string", length=3, nullable=true)
     */
    private $roster;
    
    /**
     * @var string
     *
     * @ORM\Column(name="roster_partage", type="string", length=3, nullable=true)
     */
    private $rosterPartage;
    
    /**
     * @var string
     *
     * @ORM\Column(name="simulation", type="string", length=3, nullable=true)
     */
    private $simulation;
    
    /**
     * @var string
     *
     * @ORM\Column(name="analyse", type="string", length=3, nullable=true)
     */
    private $analyse;
    
    public function getId() {
        return $this->id;
    }

    public function setId($id) {
        $this->id = $id;
    }

    public function getLogin() {
        return $this->login;
    }

    public function setLogin($login) {
        $this->login = $login;
    }

    public function getPassword() {
        return $this->password;
    }

    public function setPassword($password) {
        $this->password = $password;
    }

    public function getDateCreation() {
        return $this->dateCreation;
    }

    public function setDateCreation($dateCreation) {
        $this->dateCreation = $dateCreation;
    }

    public function getDateDerniereConnexion() {
        return $this->dateDerniereConnexion;
    }

    public function setDateDerniereConnexion($dateDerniereConnexion) {
        $this->dateDerniereConnexion = $dateDerniereConnexion;
    }

    public function __toString(){
    	return $this->login;
    }
    
    public function getRoster() {
        return $this->roster;
    }

    public function setRoster($roster) {
        $this->roster = $roster;
    }

    public function getRosterPartage() {
        return $this->rosterPartage;
    }

    public function setRosterPartage($rosterPartage) {
        $this->rosterPartage = $rosterPartage;
    }

    public function getSimulation() {
        return $this->simulation;
    }

    public function setSimulation($simulation) {
        $this->simulation = $simulation;
    }

    public function getAnalyse() {
        return $this->analyse;
    }

    public function setAnalyse($analyse) {
        $this->analyse = $analyse;
    }
}
