<?php

namespace AppBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Joueur
 *
 * @ORM\Table(name="joueur_nt_scout")
 * @ORM\Entity(repositoryClass="AppBundle\Repository\JoueurNtScoutRepository")
 * 
 */
class JoueurNtScout
{
    /**
     * @var integer
     *
     * @ORM\Column(name="bb_id", type="integer", nullable=false)
     */
    private $bbId;

    /**
     * @var integer
     *
     * @ORM\Column(name="proprietaire_bb_id", type="integer", nullable=false)
     */
    private $proprietaireBbId;

    /**
     * @var string
     *
     * @ORM\Column(name="proprietaire_nom", type="string", length=255, nullable=false)
     */
    private $proprietaireNom;

    /**
     * @var string
     *
     * @ORM\Column(name="nom", type="string", length=255, nullable=false)
     */
    private $nom;

    /**
     * @var string
     *
     * @ORM\Column(name="prenom", type="string", length=255, nullable=false)
     */
    private $prenom;

    /**
     * @var integer
     *
     * @ORM\Column(name="age", type="integer", nullable=false)
     */
    private $age;

    /**
     * @var integer
     *
     * @ORM\Column(name="taille", type="integer", nullable=false)
     */
    private $taille;

    /**
     * @var integer
     *
     * @ORM\Column(name="potentiel", type="integer", nullable=false)
     */
    private $potentiel;

    /**
     * @var integer
     *
     * @ORM\Column(name="salaire", type="integer", nullable=false)
     */
    private $salaire;

    /**
     * @var string
     *
     * @ORM\Column(name="meilleur_position", type="string", length=2, nullable=false)
     */
    private $meilleurPosition;

    /**
     * @var string
     *
     * @ORM\Column(name="nationalite", type="string", length=255, nullable=false)
     */
    private $nationalite;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="draft_id", type="integer", nullable=false)
     */
    private $draftId;

    /**
     * @var integer
     *
     * @ORM\Column(name="id_pays", type="integer", nullable=false)
     */
    private $idPays;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="dmi", type="integer", nullable=false)
     */
    private $dmi;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="forme", type="integer", nullable=false)
     */
    private $forme;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="blessure", type="integer", nullable=false)
     */
    private $blessure;
    
    /**
     * @var datetime
     *
     * @ORM\Column(name="derniere_connexion", type="datetime", nullable=false)
     */
    private $derniereConnexion;    
     
    /**
     * @var integer
     *
     * @ORM\Column(name="team_id_draft", type="integer", nullable=false)
     */
    private $teamIdDraft;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="equipe_nationale", type="integer", nullable=false)
     */
    private $equipeNationale;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="equipe_u21", type="integer", nullable=false)
     */
    private $equipeU21;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="JS", type="integer", nullable=false)
     */
    private $js;

    /**
     * @var integer
     *
     * @ORM\Column(name="PS", type="integer", nullable=false)
     */
    private $ps;

    /**
     * @var integer
     *
     * @ORM\Column(name="DE", type="integer", nullable=false)
     */
    private $de;

    /**
     * @var integer
     *
     * @ORM\Column(name="AGI", type="integer", nullable=false)
     */
    private $agi;

    /**
     * @var integer
     *
     * @ORM\Column(name="DRI", type="integer", nullable=false)
     */
    private $dri;

    /**
     * @var integer
     *
     * @ORM\Column(name="PA", type="integer", nullable=false)
     */
    private $pa;

    /**
     * @var integer
     *
     * @ORM\Column(name="SI", type="integer", nullable=false)
     */
    private $si;

    /**
     * @var integer
     *
     * @ORM\Column(name="DI", type="integer", nullable=false)
     */
    private $di;

    /**
     * @var integer
     *
     * @ORM\Column(name="REB", type="integer", nullable=false)
     */
    private $reb;

    /**
     * @var integer
     *
     * @ORM\Column(name="CO", type="integer", nullable=false)
     */
    private $co;

    /**
     * @var integer
     *
     * @ORM\Column(name="END", type="integer", nullable=false)
     */
    private $end;

    /**
     * @var integer
     *
     * @ORM\Column(name="LF", type="integer", nullable=false)
     */
    private $lf;

    /**
     * @var integer
     *
     * @ORM\Column(name="EXP", type="integer", nullable=false)
     */
    private $exp;

    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;

    /**
     * @var datetime
     *
     * @ORM\Column(name="derniere_maj", type="datetime", nullable=false)
     */
    private $derniereMaj;    

    /**
     * @var integer
     *
     * @ORM\Column(name="a_vendre", type="integer", nullable=false)
     */
    private $aVendre;
    
    /**
     * Set bbId
     *
     * @param integer $bbId
     *
     * @return Joueur
     */
    public function setBbId($bbId)
    {
        $this->bbId = $bbId;

        return $this;
    }

    /**
     * Get bbId
     *
     * @return integer
     */
    public function getBbId()
    {
        return $this->bbId;
    }

    /**
     * Set proprietaireBbId
     *
     * @param integer $proprietaireBbId
     *
     * @return Joueur
     */
    public function setProprietaireBbId($proprietaireBbId)
    {
        $this->proprietaireBbId = $proprietaireBbId;

        return $this;
    }

    /**
     * Get proprietaireBbId
     *
     * @return integer
     */
    public function getProprietaireBbId()
    {
        return $this->proprietaireBbId;
    }

    /**
     * Set proprietaireNom
     *
     * @param string $proprietaireNom
     *
     * @return Joueur
     */
    public function setProprietaireNom($proprietaireNom)
    {
        $this->proprietaireNom = $proprietaireNom;

        return $this;
    }

    /**
     * Get proprietaireNom
     *
     * @return string
     */
    public function getProprietaireNom()
    {
        return $this->proprietaireNom;
    }

    /**
     * Set nom
     *
     * @param string $nom
     *
     * @return Joueur
     */
    public function setNom($nom)
    {
        $this->nom = $nom;

        return $this;
    }

    /**
     * Get nom
     *
     * @return string
     */
    public function getNom()
    {
        return $this->nom;
    }

    /**
     * Set prenom
     *
     * @param string $prenom
     *
     * @return Joueur
     */
    public function setPrenom($prenom)
    {
        $this->prenom = $prenom;

        return $this;
    }

    /**
     * Get prenom
     *
     * @return string
     */
    public function getPrenom()
    {
        return $this->prenom;
    }

    /**
     * Set age
     *
     * @param integer $age
     *
     * @return Joueur
     */
    public function setAge($age)
    {
        $this->age = $age;

        return $this;
    }

    /**
     * Get age
     *
     * @return integer
     */
    public function getAge()
    {
        return $this->age;
    }

    /**
     * Set taille
     *
     * @param integer $taille
     *
     * @return Joueur
     */
    public function setTaille($taille)
    {
        $this->taille = $taille;

        return $this;
    }

    /**
     * Get taille
     *
     * @return integer
     */
    public function getTaille()
    {
        return $this->taille;
    }

    /**
     * Set potentiel
     *
     * @param integer $potentiel
     *
     * @return Joueur
     */
    public function setPotentiel($potentiel)
    {
        $this->potentiel = $potentiel;

        return $this;
    }

    /**
     * Get potentiel
     *
     * @return integer
     */
    public function getPotentiel()
    {
        return $this->potentiel;
    }

    /**
     * Set salaire
     *
     * @param integer $salaire
     *
     * @return Joueur
     */
    public function setSalaire($salaire)
    {
        $this->salaire = $salaire;

        return $this;
    }

    /**
     * Get salaire
     *
     * @return integer
     */
    public function getSalaire()
    {
        return $this->salaire;
    }

    /**
     * Set meilleurPosition
     *
     * @param string $meilleurPosition
     *
     * @return Joueur
     */
    public function setMeilleurPosition($meilleurPosition)
    {
        $this->meilleurPosition = $meilleurPosition;

        return $this;
    }

    /**
     * Get meilleurPosition
     *
     * @return string
     */
    public function getMeilleurPosition()
    {
        return $this->meilleurPosition;
    }

    /**
     * Set nationalite
     *
     * @param string $nationalite
     *
     * @return Joueur
     */
    public function setNationalite($nationalite)
    {
        $this->nationalite = $nationalite;

        return $this;
    }

    /**
     * Get nationalite
     *
     * @return string
     */
    public function getNationalite()
    {
        return $this->nationalite;
    }
    
    /**
     * Set draftId
     *
     * @param integer $draftId
     *
     * @return Joueur
     */
    public function setDraftId($draftId)
    {
        $this->draftId = $draftId;

        return $this;
    }

    /**
     * Get draftId
     *
     * @return integer
     */
    public function getDraftId()
    {
        return $this->draftId;
    }

    /**
     * Set js
     *
     * @param integer $js
     *
     * @return Joueur
     */
    public function setJs($js)
    {
        $this->js = $js;

        return $this;
    }

    /**
     * Get js
     *
     * @return integer
     */
    public function getJs()
    {
        return $this->js;
    }

    /**
     * Set ps
     *
     * @param integer $ps
     *
     * @return Joueur
     */
    public function setPs($ps)
    {
        $this->ps = $ps;

        return $this;
    }

    /**
     * Get ps
     *
     * @return integer
     */
    public function getPs()
    {
        return $this->ps;
    }

    /**
     * Set de
     *
     * @param integer $de
     *
     * @return Joueur
     */
    public function setDe($de)
    {
        $this->de = $de;

        return $this;
    }

    /**
     * Get de
     *
     * @return integer
     */
    public function getDe()
    {
        return $this->de;
    }

    /**
     * Set agi
     *
     * @param integer $agi
     *
     * @return Joueur
     */
    public function setAgi($agi)
    {
        $this->agi = $agi;

        return $this;
    }

    /**
     * Get agi
     *
     * @return integer
     */
    public function getAgi()
    {
        return $this->agi;
    }

    /**
     * Set dri
     *
     * @param integer $dri
     *
     * @return Joueur
     */
    public function setDri($dri)
    {
        $this->dri = $dri;

        return $this;
    }

    /**
     * Get dri
     *
     * @return integer
     */
    public function getDri()
    {
        return $this->dri;
    }

    /**
     * Set pa
     *
     * @param integer $pa
     *
     * @return Joueur
     */
    public function setPa($pa)
    {
        $this->pa = $pa;

        return $this;
    }

    /**
     * Get pa
     *
     * @return integer
     */
    public function getPa()
    {
        return $this->pa;
    }

    /**
     * Set si
     *
     * @param integer $si
     *
     * @return Joueur
     */
    public function setSi($si)
    {
        $this->si = $si;

        return $this;
    }

    /**
     * Get si
     *
     * @return integer
     */
    public function getSi()
    {
        return $this->si;
    }

    /**
     * Set di
     *
     * @param integer $di
     *
     * @return Joueur
     */
    public function setDi($di)
    {
        $this->di = $di;

        return $this;
    }

    /**
     * Get di
     *
     * @return integer
     */
    public function getDi()
    {
        return $this->di;
    }

    /**
     * Set reb
     *
     * @param integer $reb
     *
     * @return Joueur
     */
    public function setReb($reb)
    {
        $this->reb = $reb;

        return $this;
    }

    /**
     * Get reb
     *
     * @return integer
     */
    public function getReb()
    {
        return $this->reb;
    }

    /**
     * Set co
     *
     * @param integer $co
     *
     * @return Joueur
     */
    public function setCo($co)
    {
        $this->co = $co;

        return $this;
    }

    /**
     * Get co
     *
     * @return integer
     */
    public function getCo()
    {
        return $this->co;
    }

    /**
     * Set end
     *
     * @param integer $end
     *
     * @return Joueur
     */
    public function setEnd($end)
    {
        $this->end = $end;

        return $this;
    }

    /**
     * Get end
     *
     * @return integer
     */
    public function getEnd()
    {
        return $this->end;
    }

    /**
     * Set lf
     *
     * @param integer $lf
     *
     * @return Joueur
     */
    public function setLf($lf)
    {
        $this->lf = $lf;

        return $this;
    }

    /**
     * Get lf
     *
     * @return integer
     */
    public function getLf()
    {
        return $this->lf;
    }

    /**
     * Set exp
     *
     * @param integer $exp
     *
     * @return Joueur
     */
    public function setExp($exp)
    {
        $this->exp = $exp;

        return $this;
    }

    /**
     * Get exp
     *
     * @return integer
     */
    public function getExp()
    {
        return $this->exp;
    }

    /**
     * Get id
     *
     * @return integer
     */
    public function getId()
    {
        return $this->id;
    }
    
    /**
     * Set derniereMaj
     *
     * @param datetime $derniereMaj
     *
     * @return Joueur
     */
    public function setDerniereMaj($derniereMaj)
    {
        $this->derniereMaj = $derniereMaj;

        return $this;
    }

    /**
     * Get derniereMaj
     *
     * @return datetime
     */
    public function getDerniereMaj()
    {
        return $this->derniereMaj;
    }
    
    public function getIdPays() {
        return $this->idPays;
    }

    public function setIdPays($idPays) {
        $this->idPays = $idPays;
    }
    
    public function getDmi() {
        return $this->dmi;
    }

    public function setDmi($dmi) {
        $this->dmi = $dmi;
    }

    public function getForme() {
        return $this->forme;
    }

    public function setForme($forme) {
        $this->forme = $forme;
    }

    public function getBlessure() {
        return $this->blessure;
    }

    public function setBlessure($blessure) {
        $this->blessure = $blessure;
    }
    
    public function getEquipeNationale() {
        return $this->equipeNationale;
    }

    public function setEquipeNationale($equipeNationale) {
        $this->equipeNationale = $equipeNationale;
    }

    public function getEquipeU21() {
        return $this->equipeU21;
    }

    public function setEquipeU21($equipeU21) {
        $this->equipeU21 = $equipeU21;
    }
    
    public function getAVendre() {
        return $this->aVendre;
    }

    public function setAVendre($aVendre) {
        $this->aVendre = $aVendre;
    }
    
    public function getDerniereConnexion() {
        return $this->derniereConnexion;
    }

    public function setDerniereConnexion($derniereConnexion) {
        $this->derniereConnexion = $derniereConnexion;
    }
    
    public function getTeamIdDraft() {
        return $this->teamIdDraft;
    }

    public function setTeamIdDraft($teamIdDraft) {
        $this->teamIdDraft = $teamIdDraft;
    }
}
