<?php

namespace AppBundle\Entity;

use Doctrine\ORM\Mapping as ORM;

/**
 * Roster
 *
 * @ORM\Table(name="match_joueur")
 * @ORM\Entity(repositoryClass="AppBundle\Repository\MatchJoueurRepository")
 */
class MatchJoueur
{
    /**
     * @var integer
     *
     * @ORM\Column(name="id", type="integer")
     * @ORM\Id
     * @ORM\GeneratedValue(strategy="IDENTITY")
     */
    private $id;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="id_match", type="integer", nullable=false)
     */
    private $idMatch;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="id_team", type="integer", nullable=false)
     */
    private $idTeam;
    
    /**
     * @var string
     *
     * @ORM\Column(name="type_equipe", type="string", length=100, nullable=false)
     */
    private $typeEquipe;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="bb_id", type="integer", nullable=false)
     */
    private $bbId;
    
    /**
     * @var string
     *
     * @ORM\Column(name="name", type="string", length=100, nullable=false)
     */
    private $name;
    
    /**
     * @var integer
     *
     * @ORM\Column(name="forme", type="integer", nullable=true)
     */
    private $forme;
    
    /**
     * @var string
     *
     * @ORM\Column(name="position", type="string", length=100, nullable=true)
     */
    private $position;
    
    /**
     * @var string
     *
     * @ORM\Column(name="minutes", type="string", length=100, nullable=true)
     */
    private $minutes;
    
    /**
     * @var string
     *
     * @ORM\Column(name="fg", type="string", length=100, nullable=true)
     */
    private $fg;
    
    /**
     * @var string
     *
     * @ORM\Column(name="fg_total", type="string", length=100, nullable=true)
     */
    private $fgTotal;
    
    /**
     * @var string
     *
     * @ORM\Column(name="three_pts", type="string", length=100, nullable=true)
     */
    private $threePts;
    
    /**
     * @var string
     *
     * @ORM\Column(name="three_pts_total", type="string", length=100, nullable=true)
     */
    private $threePtsTotal;

    /**
     * @var string
     *
     * @ORM\Column(name="ft", type="string", length=100, nullable=true)
     */
    private $ft;
    
    /**
     * @var string
     *
     * @ORM\Column(name="ft_total", type="string", length=100, nullable=true)
     */
    private $ftTotal;

    /**
     * @var string
     *
     * @ORM\Column(name="plusminus", type="string", length=100, nullable=true)
     */
    private $plusMinus;
    
    /**
     * @var string
     *
     * @ORM\Column(name="offreb", type="string", length=100, nullable=true)
     */
    private $offReb;
    
    /**
     * @var string
     *
     * @ORM\Column(name="defreb", type="string", length=100, nullable=true)
     */
    private $defReb;
    
    /**
     * @var string
     *
     * @ORM\Column(name="totreb", type="string", length=100, nullable=true)
     */
    private $totReb;

    /**
     * @var string
     *
     * @ORM\Column(name="assists", type="string", length=100, nullable=true)
     */
    private $assists;

    /**
     * @var string
     *
     * @ORM\Column(name="turnover", type="string", length=100, nullable=true)
     */
    private $turnover;
    
    /**
     * @var string
     *
     * @ORM\Column(name="steals", type="string", length=100, nullable=true)
     */
    private $steals;
    
    /**
     * @var string
     *
     * @ORM\Column(name="blocks", type="string", length=100, nullable=true)
     */
    private $blocks;
    
    /**
     * @var string
     *
     * @ORM\Column(name="fouls", type="string", length=100, nullable=true)
     */
    private $fouls;
    
    /**
     * @var string
     *
     * @ORM\Column(name="points", type="string", length=100, nullable=true)
     */
    private $points;
    
    /**
     * @var string
     *
     * @ORM\Column(name="rating", type="string", length=100, nullable=true)
     */
    private $rating;

    public function getId() {
        return $this->id;
    }

    public function setId($id) {
        $this->id = $id;
    }

    public function getIdMatch() {
        return $this->idMatch;
    }

    public function setIdMatch($idMatch) {
        $this->idMatch = $idMatch;
    }

    public function getTypeEquipe() {
        return $this->typeEquipe;
    }

    public function setTypeEquipe($typeEquipe) {
        $this->typeEquipe = $typeEquipe;
    }

    public function getBbId() {
        return $this->bbId;
    }

    public function setBbId($bbId) {
        $this->bbId = $bbId;
    }
    
    public function getName() {
        return $this->name;
    }

    public function setName($name) {
        $this->name = $name;
    }

    public function getForme() {
        return $this->forme;
    }

    public function setForme($forme) {
        $this->forme = $forme;
    }
    
    public function getPosition() {
        return $this->position;
    }

    public function setPosition($position) {
        $this->position = $position;
    }

    public function getMinutes() {
        return $this->minutes;
    }

    public function setMinutes($minutes) {
        $this->minutes = $minutes;
    }

    public function getFg() {
        return $this->fg;
    }

    public function setFg($fg) {
        $this->fg = $fg;
    }

    public function getFgTotal() {
        return $this->fgTotal;
    }

    public function setFgTotal($fgTotal) {
        $this->fgTotal = $fgTotal;
    }

    public function getThreePts() {
        return $this->threePts;
    }

    public function setThreePts($threePts) {
        $this->threePts = $threePts;
    }

    public function getThreePtsTotal() {
        return $this->threePtsTotal;
    }

    public function setThreePtsTotal($threePtsTotal) {
        $this->threePtsTotal = $threePtsTotal;
    }

    public function getFt() {
        return $this->ft;
    }

    public function setFt($ft) {
        $this->ft = $ft;
    }

    public function getFtTotal() {
        return $this->ftTotal;
    }

    public function setFtTotal($ftTotal) {
        $this->ftTotal = $ftTotal;
    }

    public function getPlusMinus() {
        return $this->plusMinus;
    }

    public function setPlusMinus($plusMinus) {
        $this->plusMinus = $plusMinus;
    }

    public function getOffReb() {
        return $this->offReb;
    }

    public function setOffReb($offReb) {
        $this->offReb = $offReb;
    }

    public function getDefReb() {
        return $this->defReb;
    }

    public function setDefReb($defReb) {
        $this->defReb = $defReb;
    }

    public function getTotReb() {
        return $this->totReb;
    }

    public function setTotReb($totReb) {
        $this->totReb = $totReb;
    }

    public function getAssists() {
        return $this->assists;
    }

    public function setAssists($assists) {
        $this->assists = $assists;
    }

    public function getTurnover() {
        return $this->turnover;
    }

    public function setTurnover($turnover) {
        $this->turnover = $turnover;
    }

    public function getSteals() {
        return $this->steals;
    }

    public function setSteals($steals) {
        $this->steals = $steals;
    }

    public function getBlocks() {
        return $this->blocks;
    }

    public function setBlocks($blocks) {
        $this->blocks = $blocks;
    }

    public function getFouls() {
        return $this->fouls;
    }

    public function setFouls($fouls) {
        $this->fouls = $fouls;
    }

    public function getPoints() {
        return $this->points;
    }

    public function setPoints($points) {
        $this->points = $points;
    }

    public function getRating() {
        return $this->rating;
    }

    public function setRating($rating) {
        $this->rating = $rating;
    }
    
    public function getIdTeam() {
        return $this->idTeam;
    }

    public function setIdTeam($idTeam) {
        $this->idTeam = $idTeam;
    }
}
