<?php

namespace AppBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\IntegerType;
use Symfony\Component\Form\Extension\Core\Type\ChoiceType;
use Doctrine\ORM\EntityManager;
use AppBundle\Repository\ExportAffichageRepository;

class ExportOptionType extends AbstractType
{
    private $em;

    public function __construct(EntityManager $em)
    {
        $this->em = $em;
    }
    
    public function buildForm(FormBuilderInterface $builder, array $options)
    {   
        $forSale = $options['attr']['forSale'];
        $nationalTeam = $options['attr']['nationalTeam'];
        $showSkills = $options['attr']['showSkills'];
        $exportVal = $options['attr']['exportVal'];
        $nbJoueurs = $options['attr']['nbJoueurs'];

        if($nbJoueurs > 0)
        {
            if($exportVal == 'on')
            {
                if($nationalTeam == 'on')
                {
                    $arrayColonneExport = array(
                        'Full' => '1',
                        'NT Management' => '3',
                    );
                }
                else
                {
                    $arrayColonneExport = array(
                        'Full' => '2',
                        'NT Management' => '4',
                    );
                }
                
                $builder
                    ->add(
                            'enteteColonne',
                            ChoiceType::class,
                            array(
                                'choices' => array(
                                    'Yes' => '1',
                                    'No' => '0'
                                    ),
                                'mapped' => false,
                                )
                            )
                    ->add(
                            'critereRecherche',
                            ChoiceType::class,
                            array(
                                'choices' => array(
                                    'Yes' => '1',
                                    'No' => '0'
                                    ),
                                'mapped' => false,
                                )
                            )
                     ->add(
                            'colonneExport',
                            EntityType::class,
                            array(
                                'class'=>'AppBundle:ExportAffichage',
                                'choice_label'=>'titre',
                                'attr' => array ('onChange' => 'afficheAide(this.value)'),
                                'mapped' => false,
                                'query_builder' => function(ExportAffichageRepository $ea) use ($nationalTeam) {
                                    return $ea->getExportAffichage($nationalTeam);
                                    }
                                )
                            )   
                ;
            }
        }
    }
}