<?php

namespace AppBundle\Form;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;
use Symfony\Bridge\Doctrine\Form\Type\EntityType;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use AppBundle\Repository\DraftRepository;
use Doctrine\ORM\EntityManager;

class JoueurSearchType extends AbstractType
{
    private $em;

    public function __construct(EntityManager $em)
    {
        $this->em = $em;
    }
    
    public function buildForm(FormBuilderInterface $builder, array $options)
    {        
        $builder
            ->add(
                    'draftId',
                    EntityType::class,
                    array(
                        'class'=>'AppBundle:Draft',
                        'choice_label'=>'libelle',
                        'required' => false,
                        'query_builder' => function(DraftRepository $r) {
                            return $r->getDraftSortDesc();
                            }
                        )
                    )
            ->add(
                    'nom',
                    TextType::class,
                    array(
                        'required' => false
                        )
                    )
            ->add(
                    'prenom',
                    TextType::class,
                    array(
                        'required' => false
                        )
                    )    
            ->add(
                    'bbId',
                    TextType::class,
                    array(
                        'required' => false
                        )
                    )    
            ->add(
                    'Recherche',
                    SubmitType::class
                    )
        ;
    }
}