<?php

namespace AppBundle\Repository;

use Doctrine\ORM\EntityRepository;

class AccountJoueurCaracRepository extends EntityRepository
{
    public function calculScore($bbId,$accountJoueurCarac,$tabCarac)
    {
        $em = $this->getEntityManager();
        $unJoueur = $em->getRepository('AppBundle:JoueurNtScout')->findOneByBbId($bbId);
        $forme = $unJoueur->getForme();
        
        $js = $tabCarac[0];
        $ps = $tabCarac[1];
        $de = $tabCarac[2];
        $agi = $tabCarac[3];
        $dri = $tabCarac[4];
        $pa = $tabCarac[5];
        $si = $tabCarac[6];
        $di = $tabCarac[7];
        $reb = $tabCarac[8];
        $co = $tabCarac[9];
        $end = $tabCarac[10];
        $lf = $tabCarac[11];
        $exp = $tabCarac[12];
                    
        switch ($forme)
        {
            case 1:
                $formePonderateur = 0.4;
                break;
            case 2:
                $formePonderateur = 0.5;
                break;
            case 3:
                $formePonderateur = 0.6;
                break;
            case 4:
                $formePonderateur = 0.7;
                break;
            case 5:
                $formePonderateur = 0.8;
                break;
            case 6:
                $formePonderateur = 0.9;
                break;
            case 7:
                $formePonderateur = 1;
                break;
            case 8:
                $formePonderateur = 1.1;
                break;
            case 9:
                $formePonderateur = 1.2;
                break;
            case 10:
                $formePonderateur = 1.3;
                break;
            default:
                $formePonderateur = 1;
                break;
        }

        $scoreExt = (($js+$ps+$de+$pa+($agi+$dri+$si+$di)/2+($reb+$co)/4)/6.5) * $formePonderateur;
        $scoreAs = (($js+$de+$si+$di+($ps+$agi+$dri+$pa+$reb+$co)/2)/7) * $formePonderateur;
        $scoreInt = (($si+$di+$reb+$co+($js+$de)/4+($ps+$agi+$dri+$pa)/8)/5) * $formePonderateur;

        $accountJoueurCarac->setScoreExt(round($scoreExt,2));
        $accountJoueurCarac->setScoreAs(round($scoreAs,2));
        $accountJoueurCarac->setScoreInt(round($scoreInt,2));
        
        return $accountJoueurCarac;  
    }
    
    public function updateCommentaire($user,$bbId,$commentaire,$idRoster)
    {
        $em = $this->getEntityManager();
        if($bbId <> '')
        {
            $account = $em->getRepository('AppBundle:Account')->infoAccount($user);
            
            $unAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findOneBy(
                   array(
                       'idAccount' => $account->getId(),
                       'bbId' => $bbId,
                       'idRoster' => $idRoster,
                   )
               );

            if($unAccountJoueur)
            {
                $unAccountJoueurCarac = $em->getRepository('AppBundle:AccountJoueurCarac')->findOneBy(
                            array(
                                'idAccount' => $account->getId(),
                                'bbId' => $bbId,
                                'idRoster' => $idRoster,
                            )
                        );
                if($unAccountJoueurCarac)
                {
                    $unAccountJoueurCarac->setCommentaire($commentaire);
                    $em->persist($unAccountJoueurCarac);
                    $em->flush();
                }
            }
        }
    }
    
    public function update($user,$bbId,$chaineCarac,$idRoster)
    {
        $em = $this->getEntityManager();
        if($bbId <> '')
        {
            $account = $em->getRepository('AppBundle:Account')->infoAccount($user);
            
            $unAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findOneBy(
                   array(
                       'idAccount' => $account->getId(),
                       'bbId' => $bbId,
                       'idRoster' => $idRoster,
                   )
               );

            if($unAccountJoueur)
            {
                $unAccountJoueurCarac = $em->getRepository('AppBundle:AccountJoueurCarac')->findOneBy(
                            array(
                                'idAccount' => $account->getId(),
                                'bbId' => $bbId,
                                'idRoster' => $idRoster,
                            )
                        );
                if($unAccountJoueurCarac)
                {
                    $tabCarac = explode("_",$chaineCarac);
                    
                    $js = $tabCarac[0];
                    $ps = $tabCarac[1];
                    $de = $tabCarac[2];
                    $agi = $tabCarac[3];
                    $dri = $tabCarac[4];
                    $pa = $tabCarac[5];
                    $si = $tabCarac[6];
                    $di = $tabCarac[7];
                    $reb = $tabCarac[8];
                    $co = $tabCarac[9];
                    $end = $tabCarac[10];
                    $lf = $tabCarac[11];
                    $exp = $tabCarac[12];
                    $unAccountJoueurCarac->setJs($js);
                    $unAccountJoueurCarac->setPs($ps);
                    $unAccountJoueurCarac->setDe($de);
                    $unAccountJoueurCarac->setAgi($agi);
                    $unAccountJoueurCarac->setDri($dri);
                    $unAccountJoueurCarac->setPa($pa);
                    $unAccountJoueurCarac->setSi($si);
                    $unAccountJoueurCarac->setDi($di);
                    $unAccountJoueurCarac->setReb($reb);
                    $unAccountJoueurCarac->setCo($co);
                    $unAccountJoueurCarac->setEnd($end);
                    $unAccountJoueurCarac->setLf($lf);
                    $unAccountJoueurCarac->setExp($exp);

                    $unAccountJoueurCarac = $this->calculScore($bbId,$unAccountJoueurCarac,$tabCarac);
                    
                    $em->persist($unAccountJoueurCarac);
                    $em->flush();
                }
            }
        }
    }
    
    public function updateAll($user,$allBbId,$allChaineCarac,$idRoster)
    {
        $em = $this->getEntityManager();
        $tabAllBbId = explode('#',$allBbId);
        $tabAllBbId = array_filter($tabAllBbId);
        $tabAllChaineCarac = explode('#',$allChaineCarac);
        $tabAllChaineCarac = array_filter($tabAllChaineCarac);
            
        $i=0;
        foreach($tabAllBbId as $bbId)
        {
            $chaineCarac = $tabAllChaineCarac[$i];
            $this->update($user,$bbId,$chaineCarac,$idRoster);
            $i++;
        } 
    }
}