<?php

namespace AppBundle\Repository;

use Doctrine\ORM\EntityRepository;

class AccountJoueurMinutesRepository extends EntityRepository
{
    public function calculMinuteSemaineEnCours($bbId)
    {
        $em = $this->getEntityManager();
        
        $vendrediSemaineDerniere = date("Y-m-d",strtotime('friday last week'));
        $vendrediCetteSemaine = date("Y-m-d",strtotime('friday this week'));
            
        $parameters = array();
        //COALESCE ==> correspond à NVL
        $dql = 'SELECT COALESCE(SUM(ajm.minM + ajm.minAR + ajm.minAS + ajm.minAF + ajm.minP),0) as totalMinutes '; 
        $dql.= 'FROM ';
        $dql.= 'AppBundle:AccountJoueurMinutes ajm ';
        $dql.= 'WHERE ';
        $dql.= 'ajm.bbId = :bbId AND ';
        $dql.= 'ajm.dateMatch between :dateVendrediSemaineDerniere AND :dateVendrediCetteSemaine';
        
        $parameters['bbId'] = $bbId;
        $parameters['dateVendrediSemaineDerniere'] = $vendrediSemaineDerniere;
        $parameters['dateVendrediCetteSemaine'] = $vendrediCetteSemaine;
        
        $tabQueryTotalMinutes = $em->createQuery($dql)->setParameters($parameters)->getResult();
        $tabTotalMinutes = $tabQueryTotalMinutes[0];
        
        return $tabTotalMinutes['totalMinutes'];
    }
}