<?php

namespace AppBundle\Repository;

use AppBundle\Entity\AccountJoueur;
use AppBundle\Entity\AccountJoueurCarac;

use Doctrine\ORM\EntityRepository;

class AccountJoueurRepository extends EntityRepository
{
    public function create($idAccount,$bbId,$idRoster)
    {
        $em = $this->getEntityManager();
        if($bbId <> '')
        {
            $unAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findOneBy(
                   array(
                       'idAccount' => $idAccount,
                       'bbId' => $bbId,
                       'idRoster' => $idRoster,
                   )
               );
            
            if($unAccountJoueur)
            {
              //joueur deja present
            }
            else
            {
                $unAccountJoueur = new AccountJoueur();
                $unAccountJoueur->setIdAccount($idAccount);
                $unAccountJoueur->setIdRoster($idRoster);
                $unAccountJoueur->setBbId($bbId);
                $em->persist($unAccountJoueur);
                $em->flush();
                
                $unAccountJoueurCarac = $em->getRepository('AppBundle:AccountJoueurCarac')->findOneBy(
                   array(
                       'idAccount' => $idAccount,
                       'bbId' => $bbId,
                       'idRoster' => $idRoster,
                   )
                );
                if($unAccountJoueurCarac)
                {
                    //carac deja present
                }
                else
                {
                    $unAccountJoueurCarac = new AccountJoueurCarac();
                    $unAccountJoueurCarac->setIdAccount($idAccount);
                    $unAccountJoueurCarac->setIdRoster($idRoster);
                    $unAccountJoueurCarac->setBbId($bbId);
                    $unAccountJoueurCarac->setJs(1);
                    $unAccountJoueurCarac->setPs(1);
                    $unAccountJoueurCarac->setDe(1);
                    $unAccountJoueurCarac->setAgi(1);
                    $unAccountJoueurCarac->setDri(1);
                    $unAccountJoueurCarac->setPa(1);
                    $unAccountJoueurCarac->setSi(1);
                    $unAccountJoueurCarac->setDi(1);
                    $unAccountJoueurCarac->setReb(1);
                    $unAccountJoueurCarac->setCo(1);
                    $unAccountJoueurCarac->setEnd(1);
                    $unAccountJoueurCarac->setLf(1);
                    $unAccountJoueurCarac->setExp(1);

                    $tabCarac = array(1,1,1,1,1,1,1,1,1,1,1,1,1);
                    $unAccountJoueurCarac = $em->getRepository('AppBundle:AccountJoueurCarac')->calculScore($bbId,$unAccountJoueurCarac,$tabCarac);

                    $em->persist($unAccountJoueurCarac);
                    $em->flush();
                }
            }
        }
    }
    
    public function remove($user,$bbId,$idRoster)
    {
        $em = $this->getEntityManager();
        if($bbId <> '')
        {
            $account = $em->getRepository('AppBundle:Account')->infoAccount($user);
            
            $unAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findOneBy(
                   array(
                       'idAccount' => $account->getId(),
                       'bbId' => $bbId,
                       'idRoster' => $idRoster,
                   )
               );
            
            if($unAccountJoueur)
            {
                $unAccountJoueurCarac = $em->getRepository('AppBundle:AccountJoueurCarac')->findOneBy(
                   array(
                       'idAccount' => $account->getId(),
                       'bbId' => $bbId,
                       'idRoster' => $idRoster,
                   )
                );
                
                if($unAccountJoueurCarac)
                {
                    $em->remove($unAccountJoueurCarac);
                }

                $em->getRepository('AppBundle:Roster')->removeFromRoster($bbId,$user,$idRoster);
                $em->getRepository('AppBundle:Roster')->removeFromPool($bbId,$user,$idRoster);
                
                $em->remove($unAccountJoueur);
                $em->flush();
            }
        }
    }
}