<?php

namespace AppBundle\Repository;

use Doctrine\ORM\EntityRepository;

class ApiRepository extends EntityRepository
{
    public function getBoxScore($bbId)
    {
        $em = $this->getEntityManager();
        
        $unMatch = $em->getRepository('AppBundle:MatchNt')->findOneBy(
            array(
                'bbId'=>$bbId,
            ));
        
        if($unMatch)
        {
        }
        else
        {
            $ip = $_SERVER['REMOTE_ADDR'];
            if($ip == '127.0.0.1')
            {
                $unMatch = null;
            }
            else
            {
                $url = "http://odp.alwaysdata.net/apiGetBoxScore.php?idMatch=".$bbId;
                $fileGetContents = file_get_contents($url);
                $tabRetour = json_decode($fileGetContents);
                
                $tabData = array();
                $tabData['bbId'] = $tabRetour->idMatch;
                if($tabRetour->dateMatch == '')
                {
                    $unMatch = null;
                }
                else
                {
                    $tabData['dateMatch'] = $tabRetour->dateMatch;
                    $tabData['awayBbId'] = $tabRetour->teams->away->id;
                    $tabData['awayName'] = $tabRetour->teams->away->name;
                    $tabData['homeBbId'] = $tabRetour->teams->home->id;
                    $tabData['homeName'] = $tabRetour->teams->home->name;
                    $tabData['strategyAwayOffense'] = $tabRetour->strategies->away->offense;
                    $tabData['strategyAwayDefense'] = $tabRetour->strategies->away->defense;
                    $tabData['strategyHomeOffense'] = $tabRetour->strategies->home->offense;
                    $tabData['strategyHomeDefense'] = $tabRetour->strategies->home->defense;
                    $tabData['pamAwayFocus'] = $tabRetour->gameDayPrep->away->focus;
                    $tabData['pamAwayPace'] = $tabRetour->gameDayPrep->away->pace;
                    $tabData['pamHomeFocus'] = $tabRetour->gameDayPrep->home->focus;
                    $tabData['pamHomePace'] = $tabRetour->gameDayPrep->home->pace;
                    $tabData['noteAwayExtLvl'] = $tabRetour->gameNote->away->outsideScoring->level;
                    $tabData['noteAwayExtSubLvl'] = $tabRetour->gameNote->away->outsideScoring->subLevel;
                    $tabData['noteAwayIntLvl'] = $tabRetour->gameNote->away->insideScoring->level;
                    $tabData['noteAwayIntSubLvl'] = $tabRetour->gameNote->away->insideScoring->subLevel;
                    $tabData['noteAwayDeLvl'] = $tabRetour->gameNote->away->perimeterDefense->level;
                    $tabData['noteAwayDeSubLvl'] = $tabRetour->gameNote->away->perimeterDefense->subLevel;
                    $tabData['noteAwayDiLvl'] = $tabRetour->gameNote->away->insideDefense->level;
                    $tabData['noteAwayDiSubLvl'] = $tabRetour->gameNote->away->insideDefense->subLevel;
                    $tabData['noteAwayRebLvl'] = $tabRetour->gameNote->away->rebounding->level;
                    $tabData['noteAwayRebSubLvl'] = $tabRetour->gameNote->away->rebounding->subLevel;
                    $tabData['noteAwayAttLvl'] = $tabRetour->gameNote->away->offensiveFlow->level;
                    $tabData['noteAwayAttSubLvl'] = $tabRetour->gameNote->away->offensiveFlow->subLevel;
                    $tabData['noteHomeExtLvl'] = $tabRetour->gameNote->home->outsideScoring->level;
                    $tabData['noteHomeExtSubLvl'] = $tabRetour->gameNote->home->outsideScoring->subLevel;
                    $tabData['noteHomeIntLvl'] = $tabRetour->gameNote->home->insideScoring->level;
                    $tabData['noteHomeIntSubLvl'] = $tabRetour->gameNote->home->insideScoring->subLevel;
                    $tabData['noteHomeDeLvl'] = $tabRetour->gameNote->home->perimeterDefense->level;
                    $tabData['noteHomeDeSubLvl'] = $tabRetour->gameNote->home->perimeterDefense->subLevel;
                    $tabData['noteHomeDiLvl'] = $tabRetour->gameNote->home->insideDefense->level;
                    $tabData['noteHomeDiSubLvl'] = $tabRetour->gameNote->home->insideDefense->subLevel;
                    $tabData['noteHomeRebLvl'] = $tabRetour->gameNote->home->rebounding->level;
                    $tabData['noteHomeRebSubLvl'] = $tabRetour->gameNote->home->rebounding->subLevel;
                    $tabData['noteHomeAttLvl'] = $tabRetour->gameNote->home->offensiveFlow->level;
                    $tabData['noteHomeAttSubLvl'] = $tabRetour->gameNote->home->offensiveFlow->subLevel;
                    $tabData['pp100AwayPg'] = $tabRetour->pp100->away->pg;
                    $tabData['pp100AwaySg'] = $tabRetour->pp100->away->sg;
                    $tabData['pp100AwaySf'] = $tabRetour->pp100->away->sf;
                    $tabData['pp100AwayPf'] = $tabRetour->pp100->away->pf;
                    $tabData['pp100AwayC'] = $tabRetour->pp100->away->c;
                    $tabData['pp100HomePg'] = $tabRetour->pp100->home->pg;
                    $tabData['pp100HomeSg'] = $tabRetour->pp100->home->sg;
                    $tabData['pp100HomeSf'] = $tabRetour->pp100->home->sf;
                    $tabData['pp100HomePf'] = $tabRetour->pp100->home->pf;
                    $tabData['pp100HomeC'] = $tabRetour->pp100->home->c;
                    $tabData['effort'] = $tabRetour->effort;

                    $tabAwayScore = $tabRetour->scores->away;
                    $tabHomeScore = $tabRetour->scores->home;
                    $tabAwayJoueurs = $tabRetour->players->away;
                    $tabHomeJoueurs = $tabRetour->players->home;

                    $unMatch = $em->getRepository('AppBundle:MatchNt')->create($tabData,$tabAwayScore,$tabHomeScore,$tabAwayJoueurs,$tabHomeJoueurs);
                }
            }
        }
        return $unMatch;
    }
}