<?php

namespace AppBundle\Repository;

use AppBundle\Entity\Chat;
use AppBundle\Entity\ChatMessage;

use Doctrine\ORM\EntityRepository;

class ChatRepository extends EntityRepository
{
    public function send($user,$userParticipant,$message)
    {
        $em = $this->getEntityManager();

        if($userParticipant == 'tous')
        {
            $idAccount = 0;
            $idAccountParticipant = 0;
        }
        else
        {
            $account = $em->getRepository('AppBundle:Account')->infoAccount($user);
            $idAccount = $account->getId();
            $accountParticipant = $em->getRepository('AppBundle:Account')->infoAccount($userParticipant);
            $idAccountParticipant = $accountParticipant->getId();
        }
        
        $unChat = $em->getRepository('AppBundle:Chat')->findOneBy(
                array(
                    'idAccount'=>$idAccount,
                    'idAccountParticipant'=>$idAccountParticipant,
                ));
        if($unChat)
        {
            //chat déjà crée
        }
        else
        {
            $unChat = $em->getRepository('AppBundle:Chat')->findOneBy(
                array(
                    'idAccount'=>$idAccountParticipant,
                    'idAccountParticipant'=>$idAccount,
                ));
            if($unChat)
            {
                //chat déjà crée
            }
            else
            {
                $unChat = new Chat();
                $unChat->setIdAccount($idAccount);
                $unChat->setIdAccountParticipant($idAccountParticipant);
                $em->persist($unChat);
                $em->flush();
            }
        }
        
        if($user == 'anon.')
        {
            $idAccount = 0;
        }
        else
        {
            $account = $em->getRepository('AppBundle:Account')->infoAccount($user);
            $idAccount = $account->getId();
        }
        
        $unMessageChat = new ChatMessage();
        $unMessageChat->setIdChat($unChat->getId());
        $unMessageChat->setIdAccount($idAccount);
        $dateCreation = new \DateTime();
        $unMessageChat->setDateCreation($dateCreation);
        $unMessageChat->setMessage($message);
        $em->persist($unMessageChat);
        $em->flush();
    }
    
    public function lastsMessagesFromGlobal()
    {
        $em = $this->getEntityManager();
        
        $parameters = array();
        $dql = 'SELECT ';
        $dql.= 'a.login,';
        $dql.= 'cm.message,';
        $dql.= 'cm.dateCreation ';
        $dql.= 'FROM ';
        $dql.= 'AppBundle:Chat c ,';
        $dql.= 'AppBundle:ChatMessage cm, ';
        $dql.= 'AppBundle:Account a ';
        $dql.= 'WHERE ';
        $dql.= 'c.idAccount = 0 AND ';
        $dql.= 'c.idAccountParticipant = 0 AND ';
        $dql.= 'cm.idChat = c.id AND ';
        $dql.= 'cm.idAccount = a.id ';
        //$dql.= 'AND cm.dateCreation >= :dateLimite ';
        $dql.= 'ORDER BY cm.dateCreation DESC';
        //$dateLimite = new \DateTime();
        //$moinsDeuxJours = new \DateInterval( "P2D" );
        //$moinsDeuxJours->invert = 1;
        //$dateLimite->add($moinsDeuxJours);
        //$parameters['dateLimite'] = $dateLimite;
        $tabMessagerie = $em->createQuery($dql)->setParameters($parameters)->getResult();

	return $tabMessagerie;
    }
    
    public function lastsMessagesBetween($me,$otherCoach)
    {
        $em = $this->getEntityManager();
        $unChat = $em->getRepository('AppBundle:Chat')->findOneBy(
                array(
                    'idAccount'=>$me->getId(),
                    'idAccountParticipant'=>$otherCoach->getId(),
                ));
        if($unChat)
        {
            //on regarde si le chat existe dans l'autre sens
        }
        else
        {
            $unChat = $em->getRepository('AppBundle:Chat')->findOneBy(
                array(
                    'idAccount'=>$otherCoach->getId(),
                    'idAccountParticipant'=>$me->getId(),
                ));
        }
        $parameters = array();
        $dql = 'SELECT ';
        $dql.= 'a.login,';
        $dql.= 'cm.message,';
        $dql.= 'cm.dateCreation ';
        $dql.= 'FROM ';
        $dql.= 'AppBundle:Chat c ,';
        $dql.= 'AppBundle:ChatMessage cm, ';
        $dql.= 'AppBundle:Account a ';
        $dql.= 'WHERE ';
        $dql.= 'c.id = :idChat AND ';
        $dql.= 'cm.idChat = c.id AND ';
        $dql.= 'cm.idAccount = a.id ';
        //$dql.= 'AND cm.dateCreation >= :dateLimite ';
        $dql.= 'ORDER BY cm.dateCreation DESC';
        //$dateLimite = new \DateTime();
        //$moinsDeuxJours = new \DateInterval( "P2D" );
        //$moinsDeuxJours->invert = 1;
        //$dateLimite->add($moinsDeuxJours);
        if($unChat == null)
        {
            $parameters['idChat'] = -1;
        }
        else
        {
            $parameters['idChat'] = $unChat->getId();
        }
        //$parameters['dateLimite'] = $dateLimite;
        $tabMessagerie = $em->createQuery($dql)->setParameters($parameters)->getResult();

        return $tabMessagerie;
    }
}