<?php

namespace AppBundle\Repository;

use AppBundle\Entity\ChatUserOnline;

use Doctrine\ORM\EntityRepository;

class ChatUserOnlineRepository extends EntityRepository
{
    function userOnline()
    {
        $em = $this->getEntityManager();
        
        $tabUsersOnline = $em->getRepository('AppBundle:ChatUserOnline')->findBy(array(), array('nomUser' => 'ASC'));
        
        $cptUnknowAccount = 0;
        $tabRetour = array();
        $tabListeUser = array();
        foreach($tabUsersOnline as $unUserOnline)
        {
            if($unUserOnline->getNomUser() == 'Unknown account')
            {
                $cptUnknowAccount++;
            }
            else
            {
                $tabListeUser[] = $unUserOnline->getNomUser();
            }
        }

        $tabRetour['tabListeUser'] = $tabListeUser;
        $tabRetour['cptUnknowAccount'] = $cptUnknowAccount;
        
        return $tabRetour;
    }
        
    function add($infoUser,$ip)
    {
        $em = $this->getEntityManager();
        
        if(is_object($infoUser))
        {
            $nomUser = $infoUser->getLogin();
        }
        else
        {
            $nomUser = $infoUser;
        }
        
        $unChatUserDejaOnline = $em->getRepository('AppBundle:ChatUserOnline')->findOneBy(
                array(
                    'nomUser'=>$nomUser,
                    'adresseIp'=>$ip,
                ));
                
        if($unChatUserDejaOnline)
        {
            $this->refresh($infoUser,$ip);
        }
        else
        {
            $unChatUserOnline = new ChatUserOnline();
            $unChatUserOnline->setNomUser($nomUser);
            $unChatUserOnline->setAdresseIp($ip);
            $dateDerniereAction = new \DateTime();
            $unChatUserOnline->setDateDerniereAction($dateDerniereAction);
            $em->persist($unChatUserOnline);
            $em->flush();
        }
    }
    
    function remove($infoUser,$ip)
    {
        $em = $this->getEntityManager();
                
        if(is_object($infoUser))
        {
            $nomUser = $infoUser->getLogin();
        }
        else
        {
            $nomUser = $infoUser;
        }
        
        $unChatUserDejaOnline = $em->getRepository('AppBundle:ChatUserOnline')->findOneBy(
                array(
                    'nomUser'=>$nomUser,
                    'adresseIp'=>$ip,
                ));
        
        if($unChatUserDejaOnline)
        {
            $em->remove($unChatUserDejaOnline);
            $em->flush();
        }
    }
    
    function refresh($infoUser,$ip)
    {
        $em = $this->getEntityManager();
             
        if(is_object($infoUser))
        {
            $nomUser = $infoUser->getLogin();
        }
        else
        {
            $nomUser = $infoUser;
        }
        
        $unChatUserDejaOnline = $em->getRepository('AppBundle:ChatUserOnline')->findOneBy(
                array(
                    'nomUser'=>$nomUser,
                    'adresseIp'=>$ip,
                ));
        
        if($unChatUserDejaOnline)
        {
            $dateDerniereAction = new \DateTime();
            $unChatUserDejaOnline->setDateDerniereAction($dateDerniereAction);
            $em->persist($unChatUserDejaOnline);
            $em->flush();
        }
    }
}