<?php

namespace AppBundle\Repository;

use AppBundle\Entity\GameAnalysisMatchNt;
use Doctrine\ORM\EntityRepository;

class GameAnalysisMatchNtRepository extends EntityRepository
{
    public function addMatchToAnalysis($idMatchNt,$idAnalyse,$session)
    {
        $em = $this->getEntityManager();
        
        $unGameAnalysisMatchNt = $em->getRepository('AppBundle:GameAnalysisMatchNt')->findOneBy(
            array(
                'idMatchNt'=>$idMatchNt,
                'idAnalyse'=>$idAnalyse,
            ));
        
        if($unGameAnalysisMatchNt)
        {
            $session->set('messageError','Game already added');
        }
        else
        {
            $tabGameAnalysisMatchNt = $em->getRepository('AppBundle:GameAnalysisMatchNt')->findBy(
                array(
                    'idAnalyse'=>$idAnalyse,
                ));
            $ordre = count($tabGameAnalysisMatchNt) + 1;
            
            $unGameAnalysisMatchNt = new GameAnalysisMatchNt();
            $unGameAnalysisMatchNt->setIdMatchNt($idMatchNt);
            $unGameAnalysisMatchNt->setIdAnalyse($idAnalyse);
            $unGameAnalysisMatchNt->setOrdre($ordre);
            $em->persist($unGameAnalysisMatchNt);
            $em->flush();
            
            $session->set('messageSuccess','Game added');
        }
    }
    
    public function removeMatchFromAnalysis($idGameAnalysisMatchNt,$idAnalyse,$session)
    {
        $em = $this->getEntityManager();
        
        $unGameAnalysisMatchNt = $em->getRepository('AppBundle:GameAnalysisMatchNt')->findOneBy(
            array(
                'id'=>$idGameAnalysisMatchNt,
                'idAnalyse'=>$idAnalyse,
            ));
        
        if($unGameAnalysisMatchNt)
        {
            $ordreMatchRemove = $unGameAnalysisMatchNt->getOrdre();
            $em->remove($unGameAnalysisMatchNt);
            $em->flush();
            
            $tabGameAnalysisMatchNt = $em->getRepository('AppBundle:GameAnalysisMatchNt')->findBy(
                array(
                    'idAnalyse'=>$idAnalyse,
                ));
            
            foreach($tabGameAnalysisMatchNt as $unGameAnalysisMatchNt)
            {
                if($unGameAnalysisMatchNt->getOrdre() > $ordreMatchRemove)
                {
                    $nouveauOrdre = $unGameAnalysisMatchNt->getOrdre() - 1;
                    $unGameAnalysisMatchNt->setOrdre($nouveauOrdre);
                    $em->persist($unGameAnalysisMatchNt);
                    $em->flush();
                }
            }
            $session->set('messageSuccess','Game removed');
        }
        else
        {
            $session->set('messageError','Game not found');
        }
    }
        
    public function moveMatch($idGameAnalysisMatchNt,$idAnalyse,$sens)
    {
        $em = $this->getEntityManager();

        $unGameAnalysisMatchNt = $em->getRepository('AppBundle:GameAnalysisMatchNt')->findOneBy(
            array(
                'id'=>$idGameAnalysisMatchNt,
                'idAnalyse'=>$idAnalyse,
            ));
        
        if($unGameAnalysisMatchNt)
        {
            $ancienOrdre = $unGameAnalysisMatchNt->getOrdre();
            if($sens == 'up')
            {
                $nouveauOrdre = $ancienOrdre - 1;
            }
            else
            {
                $nouveauOrdre = $ancienOrdre + 1;
            }
            
            $unGameAnalysisMatchNtAPermuter = $em->getRepository('AppBundle:GameAnalysisMatchNt')->findOneBy(
                array(
                    'idAnalyse'=>$idAnalyse,
                    'ordre'=>$nouveauOrdre,
                ));
            
            $unGameAnalysisMatchNtAPermuter->setOrdre($ancienOrdre);
            $em->persist($unGameAnalysisMatchNtAPermuter);
            $em->flush();
            
            $unGameAnalysisMatchNt->setOrdre($nouveauOrdre);
            $em->persist($unGameAnalysisMatchNt);
            $em->flush();
        }
    }
    
    public function findDataMatchs($idAnalyse)
    {
        $em = $this->getEntityManager();
        
        $tabGame = $em->getRepository('AppBundle:GameAnalysisMatchNt')->findBy(
           array(
               'idAnalyse'=>$idAnalyse
           ),
           array('ordre' => 'asc')
          );
        
        $tabFullData = array();
        $tabNbShootPrisPosition = array();
        foreach($tabGame as $unGame)
        {
            $tab = array();
            $tab['gameAnalysisMatchNt'] = $unGame;
            
            $tabDataGame = $em->getRepository('AppBundle:MatchNt')->find($unGame->getIdMatchNt());
            $tab['matchNt'] = $tabDataGame;
            
            $tabScoreGame = $em->getRepository('AppBundle:MatchScore')->findBy(array(
                'idMatch'=>$unGame->getIdMatchNt()
            ));
            $tab['matchScore'] = $tabScoreGame;
            
            $scoreTotalAway = 0;
            $scoreTotalHome = 0;
            foreach($tabScoreGame as $unScoreGame)
            {
                $scoreTotalAway = $scoreTotalAway + $unScoreGame->getAwayScore();
                $scoreTotalHome = $scoreTotalHome + $unScoreGame->getHomeScore();
            }
            $tab['scoreTotalAway'] = $scoreTotalAway;
            $tab['scoreTotalHome'] = $scoreTotalHome;
            $tab['bbIdMatch'] = $tab['matchNt']->getBbId();
            $tab['idMatchNt'] = $tab['matchNt']->getId();
            $tab['dateMatch'] = $tab['matchNt']->getDateMatch();

            if($scoreTotalAway > $scoreTotalHome)
            {
                $gagnant = $tabDataGame->getAwayName();
                $scoreGagnant = $scoreTotalAway;
                $perdant = $tabDataGame->getHomeName();
                $scorePerdant = $scoreTotalHome;
            }
            else
            {
                $gagnant = $tabDataGame->getHomeName();
                $scoreGagnant = $scoreTotalHome;
                $perdant = $tabDataGame->getAwayName();
                $scorePerdant = $scoreTotalAway;
            }
            $tab['gagnant'] = $gagnant;
            $tab['scoreGagnant'] = $scoreGagnant;
            $tab['perdant'] = $perdant;
            $tab['scorePerdant'] = $scorePerdant;
            
            $tabJoueurGame = $em->getRepository('AppBundle:MatchJoueur')->findBy(array(
                'idMatch'=>$unGame->getIdMatchNt(),
            ));
            
            $tab['matchJoueur'] = $tabJoueurGame;
            
            $tabJoueurGameAway = $em->getRepository('AppBundle:MatchJoueur')->findBy(array(
                'idMatch'=>$unGame->getIdMatchNt(),
                'typeEquipe'=>'away',
            ));
            
            
            $tabNbShootPrisPosition['PG'] = 0;
            $tabNbShootPrisPosition['SG'] = 0;
            $tabNbShootPrisPosition['SF'] = 0;
            $tabNbShootPrisPosition['PF'] = 0;
            $tabNbShootPrisPosition['C'] = 0;
            $nbNbPointLf = 0;
                        
            foreach($tabJoueurGameAway as $unJoueur)
            {      
                if($unJoueur->getPosition() != '')
                {
                    $tabNbShootPrisPosition[$unJoueur->getPosition()] = $tabNbShootPrisPosition[$unJoueur->getPosition()] + $unJoueur->getFgTotal();
                    $nbNbPointLf = $nbNbPointLf + $unJoueur->getFt();
                }
            }
            $nbPointPg = round($tabNbShootPrisPosition['PG'] * $tabDataGame->getPp100AwayPg() / 100,2);
            $nbPointSg = round($tabNbShootPrisPosition['SG'] * $tabDataGame->getPp100AwaySg() / 100,2);
            $nbPointSf = round($tabNbShootPrisPosition['SF'] * $tabDataGame->getPp100AwaySf() / 100,2);
            $nbPointPf = round($tabNbShootPrisPosition['PF'] * $tabDataGame->getPp100AwayPf() / 100,2);
            $nbPointC = round($tabNbShootPrisPosition['C'] * $tabDataGame->getPp100AwayC() / 100,2);
            $scoreTheo = $nbPointPg + $nbPointSg + $nbPointSf + $nbPointPf + $nbPointC;
            $tab['scoreTheoAway'] = $scoreTheo;
            
            $pourcentageChatte = round(($scoreTotalAway - $nbNbPointLf) / $scoreTheo,2);
            $tab['pourcentageChatteAway'] = $pourcentageChatte;
            
            $tabJoueurGameHome = $em->getRepository('AppBundle:MatchJoueur')->findBy(array(
                'idMatch'=>$unGame->getIdMatchNt(),
                'typeEquipe'=>'home',
            ));
            
            $tabNbShootPrisPosition['PG'] = 0;
            $tabNbShootPrisPosition['SG'] = 0;
            $tabNbShootPrisPosition['SF'] = 0;
            $tabNbShootPrisPosition['PF'] = 0;
            $tabNbShootPrisPosition['C'] = 0;
            $nbNbPointLf = 0;
            foreach($tabJoueurGameAway as $unJoueur)
            {
                if($unJoueur->getPosition() != '')
                {
                    $tabNbShootPrisPosition[$unJoueur->getPosition()] = $tabNbShootPrisPosition[$unJoueur->getPosition()] + $unJoueur->getFgTotal();
                    $nbNbPointLf = $nbNbPointLf + $unJoueur->getFt();
                }
            }
            
            $nbPointPg = round($tabNbShootPrisPosition['PG'] * $tabDataGame->getPp100HomePg() / 100,2);
            $nbPointSg = round($tabNbShootPrisPosition['SG'] * $tabDataGame->getPp100HomeSg() / 100,2);
            $nbPointSf = round($tabNbShootPrisPosition['SF'] * $tabDataGame->getPp100HomeSf() / 100,2);
            $nbPointPf = round($tabNbShootPrisPosition['PF'] * $tabDataGame->getPp100HomePf() / 100,2);
            $nbPointC = round($tabNbShootPrisPosition['C'] * $tabDataGame->getPp100HomeC() / 100,2);
            $scoreTheo = $nbPointPg + $nbPointSg + $nbPointSf + $nbPointPf + $nbPointC;
            $tab['scoreTheoHome'] = $scoreTheo;
            
            $pourcentageChatte = round(($scoreTotalHome - $nbNbPointLf) / $scoreTheo,2);
            $tab['pourcentageChatteHome'] = $pourcentageChatte;
            $tabFullData[] = $tab;
        }
              
        $tabDataTeam = array();
        $tabDataIdMatchNt = array();
        $tabDataGagnant = array();
        $tabDataPerdant = array();
        $tabDataScoreGagnant = array();
        $tabDataScorePerdant = array();
        $tabDataOffStrategie = array();
        $tabDataAwayOffStrategie = array();
        $tabDataHomeOffStrategie = array();
        $tabDataDefStrategie = array();
        $tabDataPamFocus = array();
        $tabDataPamPace = array();
        $tabDataNoteExtLvl = array();
        $tabDataNoteIntLvl = array();
        $tabDataNoteDeLvl = array();
        $tabDataNoteDiLvl = array();
        $tabDataNoteRebLvl = array();
        $tabDataNoteAttLvl = array();
        $tabDataPp100Pg = array();
        $tabDataPp100Sg = array();
        $tabDataPp100Sf = array();
        $tabDataPp100Pf = array();
        $tabDataPp100C = array();

        foreach($tabFullData as $unGame)
        {        
            $tabDataBbIdTeam[] = $unGame['matchNt']->getAwayBbId();
            $tabDataBbIdTeam[] = $unGame['matchNt']->getHomeBbId();
            $tabDataTeam[] = $unGame['matchNt']->getAwayName();
            $tabDataTeam[] = $unGame['matchNt']->getHomeName();
            $tabDataIdMatchNt[] = $unGame['idMatchNt'];
            $tabDataIdMatchNt[] = $unGame['idMatchNt'];
            $tabDataGagnant[] = $unGame['gagnant'];
            $tabDataGagnant[] = $unGame['gagnant'];
            $tabDataPerdant[] = $unGame['perdant'];
            $tabDataPerdant[] = $unGame['perdant'];
            $tabDataScoreGagnant[] = $unGame['scoreGagnant'];
            $tabDataScoreGagnant[] = $unGame['scoreGagnant'];
            $tabDataScorePerdant[] = $unGame['scorePerdant'];
            $tabDataScorePerdant[] = $unGame['scorePerdant'];
            $tabDataOffStrategie[] = $unGame['matchNt']->getStrategyAwayOffense();
            $tabDataOffStrategie[] = $unGame['matchNt']->getStrategyHomeOffense();
            $tabDataAwayOffStrategie[] = $unGame['matchNt']->getStrategyHomeOffense();
            $tabDataHomeOffStrategie[] = $unGame['matchNt']->getStrategyHomeOffense();
            $tabDataDefStrategie[] = $unGame['matchNt']->getStrategyAwayDefense();
            $tabDataDefStrategie[] = $unGame['matchNt']->getStrategyHomeDefense();
            $tabDataPamFocus[] = $unGame['matchNt']->getPamAwayFocus();
            $tabDataPamFocus[] = $unGame['matchNt']->getPamHomeFocus();
            $tabDataPamPace[] = $unGame['matchNt']->getPamAwayPace();
            $tabDataPamPace[] = $unGame['matchNt']->getPamHomePace();
            $tabDataNoteExtLvl[] = $unGame['matchNt']->getNoteAwayExtLvl();
            $tabDataNoteExtLvl[] = $unGame['matchNt']->getNoteHomeExtLvl();
            $tabDataNoteIntLvl[] = $unGame['matchNt']->getNoteAwayIntLvl();
            $tabDataNoteIntLvl[] = $unGame['matchNt']->getNoteHomeIntLvl();
            $tabDataNoteDeLvl[] = $unGame['matchNt']->getNoteAwayDeLvl();
            $tabDataNoteDeLvl[] = $unGame['matchNt']->getNoteHomeDeLvl();
            $tabDataNoteDiLvl[] = $unGame['matchNt']->getNoteAwayDiLvl();
            $tabDataNoteDiLvl[] = $unGame['matchNt']->getNoteHomeDiLvl();
            $tabDataNoteRebLvl[] = $unGame['matchNt']->getNoteAwayRebLvl();
            $tabDataNoteRebLvl[] = $unGame['matchNt']->getNoteHomeRebLvl();
            $tabDataNoteAttLvl[] = $unGame['matchNt']->getNoteAwayAttLvl();    
            $tabDataNoteAttLvl[] = $unGame['matchNt']->getNoteHomeAttLvl(); 
            $tabDataPp100Pg[] = $unGame['matchNt']->getPp100AwayPg(); 
            $tabDataPp100Pg[] = $unGame['matchNt']->getPp100HomePg(); 
            $tabDataPp100Sg[] = $unGame['matchNt']->getPp100AwaySg(); 
            $tabDataPp100Sg[] = $unGame['matchNt']->getPp100HomeSg(); 
            $tabDataPp100Sf[] = $unGame['matchNt']->getPp100AwaySf(); 
            $tabDataPp100Sf[] = $unGame['matchNt']->getPp100HomeSf(); 
            $tabDataPp100Pf[] = $unGame['matchNt']->getPp100AwayPf(); 
            $tabDataPp100Pf[] = $unGame['matchNt']->getPp100HomePf(); 
            $tabDataPp100C[] = $unGame['matchNt']->getPp100AwayC(); 
            $tabDataPp100C[] = $unGame['matchNt']->getPp100HomeC(); 
        }

        $tabNomTeam = array_unique($tabDataTeam);

        $tabDataTeamFinal = array();
        foreach($tabNomTeam as $unNomTeam)
        { 
            $tabIndice = array_keys($tabDataTeam, $unNomTeam);
            $tabDataTeamTmpFinal = array();
            $tabDataBbIdTeamFinal = array();
            $tabDataGagnantFinal = array();
            $tabDataPerdantFinal = array();
            $tabDataScoreGagnantFinal = array();
            $tabDataScorePerdantFinal = array();
            $tabDataIdMatchNtFinal = array();
            $tabDataOffStrategieFinal = array();
            $tabDataDefStrategieFinal = array();
            $tabDataPamFocusFinal = array();
            $tabDataPamPaceFinal = array();
            $tabDataNoteExtLvlFinal = array();
            $tabDataNoteIntLvlFinal = array();
            $tabDataNoteDeLvlFinal = array();
            $tabDataNoteDiLvlFinal = array();
            $tabDataNoteRebLvlFinal = array();
            $tabDataNoteAttLvlFinal = array();
            $tabDataPp100PgFinal = array();
            $tabDataPp100SgFinal = array();
            $tabDataPp100SfFinal = array();
            $tabDataPp100PfFinal = array();
            $tabDataPp100CFinal = array();
            foreach($tabIndice as $unIndice)
            {
                $tabDataBbIdTeamFinal[] = $tabDataBbIdTeam[$unIndice];
                $tabDataGagnantFinal[] = $tabDataGagnant[$unIndice];
                $tabDataPerdantFinal[] = $tabDataPerdant[$unIndice];
                $tabDataScoreGagnantFinal[] = $tabDataScoreGagnant[$unIndice];
                $tabDataScorePerdantFinal[] = $tabDataScorePerdant[$unIndice];
                $tabDataIdMatchNtFinal[] = $tabDataIdMatchNt[$unIndice];
                $tabDataOffStrategieFinal[] = $tabDataOffStrategie[$unIndice];
                $tabDataDefStrategieFinal[] = $tabDataDefStrategie[$unIndice];
                $tabDataPamFocusFinal[] = $tabDataPamFocus[$unIndice];
                $tabDataPamPaceFinal[] = $tabDataPamPace[$unIndice];
                $tabDataNoteExtLvlFinal[] = $tabDataNoteExtLvl[$unIndice];
                $tabDataNoteIntLvlFinal[] = $tabDataNoteIntLvl[$unIndice];
                $tabDataNoteDeLvlFinal[] = $tabDataNoteDeLvl[$unIndice];
                $tabDataNoteDiLvlFinal[] = $tabDataNoteDiLvl[$unIndice];
                $tabDataNoteRebLvlFinal[] = $tabDataNoteRebLvl[$unIndice];
                $tabDataNoteAttLvlFinal[] = $tabDataNoteAttLvl[$unIndice];
                $tabDataPp100PgFinal[] = $tabDataPp100Pg[$unIndice];
                $tabDataPp100SgFinal[] = $tabDataPp100Sg[$unIndice];
                $tabDataPp100SfFinal[] = $tabDataPp100Sf[$unIndice];
                $tabDataPp100PfFinal[] = $tabDataPp100Pf[$unIndice];
                $tabDataPp100CFinal[] = $tabDataPp100C[$unIndice];
            }
            
            $tabDataTeamTmpFinal['nbMatch'] = count($tabDataOffStrategieFinal);
            $tabDataTeamTmpFinal['idMatchNt'] = $tabDataIdMatchNtFinal;  
            $tabDataTeamTmpFinal['idBbTeam'] = $tabDataBbIdTeamFinal; 
            $tabDataTeamTmpFinal['gagnant'] = $tabDataGagnantFinal;
            $tabDataTeamTmpFinal['scoreGagnant'] = $tabDataScoreGagnantFinal;
            $tabDataTeamTmpFinal['nbVictoire'] = count(array_keys($tabDataGagnantFinal, $unNomTeam));
            $tabDataTeamTmpFinal['perdant'] = $tabDataPerdantFinal;
            $tabDataTeamTmpFinal['scorePerdant'] = $tabDataScorePerdantFinal;
            $tabDataTeamTmpFinal['nbDefaite'] = count(array_keys($tabDataPerdantFinal, $unNomTeam));
            $tabDataTeamTmpFinal['offStrat'] = $tabDataOffStrategieFinal;
            $tabDataTeamTmpFinal['offStratCount'] = array_count_values($tabDataOffStrategieFinal);
            $tabDataTeamTmpFinal['defStrat'] = $tabDataDefStrategieFinal;
            $tabDataTeamTmpFinal['defStratCount'] = array_count_values($tabDataDefStrategieFinal);
            $tabDataTeamTmpFinal['pamFocus'] = $tabDataPamFocusFinal;
            $tabDataTeamTmpFinal['pamFocusCount'] = array_count_values($tabDataPamFocusFinal);
            $tabDataTeamTmpFinal['pamPace'] = $tabDataPamPaceFinal;
            $tabDataTeamTmpFinal['pamPaceCount'] = array_count_values($tabDataPamPaceFinal);
            $tabDataTeamTmpFinal['noteExt'] = $tabDataNoteExtLvlFinal;
            $tabDataTeamTmpFinal['noteExtAverage'] = round(array_sum($tabDataNoteExtLvlFinal) / count($tabDataNoteExtLvlFinal),2); 
            $tabDataTeamTmpFinal['noteInt'] = $tabDataNoteIntLvlFinal;
            $tabDataTeamTmpFinal['noteIntAverage'] = round(array_sum($tabDataNoteIntLvlFinal) / count($tabDataNoteIntLvlFinal),2);  
            $tabDataTeamTmpFinal['noteDe'] = $tabDataNoteDeLvlFinal;
            $tabDataTeamTmpFinal['noteDeAverage'] = round(array_sum($tabDataNoteDeLvlFinal) / count($tabDataNoteDeLvlFinal),2);  
            $tabDataTeamTmpFinal['noteDi'] = $tabDataNoteDiLvlFinal;
            $tabDataTeamTmpFinal['noteDiAverage'] = round(array_sum($tabDataNoteDiLvlFinal) / count($tabDataNoteDiLvlFinal),2);  
            $tabDataTeamTmpFinal['noteReb'] = $tabDataNoteRebLvlFinal;
            $tabDataTeamTmpFinal['noteRebAverage'] = round(array_sum($tabDataNoteRebLvlFinal) / count($tabDataNoteRebLvlFinal),2);  
            $tabDataTeamTmpFinal['noteAtt'] = $tabDataNoteAttLvlFinal;
            $tabDataTeamTmpFinal['noteAttAverage'] = round(array_sum($tabDataNoteAttLvlFinal) / count($tabDataNoteAttLvlFinal),2);  
            $tabDataTeamTmpFinal['pp100Pg'] = $tabDataPp100PgFinal;
            $tabDataTeamTmpFinal['pp100PgAverage'] = round(array_sum($tabDataPp100PgFinal) / count($tabDataPp100PgFinal),2);  
            $tabDataTeamTmpFinal['pp100Sg'] = $tabDataPp100SgFinal;
            $tabDataTeamTmpFinal['pp100SgAverage'] = round(array_sum($tabDataPp100SgFinal) / count($tabDataPp100SgFinal),2); 
            $tabDataTeamTmpFinal['pp100Sf'] = $tabDataPp100SfFinal;
            $tabDataTeamTmpFinal['pp100SfAverage'] = round(array_sum($tabDataPp100SfFinal) / count($tabDataPp100SfFinal),2);  
            $tabDataTeamTmpFinal['pp100Pf'] = $tabDataPp100PfFinal;
            $tabDataTeamTmpFinal['pp100PfAverage'] = round(array_sum($tabDataPp100PfFinal) / count($tabDataPp100PfFinal),2);  
            $tabDataTeamTmpFinal['pp100C'] = $tabDataPp100CFinal;
            $tabDataTeamTmpFinal['pp100CAverage'] = round(array_sum($tabDataPp100CFinal) / count($tabDataPp100CFinal),2); 
             
            $tabStrat = $tabDataOffStrategieFinal;
            $tabTmp = array();
            foreach($tabStrat as $uneStrat)
            { 
                $tabIndiceStrat = array_keys($tabDataOffStrategieFinal, $uneStrat);
                $tabDataStratTmpFinal = array();
                $tabDataStratGagnantFinal = array();
                $tabDataStratPerdantFinal = array();
                $tabDataStratScoreGagnantFinal = array();
                $tabDataStratScorePerdantFinal = array();
                $tabDataStratIdMatchNtFinal = array();
                $tabDataStratBbIdFinal = array();
                $tabDataStratVersusFinal = array();
                $tabDataStratResultatFinal = array();
                $tabDataStratOffStrategieFinal = array();
                $tabDataStratDefStrategieFinal = array();
                $tabDataStratPamFocusFinal = array();
                $tabDataStratPamPaceFinal = array();
                $tabDataStratNoteExtLvlFinal = array();
                $tabDataStratNoteIntLvlFinal = array();
                $tabDataStratNoteDeLvlFinal = array();
                $tabDataStratNoteDiLvlFinal = array();
                $tabDataStratNoteRebLvlFinal = array();
                $tabDataStratNoteAttLvlFinal = array();
                $tabDataStratNoteExtAdversaireLvlFinal = array();
                $tabDataStratNoteIntAdversaireLvlFinal = array();
                $tabDataStratNoteDeAdversaireLvlFinal = array();
                $tabDataStratNoteDiAdversaireLvlFinal = array();
                $tabDataStratNoteRebAdversaireLvlFinal = array();
                $tabDataStratNoteAttAdversaireLvlFinal = array();
                $tabDataStratPp100PgFinal = array();
                $tabDataStratPp100SgFinal = array();
                $tabDataStratPp100SfFinal = array();
                $tabDataStratPp100PfFinal = array();
                $tabDataStratPp100CFinal = array();
                foreach($tabIndiceStrat as $unIndiceStrat)
                {
                    $tabDataStratGagnantFinal[] = $tabDataGagnantFinal[$unIndiceStrat];
                    $tabDataStratPerdantFinal[] = $tabDataPerdantFinal[$unIndiceStrat];
                    $tabDataStratScoreGagnantFinal[] = $tabDataScoreGagnantFinal[$unIndiceStrat];
                    $tabDataStratScorePerdantFinal[] = $tabDataScorePerdantFinal[$unIndiceStrat];
                    $tabDataStratIdMatchNtFinal[] = $tabDataIdMatchNtFinal[$unIndiceStrat];
                }
                
                $tabDataStratTmpFinal['nbMatch'] = count(array_keys($tabDataStratGagnantFinal, $unNomTeam)) + count(array_keys($tabDataStratGagnantFinal, $unNomTeam));
                                       
                $tabDataStratTmpFinal['gagnant'] = $tabDataStratGagnantFinal;

                $tabDataStratTmpFinal['scoreGagnant'] = $tabDataStratScoreGagnantFinal;
                $tabDataStratTmpFinal['nbVictoire'] = count(array_keys($tabDataStratGagnantFinal, $unNomTeam));

                $tabDataStratTmpFinal['perdant'] = $tabDataStratPerdantFinal;
                $tabDataStratTmpFinal['scorePerdant'] = $tabDataStratScorePerdantFinal;
                $tabDataStratTmpFinal['nbDefaite'] = count(array_keys($tabDataStratPerdantFinal, $unNomTeam));
                  
                $i=0;
                foreach($tabDataStratIdMatchNtFinal as $unMatchNt)
                {
                    $dataMatchNt = $em->getRepository('AppBundle:MatchNt')->find($unMatchNt);
                    
                    if($tabDataStratGagnantFinal[$i] == $unNomTeam)
                    {
                        $tabDataStratResultatFinal[] = 'V';
                    }
                    else
                    {
                        $tabDataStratResultatFinal[] = 'D';
                    }
                    $i++;  
                    
                    if($unNomTeam == $dataMatchNt->getAwayName())
                    {
                        $infoAPrendre = 'away';
                    }
                    else
                    {
                        $infoAPrendre = 'home';
                    }
                    
                    $tabDataStratBbIdFinal[] = $dataMatchNt->getBbId();
                    if($infoAPrendre == 'home')
                    {
                        $tabDataStratVersusFinal[] = $dataMatchNt->getAwayName();
                        $tabDataStratOffStrategieFinal[] = $dataMatchNt->getStrategyHomeOffense();
                        $tabDataStratDefStrategieFinal[] = $dataMatchNt->getStrategyHomeDefense();
                        $tabDataStratPamFocusFinal[] = $dataMatchNt->getPamHomeFocus();
                        $tabDataStratPamPaceFinal[] = $dataMatchNt->getPamHomePace();
                        $tabDataStratNoteExtLvlFinal[] = $dataMatchNt->getNoteHomeExtLvl();
                        $tabDataStratNoteIntLvlFinal[] = $dataMatchNt->getNoteHomeIntLvl();
                        $tabDataStratNoteDeLvlFinal[] = $dataMatchNt->getNoteHomeDeLvl();
                        $tabDataStratNoteDiLvlFinal[] = $dataMatchNt->getNoteHomeDiLvl();
                        $tabDataStratNoteRebLvlFinal[] = $dataMatchNt->getNoteHomeRebLvl();
                        $tabDataStratNoteAttLvlFinal[] = $dataMatchNt->getNoteHomeAttLvl();
                        $tabDataStratPp100PgFinal[] = $dataMatchNt->getPp100HomePg();
                        $tabDataStratPp100SgFinal[] = $dataMatchNt->getPp100HomeSg();
                        $tabDataStratPp100SfFinal[] = $dataMatchNt->getPp100HomeSf();
                        $tabDataStratPp100PfFinal[] = $dataMatchNt->getPp100HomePf();
                        $tabDataStratPp100CFinal[] = $dataMatchNt->getPp100HomeC();
                        
                        $tabDataStratNoteExtAdversaireLvlFinal[] = $dataMatchNt->getNoteAwayExtLvl();
                        $tabDataStratNoteIntAdversaireLvlFinal[] = $dataMatchNt->getNoteAwayIntLvl();
                        $tabDataStratNoteDeAdversaireLvlFinal[] = $dataMatchNt->getNoteAwayDeLvl();
                        $tabDataStratNoteDiAdversaireLvlFinal[] = $dataMatchNt->getNoteAwayDiLvl();
                        $tabDataStratNoteRebAdversaireLvlFinal[] = $dataMatchNt->getNoteAwayRebLvl();
                        $tabDataStratNoteAttAdversaireLvlFinal[] = $dataMatchNt->getNoteAwayAttLvl();
                    }
                    else
                    {
                        $tabDataStratVersusFinal[] = $dataMatchNt->getHomeName();
                        $tabDataStratOffStrategieFinal[] = $dataMatchNt->getStrategyAwayOffense();
                        $tabDataStratDefStrategieFinal[] = $dataMatchNt->getStrategyAwayDefense();
                        $tabDataStratPamFocusFinal[] = $dataMatchNt->getPamAwayFocus();
                        $tabDataStratPamPaceFinal[] = $dataMatchNt->getPamAwayPace();
                        $tabDataStratNoteExtLvlFinal[] = $dataMatchNt->getNoteAwayExtLvl();
                        $tabDataStratNoteIntLvlFinal[] = $dataMatchNt->getNoteAwayIntLvl();
                        $tabDataStratNoteDeLvlFinal[] = $dataMatchNt->getNoteAwayDeLvl();
                        $tabDataStratNoteDiLvlFinal[] = $dataMatchNt->getNoteAwayDiLvl();
                        $tabDataStratNoteRebLvlFinal[] = $dataMatchNt->getNoteAwayRebLvl();
                        $tabDataStratNoteAttLvlFinal[] = $dataMatchNt->getNoteAwayAttLvl();
                        $tabDataStratPp100PgFinal[] = $dataMatchNt->getPp100AwayPg();
                        $tabDataStratPp100SgFinal[] = $dataMatchNt->getPp100AwaySg();
                        $tabDataStratPp100SfFinal[] = $dataMatchNt->getPp100AwaySf();
                        $tabDataStratPp100PfFinal[] = $dataMatchNt->getPp100AwayPf();
                        $tabDataStratPp100CFinal[] = $dataMatchNt->getPp100AwayC();
                        
                        $tabDataStratNoteExtAdversaireLvlFinal[] = $dataMatchNt->getNoteHomeExtLvl();
                        $tabDataStratNoteIntAdversaireLvlFinal[] = $dataMatchNt->getNoteHomeIntLvl();
                        $tabDataStratNoteDeAdversaireLvlFinal[] = $dataMatchNt->getNoteHomeDeLvl();
                        $tabDataStratNoteDiAdversaireLvlFinal[] = $dataMatchNt->getNoteHomeDiLvl();
                        $tabDataStratNoteRebAdversaireLvlFinal[] = $dataMatchNt->getNoteHomeRebLvl();
                        $tabDataStratNoteAttAdversaireLvlFinal[] = $dataMatchNt->getNoteHomeAttLvl();
                    }    
                }

                $tabDataStratTmpFinal['bbId'] = $tabDataStratBbIdFinal;
                $tabDataStratTmpFinal['versus'] = $tabDataStratVersusFinal;
                $tabDataStratTmpFinal['resultat'] = $tabDataStratResultatFinal;
                $tabDataStratTmpFinal['offStrat'] = $tabDataStratOffStrategieFinal;
                $tabDataStratTmpFinal['defStrat'] = $tabDataStratDefStrategieFinal;
                $tabDataStratTmpFinal['pamFocus'] = $tabDataStratPamFocusFinal;
                $tabDataStratTmpFinal['pamPace'] = $tabDataStratPamPaceFinal;
                $tabDataStratTmpFinal['noteExt'] = $tabDataStratNoteExtLvlFinal;
                $tabDataStratTmpFinal['noteExtAverage'] = round(array_sum($tabDataStratNoteExtLvlFinal) / count($tabDataStratNoteExtLvlFinal),2);
                $tabDataStratTmpFinal['noteInt'] = $tabDataStratNoteIntLvlFinal;
                $tabDataStratTmpFinal['noteIntAverage'] = round(array_sum($tabDataStratNoteIntLvlFinal) / count($tabDataStratNoteIntLvlFinal),2);
                $tabDataStratTmpFinal['noteDe'] = $tabDataStratNoteDeLvlFinal;
                $tabDataStratTmpFinal['noteDeAverage'] = round(array_sum($tabDataStratNoteDeLvlFinal) / count($tabDataStratNoteDeLvlFinal),2);
                $tabDataStratTmpFinal['noteDi'] = $tabDataStratNoteDiLvlFinal;
                $tabDataStratTmpFinal['noteDiAverage'] = round(array_sum($tabDataStratNoteDiLvlFinal) / count($tabDataStratNoteDiLvlFinal),2);
                $tabDataStratTmpFinal['noteReb'] = $tabDataStratNoteRebLvlFinal;
                $tabDataStratTmpFinal['noteRebAverage'] = round(array_sum($tabDataStratNoteRebLvlFinal) / count($tabDataStratNoteRebLvlFinal),2);
                $tabDataStratTmpFinal['noteAtt'] = $tabDataStratNoteAttLvlFinal;
                $tabDataStratTmpFinal['noteAttAverage'] = round(array_sum($tabDataStratNoteAttLvlFinal) / count($tabDataStratNoteAttLvlFinal),2);
                $tabDataStratTmpFinal['pp100Pg'] = $tabDataStratPp100PgFinal;
                $tabDataStratTmpFinal['pp100PgAverage'] = round(array_sum($tabDataStratPp100PgFinal) / count($tabDataStratPp100PgFinal),2);
                $tabDataStratTmpFinal['pp100Sg'] = $tabDataStratPp100SgFinal;
                $tabDataStratTmpFinal['pp100SgAverage'] = round(array_sum($tabDataStratPp100SgFinal) / count($tabDataStratPp100SgFinal),2);
                $tabDataStratTmpFinal['pp100Sf'] = $tabDataStratPp100SfFinal;
                $tabDataStratTmpFinal['pp100SfAverage'] = round(array_sum($tabDataStratPp100SfFinal) / count($tabDataStratPp100SfFinal),2);
                $tabDataStratTmpFinal['pp100Pf'] = $tabDataStratPp100PfFinal;
                $tabDataStratTmpFinal['pp100PfAverage'] = round(array_sum($tabDataStratPp100PfFinal) / count($tabDataStratPp100PfFinal),2);
                $tabDataStratTmpFinal['pp100C'] = $tabDataStratPp100CFinal;
                $tabDataStratTmpFinal['pp100CAverage'] = round(array_sum($tabDataStratPp100CFinal) / count($tabDataStratPp100CFinal),2);
                
                $tabDataStratTmpFinal['noteExtAdversaire'] = $tabDataStratNoteExtAdversaireLvlFinal;
                $tabDataStratTmpFinal['noteExtAdversaireAverage'] = round(array_sum($tabDataStratNoteExtAdversaireLvlFinal) / count($tabDataStratNoteExtAdversaireLvlFinal),2);
                $tabDataStratTmpFinal['noteIntAdversaire'] = $tabDataStratNoteIntAdversaireLvlFinal;
                $tabDataStratTmpFinal['noteIntAdversaireAverage'] = round(array_sum($tabDataStratNoteIntAdversaireLvlFinal) / count($tabDataStratNoteIntAdversaireLvlFinal),2);
                $tabDataStratTmpFinal['noteDeAdversaire'] = $tabDataStratNoteDeAdversaireLvlFinal;
                $tabDataStratTmpFinal['noteDeAdversaireAverage'] = round(array_sum($tabDataStratNoteDeAdversaireLvlFinal) / count($tabDataStratNoteDeAdversaireLvlFinal),2);
                $tabDataStratTmpFinal['noteDiAdversaire'] = $tabDataStratNoteDiAdversaireLvlFinal;
                $tabDataStratTmpFinal['noteDiAdversaireAverage'] = round(array_sum($tabDataStratNoteDiAdversaireLvlFinal) / count($tabDataStratNoteDiAdversaireLvlFinal),2);
                $tabDataStratTmpFinal['noteRebAdversaire'] = $tabDataStratNoteRebAdversaireLvlFinal;
                $tabDataStratTmpFinal['noteRebAdversaireAverage'] = round(array_sum($tabDataStratNoteRebAdversaireLvlFinal) / count($tabDataStratNoteRebAdversaireLvlFinal),2);
                $tabDataStratTmpFinal['noteAttAdversaire'] = $tabDataStratNoteAttAdversaireLvlFinal;
                $tabDataStratTmpFinal['noteAttAdversaireAverage'] = round(array_sum($tabDataStratNoteAttAdversaireLvlFinal) / count($tabDataStratNoteAttLvlFinal),2);
                
                $tabTmp[$uneStrat] = $tabDataStratTmpFinal;
                
            }
            $tabDataTeamTmpFinal['infoParStrategieOff'] = $tabTmp;
            
            $tabStrat = $tabDataDefStrategieFinal;
            $tabTmp = array();
            foreach($tabStrat as $uneStrat)
            { 
                $tabIndiceStrat = array_keys($tabDataDefStrategieFinal, $uneStrat);
                $tabDataStratTmpFinal = array();
                $tabDataStratGagnantFinal = array();
                $tabDataStratPerdantFinal = array();
                $tabDataStratIdMatchNtFinal = array();
                $tabDataStratBbIdFinal = array();
                $tabDataStratVersusFinal = array();
                $tabDataStratResultatFinal = array();
                $tabDataStratOffStrategieFinal = array();
                $tabDataStratDefStrategieFinal = array();
                $tabDataStratPamFocusFinal = array();
                $tabDataStratPamPaceFinal = array();
                $tabDataStratNoteExtLvlFinal = array();
                $tabDataStratNoteIntLvlFinal = array();
                $tabDataStratNoteDeLvlFinal = array();
                $tabDataStratNoteDiLvlFinal = array();
                $tabDataStratNoteRebLvlFinal = array();
                $tabDataStratNoteAttLvlFinal = array();
                $tabDataStratNoteExtAdversaireLvlFinal = array();
                $tabDataStratNoteIntAdversaireLvlFinal = array();
                $tabDataStratNoteDeAdversaireLvlFinal = array();
                $tabDataStratNoteDiAdversaireLvlFinal = array();
                $tabDataStratNoteRebAdversaireLvlFinal = array();
                $tabDataStratNoteAttAdversaireLvlFinal = array();
                $tabDataStratPp100PgFinal = array();
                $tabDataStratPp100SgFinal = array();
                $tabDataStratPp100SfFinal = array();
                $tabDataStratPp100PfFinal = array();
                $tabDataStratPp100CFinal = array();
                foreach($tabIndiceStrat as $unIndiceStrat)
                {
                    $tabDataStratGagnantFinal[] = $tabDataGagnantFinal[$unIndiceStrat];
                    $tabDataStratPerdantFinal[] = $tabDataPerdantFinal[$unIndiceStrat];
                    $tabDataStratIdMatchNtFinal[] = $tabDataIdMatchNtFinal[$unIndiceStrat];
                }
                
                $tabDataStratTmpFinal['nbMatch'] = count(array_keys($tabDataStratGagnantFinal, $unNomTeam)) + count(array_keys($tabDataStratGagnantFinal, $unNomTeam));
                                       
                $tabDataStratTmpFinal['gagnant'] = $tabDataStratGagnantFinal;
                $tabDataStratTmpFinal['nbVictoire'] = count(array_keys($tabDataStratGagnantFinal, $unNomTeam));

                $tabDataStratTmpFinal['perdant'] = $tabDataStratPerdantFinal;
                $tabDataStratTmpFinal['nbDefaite'] = count(array_keys($tabDataStratPerdantFinal, $unNomTeam));

                $i=0;
                foreach($tabDataStratIdMatchNtFinal as $unMatchNt)
                {
                    if($tabDataStratGagnantFinal[$i] == $unNomTeam)
                    {
                        $tabDataStratResultatFinal[] = 'V';
                    }
                    else
                    {
                        $tabDataStratResultatFinal[] = 'D';
                    }
                    $i++; 
                    
                    $dataMatchNt = $em->getRepository('AppBundle:MatchNt')->find($unMatchNt);
                    if($unNomTeam == $dataMatchNt->getAwayName())
                    {
                        $infoAPrendre = 'home';
                    }
                    else
                    {
                        $infoAPrendre = 'away';
                    }
                    
                    $tabDataStratBbIdFinal[] = $dataMatchNt->getBbId();
                    if($infoAPrendre == 'home')
                    {
                        $tabDataStratVersusFinal[] = $dataMatchNt->getHomeName();
                        $tabDataStratOffStrategieFinal[] = $dataMatchNt->getStrategyHomeOffense();
                        $tabDataStratDefStrategieFinal[] = $dataMatchNt->getStrategyHomeDefense();
                        $tabDataStratPamFocusFinal[] = $dataMatchNt->getPamHomeFocus();
                        $tabDataStratPamPaceFinal[] = $dataMatchNt->getPamHomePace();
                        $tabDataStratNoteExtLvlFinal[] = $dataMatchNt->getNoteHomeExtLvl();
                        $tabDataStratNoteIntLvlFinal[] = $dataMatchNt->getNoteHomeIntLvl();
                        $tabDataStratNoteDeLvlFinal[] = $dataMatchNt->getNoteHomeDeLvl();
                        $tabDataStratNoteDiLvlFinal[] = $dataMatchNt->getNoteHomeDiLvl();
                        $tabDataStratNoteRebLvlFinal[] = $dataMatchNt->getNoteHomeRebLvl();
                        $tabDataStratNoteAttLvlFinal[] = $dataMatchNt->getNoteHomeAttLvl();
                        $tabDataStratPp100PgFinal[] = $dataMatchNt->getPp100HomePg();
                        $tabDataStratPp100SgFinal[] = $dataMatchNt->getPp100HomeSg();
                        $tabDataStratPp100SfFinal[] = $dataMatchNt->getPp100HomeSf();
                        $tabDataStratPp100PfFinal[] = $dataMatchNt->getPp100HomePf();
                        $tabDataStratPp100CFinal[] = $dataMatchNt->getPp100HomeC();
                        
                        $tabDataStratNoteExtAdversaireLvlFinal[] = $dataMatchNt->getNoteAwayExtLvl();
                        $tabDataStratNoteIntAdversaireLvlFinal[] = $dataMatchNt->getNoteAwayIntLvl();
                        $tabDataStratNoteDeAdversaireLvlFinal[] = $dataMatchNt->getNoteAwayDeLvl();
                        $tabDataStratNoteDiAdversaireLvlFinal[] = $dataMatchNt->getNoteAwayDiLvl();
                        $tabDataStratNoteRebAdversaireLvlFinal[] = $dataMatchNt->getNoteAwayRebLvl();
                        $tabDataStratNoteAttAdversaireLvlFinal[] = $dataMatchNt->getNoteAwayAttLvl();
                    }
                    else
                    {
                        $tabDataStratVersusFinal[] = $dataMatchNt->getAwayName();
                        $tabDataStratOffStrategieFinal[] = $dataMatchNt->getStrategyAwayOffense();
                        $tabDataStratDefStrategieFinal[] = $dataMatchNt->getStrategyAwayDefense();
                        $tabDataStratPamFocusFinal[] = $dataMatchNt->getPamAwayFocus();
                        $tabDataStratPamPaceFinal[] = $dataMatchNt->getPamAwayPace();
                        $tabDataStratNoteExtLvlFinal[] = $dataMatchNt->getNoteAwayExtLvl();
                        $tabDataStratNoteIntLvlFinal[] = $dataMatchNt->getNoteAwayIntLvl();
                        $tabDataStratNoteDeLvlFinal[] = $dataMatchNt->getNoteAwayDeLvl();
                        $tabDataStratNoteDiLvlFinal[] = $dataMatchNt->getNoteAwayDiLvl();
                        $tabDataStratNoteRebLvlFinal[] = $dataMatchNt->getNoteAwayRebLvl();
                        $tabDataStratNoteAttLvlFinal[] = $dataMatchNt->getNoteAwayAttLvl();
                        $tabDataStratPp100PgFinal[] = $dataMatchNt->getPp100AwayPg();
                        $tabDataStratPp100SgFinal[] = $dataMatchNt->getPp100AwaySg();
                        $tabDataStratPp100SfFinal[] = $dataMatchNt->getPp100AwaySf();
                        $tabDataStratPp100PfFinal[] = $dataMatchNt->getPp100AwayPf();
                        $tabDataStratPp100CFinal[] = $dataMatchNt->getPp100AwayC();
                        
                        $tabDataStratNoteExtAdversaireLvlFinal[] = $dataMatchNt->getNoteHomeExtLvl();
                        $tabDataStratNoteIntAdversaireLvlFinal[] = $dataMatchNt->getNoteHomeIntLvl();
                        $tabDataStratNoteDeAdversaireLvlFinal[] = $dataMatchNt->getNoteHomeDeLvl();
                        $tabDataStratNoteDiAdversaireLvlFinal[] = $dataMatchNt->getNoteHomeDiLvl();
                        $tabDataStratNoteRebAdversaireLvlFinal[] = $dataMatchNt->getNoteHomeRebLvl();
                        $tabDataStratNoteAttAdversaireLvlFinal[] = $dataMatchNt->getNoteHomeAttLvl();
                    }    
                    
                }

                $tabDataStratTmpFinal['bbId'] = $tabDataStratBbIdFinal;
                $tabDataStratTmpFinal['versus'] = $tabDataStratVersusFinal;
                $tabDataStratTmpFinal['resultat'] = $tabDataStratResultatFinal;
                $tabDataStratTmpFinal['offStrat'] = $tabDataStratOffStrategieFinal;
                $tabDataStratTmpFinal['defStrat'] = $tabDataStratDefStrategieFinal;
                $tabDataStratTmpFinal['pamFocus'] = $tabDataStratPamFocusFinal;
                $tabDataStratTmpFinal['pamPace'] = $tabDataStratPamPaceFinal;
                $tabDataStratTmpFinal['noteExt'] = $tabDataStratNoteExtLvlFinal;
                $tabDataStratTmpFinal['noteExtAverage'] = round(array_sum($tabDataStratNoteExtLvlFinal) / count($tabDataStratNoteExtLvlFinal),2);
                $tabDataStratTmpFinal['noteInt'] = $tabDataStratNoteIntLvlFinal;
                $tabDataStratTmpFinal['noteIntAverage'] = round(array_sum($tabDataStratNoteIntLvlFinal) / count($tabDataStratNoteIntLvlFinal),2);
                $tabDataStratTmpFinal['noteDe'] = $tabDataStratNoteDeLvlFinal;
                $tabDataStratTmpFinal['noteDeAverage'] = round(array_sum($tabDataStratNoteDeLvlFinal) / count($tabDataStratNoteDeLvlFinal),2);
                $tabDataStratTmpFinal['noteDi'] = $tabDataStratNoteDiLvlFinal;
                $tabDataStratTmpFinal['noteDiAverage'] = round(array_sum($tabDataStratNoteDiLvlFinal) / count($tabDataStratNoteDiLvlFinal),2);
                $tabDataStratTmpFinal['noteReb'] = $tabDataStratNoteRebLvlFinal;
                $tabDataStratTmpFinal['noteRebAverage'] = round(array_sum($tabDataStratNoteRebLvlFinal) / count($tabDataStratNoteRebLvlFinal),2);
                $tabDataStratTmpFinal['noteAtt'] = $tabDataStratNoteAttLvlFinal;
                $tabDataStratTmpFinal['noteAttAverage'] = round(array_sum($tabDataStratNoteAttLvlFinal) / count($tabDataStratNoteAttLvlFinal),2);
                $tabDataStratTmpFinal['pp100Pg'] = $tabDataStratPp100PgFinal;
                $tabDataStratTmpFinal['pp100PgAverage'] = round(array_sum($tabDataStratPp100PgFinal) / count($tabDataStratPp100PgFinal),2);
                $tabDataStratTmpFinal['pp100Sg'] = $tabDataStratPp100SgFinal;
                $tabDataStratTmpFinal['pp100SgAverage'] = round(array_sum($tabDataStratPp100SgFinal) / count($tabDataStratPp100SgFinal),2);
                $tabDataStratTmpFinal['pp100Sf'] = $tabDataStratPp100SfFinal;
                $tabDataStratTmpFinal['pp100SfAverage'] = round(array_sum($tabDataStratPp100SfFinal) / count($tabDataStratPp100SfFinal),2);
                $tabDataStratTmpFinal['pp100Pf'] = $tabDataStratPp100PfFinal;
                $tabDataStratTmpFinal['pp100PfAverage'] = round(array_sum($tabDataStratPp100PfFinal) / count($tabDataStratPp100PfFinal),2);
                $tabDataStratTmpFinal['pp100C'] = $tabDataStratPp100CFinal;
                $tabDataStratTmpFinal['pp100CAverage'] = round(array_sum($tabDataStratPp100CFinal) / count($tabDataStratPp100CFinal),2);
                
                $tabDataStratTmpFinal['noteExtAdversaire'] = $tabDataStratNoteExtAdversaireLvlFinal;
                $tabDataStratTmpFinal['noteExtAdversaireAverage'] = round(array_sum($tabDataStratNoteExtAdversaireLvlFinal) / count($tabDataStratNoteExtAdversaireLvlFinal),2);
                $tabDataStratTmpFinal['noteIntAdversaire'] = $tabDataStratNoteIntAdversaireLvlFinal;
                $tabDataStratTmpFinal['noteIntAdversaireAverage'] = round(array_sum($tabDataStratNoteIntAdversaireLvlFinal) / count($tabDataStratNoteIntAdversaireLvlFinal),2);
                $tabDataStratTmpFinal['noteDeAdversaire'] = $tabDataStratNoteDeAdversaireLvlFinal;
                $tabDataStratTmpFinal['noteDeAdversaireAverage'] = round(array_sum($tabDataStratNoteDeAdversaireLvlFinal) / count($tabDataStratNoteDeAdversaireLvlFinal),2);
                $tabDataStratTmpFinal['noteDiAdversaire'] = $tabDataStratNoteDiAdversaireLvlFinal;
                $tabDataStratTmpFinal['noteDiAdversaireAverage'] = round(array_sum($tabDataStratNoteDiAdversaireLvlFinal) / count($tabDataStratNoteDiAdversaireLvlFinal),2);
                $tabDataStratTmpFinal['noteRebAdversaire'] = $tabDataStratNoteRebAdversaireLvlFinal;
                $tabDataStratTmpFinal['noteRebAdversaireAverage'] = round(array_sum($tabDataStratNoteRebAdversaireLvlFinal) / count($tabDataStratNoteRebAdversaireLvlFinal),2);
                $tabDataStratTmpFinal['noteAttAdversaire'] = $tabDataStratNoteAttAdversaireLvlFinal;
                $tabDataStratTmpFinal['noteAttAdversaireAverage'] = round(array_sum($tabDataStratNoteAttAdversaireLvlFinal) / count($tabDataStratNoteAttLvlFinal),2);
                
                $tabTmp[$uneStrat] = $tabDataStratTmpFinal;
                
            }
            $tabDataTeamTmpFinal['infoParStrategieDef'] = $tabTmp;
            
            $tabDataTeamGlobalFinal = array();
            foreach($tabDataStratIdMatchNtFinal as $unMatchNt)
            {
                $dataMatchNt = $em->getRepository('AppBundle:MatchNt')->find($unMatchNt);
                $tabDataTeamGlobal = array();
                $tabDataTeamGlobal['bbIdMatch'] = $dataMatchNt->getBbId();
                
                $tabTmp = array();
                $tabTmp[] = $dataMatchNt->getAwayName();
                $tabTmp[] = $dataMatchNt->getHomeName();
                $tabDataTeamGlobal['teams'] = $tabTmp;
                
                $tabTmp = array();
                $tabTmp[] = $dataMatchNt->getStrategyAwayOffense();
                $tabTmp[] = $dataMatchNt->getStrategyHomeOffense();
                $tabDataTeamGlobal['offStrat'] = $tabTmp;
                
                $tabTmp = array();
                $tabTmp[] = $dataMatchNt->getStrategyAwayDefense();
                $tabTmp[] = $dataMatchNt->getStrategyHomeDefense();
                $tabDataTeamGlobal['defStrat'] = $tabTmp;
                
                $tabTmp = array();
                $tabTmp[] = $dataMatchNt->getPamAwayFocus()."-".$dataMatchNt->getPamAwayPace();
                $tabTmp[] = $dataMatchNt->getPamHomeFocus()."-".$dataMatchNt->getPamHomePace();
                $tabDataTeamGlobal['pam'] = $tabTmp;
                
                $tabTmp = array();
                $tabTmpFg = array();
                $tabTmpFgTot = array();
                $tabTmpFgPourcentage = array();
                $tabTmp3pts = array();
                $tabTmp3ptsTot = array();
                $tabTmp3ptsPourcentage = array();
                $tabTmpFt = array();
                $tabTmpFtTot = array();
                $tabTmpFtPourcentage = array();
                $tabTmpTotReb = array();
                $tabTmpOffReb = array();
                $tabTmpDefReb = array();
                $tabTmpAssists = array();
                $tabTmpTurnovers = array();
                $tabTmpSteals = array();
                $tabTmpBlocks = array();
                $tabTmpFouls = array();
                $tabTmpPoints = array();
                $tabTmpRatings = array();
                
                $dataMatchJoueur = $em->getRepository('AppBundle:MatchJoueur')->findBy(array(
                        'idMatch'=>$unMatchNt,
                        'typeEquipe'=> 'away'
                    ));
                $globalFg = 0;
                $globalFgTot = 0;
                $global3pts = 0;
                $global3ptsTot = 0;
                $globalFt = 0;
                $globalFtTot = 0;
                $globalTotReb = 0;
                $globalOffReb= 0;
                $globalDefReb = 0;
                $globalAssists = 0;
                $globalTurnovers = 0;
                $globalSteals = 0;
                $globalBlocks = 0;
                $globalFouls = 0;
                $globalPoints = 0;
                $globalRatings = 0;
                foreach($dataMatchJoueur as $uneLigneMatch)
                {
                    $globalFg = $globalFg + $uneLigneMatch->getFg();
                    $globalFgTot = $globalFgTot + $uneLigneMatch->getFgTotal();
                    $global3pts = $global3pts + $uneLigneMatch->getThreePts();
                    $global3ptsTot = $global3ptsTot + $uneLigneMatch->getThreePtsTotal();
                    $globalFt = $globalFt + $uneLigneMatch->getFt();
                    $globalFtTot = $globalFtTot + $uneLigneMatch->getFtTotal();
                    $globalTotReb = $globalTotReb + $uneLigneMatch->getTotReb();
                    $globalOffReb= $globalOffReb + $uneLigneMatch->getOffReb();
                    $globalDefReb = $globalDefReb + $uneLigneMatch->getDefReb();
                    $globalAssists = $globalAssists + $uneLigneMatch->getAssists();
                    $globalTurnovers = $globalTurnovers + $uneLigneMatch->getTurnover();
                    $globalSteals = $globalSteals + $uneLigneMatch->getSteals();
                    $globalBlocks = $globalBlocks + $uneLigneMatch->getBlocks();
                    $globalFouls = $globalFouls + $uneLigneMatch->getFouls();
                    $globalPoints = $globalPoints + $uneLigneMatch->getPoints();
                    $globalRatings = $globalRatings + $uneLigneMatch->getRating();
                }
                $tabTmpFg[] = $globalFg;
                $tabTmpFgTot[] = $globalFgTot;
                if($globalFgTot == 0)
                {
                    $tabTmpFgPourcentage[] = 0;
                }
                else
                {
                    $tabTmpFgPourcentage[] = round($globalFg * 100 / $globalFgTot,2);
                }
                $tabTmp3pts[] = $global3pts;
                $tabTmp3ptsTot[] = $global3ptsTot;
                if($global3ptsTot == 0)
                {
                    $tabTmp3ptsPourcentage[] = 0;
                }
                else
                {
                    $tabTmp3ptsPourcentage[] = round($global3pts * 100 / $global3ptsTot,2);
                }
                $tabTmpFt[] = $globalFt;
                $tabTmpFtTot[] = $globalFtTot;
                if($globalFtTot == 0)
                {
                    $tabTmpFtPourcentage[] = 0;
                }
                else
                {
                    $tabTmpFtPourcentage[] = round($globalFt * 100 / $globalFtTot,2);
                }
                $tabTmpTotReb[] = $globalTotReb;
                $tabTmpOffReb[] = $globalOffReb;
                $tabTmpDefReb[] = $globalDefReb;
                $tabTmpAssists[] = $globalAssists;
                $tabTmpTurnovers[] = $globalTurnovers;
                $tabTmpSteals[] = $globalSteals;
                $tabTmpBlocks[] = $globalBlocks;
                $tabTmpFouls[] = $globalFouls;
                $tabTmpPoints[] = $globalPoints;
                $tabTmpRatings[] = $globalRatings;

                $dataMatchJoueur = $em->getRepository('AppBundle:MatchJoueur')->findBy(array(
                        'idMatch'=>$unMatchNt,
                        'typeEquipe'=> 'home'
                    ));
                $globalFg = 0;
                $globalFgTot = 0;
                $global3pts = 0;
                $global3ptsTot = 0;
                $globalFt = 0;
                $globalFtTot = 0;
                $globalTotReb = 0;
                $globalOffReb= 0;
                $globalDefReb = 0;
                $globalAssists = 0;
                $globalTurnovers = 0;
                $globalSteals = 0;
                $globalBlocks = 0;
                $globalFouls = 0;
                $globalPoints = 0;
                $globalRatings = 0;
                foreach($dataMatchJoueur as $uneLigneMatch)
                {
                    $globalFg = $globalFg + $uneLigneMatch->getFg();
                    $globalFgTot = $globalFgTot + $uneLigneMatch->getFgTotal();
                    $global3pts = $global3pts + $uneLigneMatch->getThreePts();
                    $global3ptsTot = $global3ptsTot + $uneLigneMatch->getThreePtsTotal();
                    $globalFt = $globalFt + $uneLigneMatch->getFt();
                    $globalFtTot = $globalFtTot + $uneLigneMatch->getFtTotal();
                    $globalTotReb = $globalTotReb + $uneLigneMatch->getTotReb();
                    $globalOffReb = $globalOffReb + $uneLigneMatch->getOffReb();
                    $globalDefReb = $globalDefReb + $uneLigneMatch->getDefReb();
                    $globalAssists = $globalAssists + $uneLigneMatch->getAssists();
                    $globalTurnovers = $globalTurnovers + $uneLigneMatch->getTurnover();
                    $globalSteals = $globalSteals + $uneLigneMatch->getSteals();
                    $globalBlocks = $globalBlocks + $uneLigneMatch->getBlocks();
                    $globalFouls = $globalFouls + $uneLigneMatch->getFouls();
                    $globalPoints = $globalPoints + $uneLigneMatch->getPoints();
                    $globalRatings = $globalRatings + $uneLigneMatch->getRating();    
                }
                $tabTmpFg[] = $globalFg;
                $tabTmpFgTot[] = $globalFgTot;
                if($globalFgTot == 0)
                {
                    $tabTmpFgPourcentage[] = 0;
                }
                else
                {
                    $tabTmpFgPourcentage[] = round($globalFg * 100 / $globalFgTot,2);
                }
                $tabTmp3pts[] = $global3pts;
                $tabTmp3ptsTot[] = $global3ptsTot;
                if($global3ptsTot == 0)
                {
                    $tabTmp3ptsPourcentage[] = 0;
                }
                else
                {
                    $tabTmp3ptsPourcentage[] = round($global3pts * 100 / $global3ptsTot,2);
                }
                $tabTmpFt[] = $globalFt;
                $tabTmpFtTot[] = $globalFtTot;
                if($globalFtTot == 0)
                {
                    $tabTmpFtPourcentage[] = 0;
                }
                else
                {
                    $tabTmpFtPourcentage[] = round($globalFt * 100 / $globalFtTot,2);
                }
                $tabTmpTotReb[] = $globalTotReb;
                $tabTmpOffReb[] = $globalOffReb;
                $tabTmpDefReb[] = $globalDefReb;
                $tabTmpAssists[] = $globalAssists;
                $tabTmpTurnovers[] = $globalTurnovers;
                $tabTmpSteals[] = $globalSteals;
                $tabTmpBlocks[] = $globalBlocks;
                $tabTmpFouls[] = $globalFouls;
                $tabTmpPoints[] = $globalPoints;
                $tabTmpRatings[] = $globalRatings;
                
                $tabDataTeamGlobal['globalFg'] = $tabTmpFg;
                $tabDataTeamGlobal['globalFgTot'] = $tabTmpFgTot;
                $tabDataTeamGlobal['globalFgPourcentage'] = $tabTmpFgPourcentage;
                $tabDataTeamGlobal['global3pts'] = $tabTmp3pts;
                $tabDataTeamGlobal['global3ptsTot'] = $tabTmp3ptsTot;
                $tabDataTeamGlobal['global3ptsPourcentage'] = $tabTmp3ptsPourcentage;
                $tabDataTeamGlobal['globalFt'] = $tabTmpFt;
                $tabDataTeamGlobal['globalFtTot'] = $tabTmpFtTot;
                $tabDataTeamGlobal['globalFtPourcentage'] = $tabTmpFtPourcentage;
                $tabDataTeamGlobal['globalTotReb'] = $tabTmpTotReb;
                $tabDataTeamGlobal['globalOffReb'] = $tabTmpOffReb;
                $tabDataTeamGlobal['globalDefReb'] = $tabTmpDefReb;
                $tabDataTeamGlobal['globalAssists'] = $tabTmpAssists;
                $tabDataTeamGlobal['globalTurnovers'] = $tabTmpTurnovers;
                $tabDataTeamGlobal['globalSteals'] = $tabTmpSteals;
                $tabDataTeamGlobal['globalBlocks'] = $tabTmpBlocks;
                $tabDataTeamGlobal['globalFouls'] = $tabTmpFouls;
                $tabDataTeamGlobal['globalPoints'] = $tabTmpPoints;
                $tabDataTeamGlobal['globalRatings'] = $tabTmpRatings;
                                
                $tabDataTeamGlobalFinal[$dataMatchNt->getBbId()] = $tabDataTeamGlobal;
                
            }

            $tabDataTeamTmpFinal['infoTeamGlobal'] = $tabDataTeamGlobalFinal;
            
            $tabIdTeam = array_unique($tabDataBbIdTeamFinal);
            $idTeam = $tabIdTeam[0];

            $tabBbIdJoueur = array();
            $tabBbIdMatch = array();
            $tabOffStrat = array();
            $tabDefStrat = array();
            $tabNom = array();
            $tabPosition = array();
            $tabForme = array();
            $tabMinutes = array();
            $tabFg = array();
            $tabFgTotal = array();
            $tabThreePts = array();
            $tabThreePtsTotal = array();
            $tabFt = array();
            $tabFtTotal = array();
            $tabOffReb = array();
            $tabDefReb = array();
            $tabTotReb = array();
            $tabAssists = array();
            $tabTurnover = array();
            $tabSteals = array();
            $tabBlocks = array();
            $tabFouls = array();
            $tabPoints = array();
            $tabRating = array();
            $tabPp100 = array();
            
            $tabNbShootPosition = array();
            $tabCoefShoot = array();
            $tabCoefShootJoueur = array();
            
            foreach($tabDataIdMatchNtFinal as $unIdMatchNt)
            {
                $tabNbShootPositionTmp = array();
                
                $tabNbShootPositionTmp['PG'] = 0;
                $tabNbShootPositionTmp['SG'] = 0;
                $tabNbShootPositionTmp['SF'] = 0;
                $tabNbShootPositionTmp['PF'] = 0;
                $tabNbShootPositionTmp['C'] = 0;
            
                $unMatchNt = $em->getRepository('AppBundle:MatchNt')->find($unIdMatchNt);
                
                $tabJoueurGame = $em->getRepository('AppBundle:MatchJoueur')->findBy(array(
                    'idTeam'=>$idTeam,
                    'idMatch'=>$unIdMatchNt,
                ));
                
                foreach($tabJoueurGame as $unJoueurGame)
                { 
                    $tabBbIdJoueur[] = $unJoueurGame->getBbId();
                    $tabBbIdMatch[] = $unMatchNt->getBbId();
                    
                    $tabPpTmp = array();
                    if($unJoueurGame->getTypeEquipe() == 'away')
                    {
                        $tabOffStrat[] = $unMatchNt->getStrategyAwayOffense();
                        $tabDefStrat[] = $unMatchNt->getStrategyAwayDefense();
                        
                        $tabPpTmp['PG'] = $unMatchNt->getPp100AwayPg();
                        $tabPpTmp['SG'] = $unMatchNt->getPp100AwaySg();
                        $tabPpTmp['SF'] = $unMatchNt->getPp100AwaySf();
                        $tabPpTmp['PF'] = $unMatchNt->getPp100AwayPf();
                        $tabPpTmp['C'] = $unMatchNt->getPp100AwayC();
                    }
                    else
                    {
                        $tabOffStrat[] = $unMatchNt->getStrategyHomeOffense();
                        $tabDefStrat[] = $unMatchNt->getStrategyHomeDefense();
                        
                        $tabPpTmp['PG'] = $unMatchNt->getPp100HomePg();
                        $tabPpTmp['SG'] = $unMatchNt->getPp100HomeSg();
                        $tabPpTmp['SF'] = $unMatchNt->getPp100HomeSf();
                        $tabPpTmp['PF'] = $unMatchNt->getPp100HomePf();
                        $tabPpTmp['C'] = $unMatchNt->getPp100HomeC();
                    }
                    
                    $tabPp100[] = $tabPpTmp;
                    $tabNom[] = $unJoueurGame->getName();
                    $tabPosition[] = $unJoueurGame->getPosition();
                    if($unJoueurGame->getPosition() != '')
                    {
                        $tabNbShootPositionTmp[$unJoueurGame->getPosition()] = $tabNbShootPositionTmp[$unJoueurGame->getPosition()] + $unJoueurGame->getFgTotal();
                    }
                    
                    $tabForme[] = $unJoueurGame->getForme();
                    $tabMinutes[] = $unJoueurGame->getMinutes();
                    $tabFg[] = $unJoueurGame->getFg();
                    $tabFgTotal[] = $unJoueurGame->getFgTotal();
                    $tabThreePts[] = $unJoueurGame->getThreePts();
                    $tabThreePtsTotal[] = $unJoueurGame->getThreePtsTotal();
                    $tabFt[] = $unJoueurGame->getFt();
                    $tabFtTotal[] = $unJoueurGame->getFtTotal();
                    $tabOffReb[] = $unJoueurGame->getOffReb();
                    $tabDefReb[] = $unJoueurGame->getDefReb();
                    $tabTotReb[] = $unJoueurGame->getTotReb();
                    $tabAssists[] = $unJoueurGame->getAssists();
                    $tabTurnover[] = $unJoueurGame->getTurnover();
                    $tabSteals[] = $unJoueurGame->getSteals();
                    $tabBlocks[] = $unJoueurGame->getBlocks();
                    $tabFouls[] = $unJoueurGame->getFouls();
                    $tabPoints[] = $unJoueurGame->getPoints();
                    $tabRating[] = $unJoueurGame->getRating();  
                }
                $tabNbShootPosition[] = $tabNbShootPositionTmp;
                
                $tabCoefShootTmp = array();
                $tabCoefShootTmp['PG'] = round(100 / $tabNbShootPositionTmp['PG'],2);
                $tabCoefShootTmp['SG'] = round(100 / $tabNbShootPositionTmp['SG'],2);
                $tabCoefShootTmp['SF'] = round(100 / $tabNbShootPositionTmp['SF'],2);
                $tabCoefShootTmp['PF'] = round(100 / $tabNbShootPositionTmp['PF'],2);
                $tabCoefShootTmp['C'] = round(100 / $tabNbShootPositionTmp['C'],2);
                                
                $tabCoefShoot[] = $tabCoefShootTmp;
                
                foreach($tabJoueurGame as $unJoueurGame)
                {
                    $tabCoefShootJoueur[] = $tabCoefShoot;
                }
            }   

            $tabBbIdJoueurUnique = array_unique($tabBbIdJoueur);
            
            $tabJoueurFinal = array();            
            foreach($tabBbIdJoueurUnique as $unBbIdJoueur)
            {
                $tabIndiceJoueur = array_keys($tabBbIdJoueur, $unBbIdJoueur);
     
                $tabTmp = array();
                $tabNomFinal = array();
                $tabBbIdMatchFinal = array();
                $tabOffStratFinal = array();
                $tabDefStratFinal = array();
                $tabPositionFinal = array();
                $tabFormeFinal = array();
                $tabMinutesFinal = array();
                $tabFgFinal = array();
                $tabFgTotalFinal = array();
                $tabFgPourcentageFinal = array();
                $tabThreePtsFinal = array();
                $tabThreePtsTotalFinal = array();
                $tabThreePtsPourcentageFinal = array();
                $tabFtFinal = array();
                $tabFtTotalFinal = array();
                $tabFtPourcentageFinal = array();
                $tabOffRebFinal = array();
                $tabDefRebFinal = array();
                $tabTotRebFinal = array();
                $tabAssistsFinal = array();
                $tabTurnoverFinal = array();
                $tabStealsFinal = array();
                $tabBlocksFinal = array();
                $tabFoulsFinal = array();
                $tabPointsFinal = array();
                $tabRatingFinal = array();
                $tabPp100Final = array();
                $tabAdversaireFinal = array();
                $tabPp100JoueurFinal = array();
                
                foreach($tabIndiceJoueur as $unIndiceJoueur)
                {
                    $tabNomFinal[] = $tabNom[$unIndiceJoueur];
                    $tabBbIdMatchFinal[] = $tabBbIdMatch[$unIndiceJoueur];
                    $tabOffStratFinal[] = $tabOffStrat[$unIndiceJoueur];
                    $tabDefStratFinal[] = $tabDefStrat[$unIndiceJoueur];
                    $tabPositionFinal[] = $tabPosition[$unIndiceJoueur];
                    $tabFormeFinal[] = $tabForme[$unIndiceJoueur];
                    $tabMinutesFinal[] = $tabMinutes[$unIndiceJoueur];
                    $tabFgFinal[] = $tabFg[$unIndiceJoueur];
                    $tabFgTotalFinal[] = $tabFgTotal[$unIndiceJoueur];
                    if($tabFgTotal[$unIndiceJoueur] == 0)
                    {
                        $tabFgPourcentageFinal[] = 0; 
                    }
                    else
                    {
                        $tabFgPourcentageFinal[] = round($tabFg[$unIndiceJoueur] * 100 / $tabFgTotal[$unIndiceJoueur],2); 
                    }
                    $tabThreePtsFinal[] = $tabThreePts[$unIndiceJoueur];
                    $tabThreePtsTotalFinal[] = $tabThreePtsTotal[$unIndiceJoueur];
                    if($tabThreePtsTotal[$unIndiceJoueur] == 0)
                    {
                        $tabThreePtsPourcentageFinal[] = 0; 
                    }
                    else
                    {
                        $tabThreePtsPourcentageFinal[] = round($tabThreePts[$unIndiceJoueur] * 100 / $tabThreePtsTotal[$unIndiceJoueur],2); 
                    }
                    $tabFtFinal[] = $tabFt[$unIndiceJoueur];
                    $tabFtTotalFinal[] = $tabFtTotal[$unIndiceJoueur];
                    if($tabFtTotal[$unIndiceJoueur] == 0)
                    {
                        $tabFtPourcentageFinal[] = 0; 
                    }
                    else
                    {
                        $tabFtPourcentageFinal[] = round($tabFt[$unIndiceJoueur] * 100 / $tabFtTotal[$unIndiceJoueur],2); 
                    }
                    
                    $tabOffRebFinal[] = $tabOffReb[$unIndiceJoueur];
                    $tabDefRebFinal[] = $tabDefReb[$unIndiceJoueur];
                    $tabTotRebFinal[] = $tabTotReb[$unIndiceJoueur];
                    $tabAssistsFinal[] = $tabAssists[$unIndiceJoueur];
                    $tabTurnoverFinal[] = $tabTurnover[$unIndiceJoueur];
                    $tabStealsFinal[] = $tabSteals[$unIndiceJoueur];
                    $tabBlocksFinal[] = $tabBlocks[$unIndiceJoueur];
                    $tabFoulsFinal[] = $tabFouls[$unIndiceJoueur];
                    $tabPointsFinal[] = $tabPoints[$unIndiceJoueur];
                    $tabRatingFinal[] = $tabRating[$unIndiceJoueur];
                    $tabPp100Final[] = $tabPp100[$unIndiceJoueur];
                    
                    $tabPp100Pos = $tabPp100[$unIndiceJoueur];
                    $tabCoefJoueurTmp = $tabCoefShootJoueur[$unIndiceJoueur];
                    $tabCoefJoueur = $tabCoefJoueurTmp[0];

                    if($tabFgTotal[$unIndiceJoueur] == 0)
                    {
                        $tabPp100JoueurFinal[] = 0;
                    }
                    else
                    {
                       $valPp100Joueur = round($tabPp100Pos[$tabPosition[$unIndiceJoueur]] * $tabFgTotal[$unIndiceJoueur] / 100 * $tabCoefJoueur[$tabPosition[$unIndiceJoueur]],1); 
                       if($valPp100Joueur > $tabPp100[$unIndiceJoueur])
                       {
                           $valPp100Joueur = $tabPp100[$unIndiceJoueur];
                       }
                       $tabPp100JoueurFinal[] = $valPp100Joueur;
                    }
                }
                
                $tabTmp['nom'] = $tabNomFinal[0];  
                $tabTmp['bbIdMatch'] = $tabBbIdMatchFinal;
                $tabTmp['pp100'] = $tabPp100Final;
                $tabTmp['nbShootPosition'] = $tabNbShootPosition;
                $tabTmp['pp100Joueur'] = $tabPp100JoueurFinal;
                $tabTmp['coefShoot'] = $tabCoefShoot;
                $tabTmp['offStrat'] = $tabOffStratFinal;
                $tabTmp['defStrat'] = $tabDefStratFinal;
                $tabTmp['position'] = $tabPositionFinal;  
                $tabTmp['forme'] = $tabFormeFinal;  
                $tabTmp['minutes'] = $tabMinutesFinal;
                $tabTmp['fg'] = $tabFgFinal;
                $tabTmp['fgTotal'] = $tabFgTotalFinal;
                $tabTmp['fgPourcentage'] = $tabFgPourcentageFinal;
                $tabTmp['threePts'] = $tabThreePtsFinal;
                $tabTmp['threePtsTotal'] = $tabThreePtsTotalFinal;
                $tabTmp['threePtsPourcentage'] = $tabThreePtsPourcentageFinal;
                $tabTmp['ft'] = $tabFtFinal;
                $tabTmp['ftTotal'] = $tabFtTotalFinal;
                $tabTmp['ftPourcentage'] = $tabFtPourcentageFinal;
                $tabTmp['offReb'] = $tabOffRebFinal;
                $tabTmp['defReb'] = $tabDefRebFinal;
                $tabTmp['totReb'] = $tabTotRebFinal;
                $tabTmp['assists'] = $tabAssistsFinal;
                $tabTmp['turnovers'] = $tabTurnoverFinal;
                $tabTmp['steals'] = $tabStealsFinal;
                $tabTmp['blocks'] = $tabBlocksFinal;
                $tabTmp['fouls'] = $tabFoulsFinal;
                $tabTmp['points'] = $tabPointsFinal;
                $tabTmp['ratings'] = $tabRatingFinal;
                
                $tabTmp['sumMinutes'] = array_sum($tabMinutesFinal);   
                $tabTmp['moyMinutes'] = round(array_sum($tabMinutesFinal) / count($tabMinutesFinal),2); 
                $tabTmp['sumFg'] = array_sum($tabFgFinal);   
                $tabTmp['moyFg'] = round(array_sum($tabFgFinal) / count($tabFgFinal),2); 
                $tabTmp['sumFgTotal'] = array_sum($tabFgTotalFinal);   
                $tabTmp['moyFgTotal'] = round(array_sum($tabFgTotalFinal) / count($tabFgTotalFinal),2); 
                if(array_sum($tabFgTotalFinal) == 0)
                {
                    $tabTmp['pourcentageTotFg'] = 0; 
                }
                else
                {
                    $tabTmp['pourcentageTotFg'] = round(array_sum($tabFgFinal) * 100 / array_sum($tabFgTotalFinal),2); 
                }
                
                $tabTmp['sumThreePts'] = array_sum($tabThreePtsFinal);   
                $tabTmp['moyThreePts'] = round(array_sum($tabThreePtsFinal) / count($tabThreePtsFinal),2); 
                $tabTmp['sumThreePtsTotal'] = array_sum($tabThreePtsTotalFinal);   
                $tabTmp['moyThreePtsTotal'] = round(array_sum($tabThreePtsTotalFinal) / count($tabThreePtsTotalFinal),2); 
                if(array_sum($tabThreePtsTotalFinal) == 0)
                {
                    $tabTmp['pourcentageTotThreePts'] = 0; 
                }
                else
                {
                    $tabTmp['pourcentageTotThreePts'] = round(array_sum($tabThreePtsFinal) * 100 / array_sum($tabThreePtsTotalFinal),2); 
                }
                
                $tabTmp['sumFt'] = array_sum($tabFtFinal);   
                $tabTmp['moyFt'] = round(array_sum($tabFtFinal) / count($tabFtFinal),2); 
                $tabTmp['sumFtTotal'] = array_sum($tabFtTotalFinal);   
                $tabTmp['moyFtTotal'] = round(array_sum($tabFtTotalFinal) / count($tabFtTotalFinal),2); 
                if(array_sum($tabFtTotalFinal) == 0)
                {
                    $tabTmp['pourcentageTotFt'] = 0; 
                }
                else
                {
                    $tabTmp['pourcentageTotFt'] = round(array_sum($tabFtFinal) * 100 / array_sum($tabFtTotalFinal),2); 
                }
                
                $tabTmp['sumOffReb'] = array_sum($tabOffRebFinal);
                $tabTmp['sumDefReb'] = array_sum($tabDefRebFinal);
                $tabTmp['sumTotReb'] = array_sum($tabTotRebFinal);
                $tabTmp['sumAssists'] = array_sum($tabAssistsFinal);
                $tabTmp['sumTurnovers'] = array_sum($tabTurnoverFinal);
                $tabTmp['sumSteals'] = array_sum($tabStealsFinal);
                $tabTmp['sumBlocks'] = array_sum($tabBlocksFinal);
                $tabTmp['sumFouls'] = array_sum($tabFoulsFinal);
                $tabTmp['sumPoints'] = array_sum($tabPointsFinal);
                $tabTmp['sumRatings'] = array_sum($tabRatingFinal);
                
                $tabTmp['moyOffReb'] = round(array_sum($tabOffRebFinal) / count($tabFtTotalFinal),2); 
                $tabTmp['moyDefReb'] = round(array_sum($tabDefRebFinal) / count($tabDefRebFinal),2); 
                $tabTmp['moyTotReb'] = round(array_sum($tabTotRebFinal) / count($tabTotRebFinal),2); 
                $tabTmp['moyAssists'] = round(array_sum($tabAssistsFinal) / count($tabAssistsFinal),2); 
                $tabTmp['moyTurnovers'] = round(array_sum($tabTurnoverFinal) / count($tabTurnoverFinal),2); 
                $tabTmp['moySteals'] = round(array_sum($tabStealsFinal) / count($tabStealsFinal),2); 
                $tabTmp['moyBlocks'] = round(array_sum($tabBlocksFinal) / count($tabBlocksFinal),2); 
                $tabTmp['moyFouls'] = round(array_sum($tabFoulsFinal) / count($tabFoulsFinal),2); 
                $tabTmp['moyPoints'] = round(array_sum($tabPointsFinal) / count($tabPointsFinal),2); 
                $tabTmp['moyRatings'] = round(array_sum($tabRatingFinal) / count($tabRatingFinal),2); 
                 
                $indiceMatch = 0;
                $tabPp100Adversaire = array(); 
                foreach($tabBbIdMatchFinal as $unBbIdMatch)
                {                   
                    if($tabPositionFinal[$indiceMatch] <> '')
                    {        
                        $unMatchNt = $em->getRepository('AppBundle:MatchNt')->findOneBy(array(
                                'bbId'=>$unBbIdMatch,
                            ));

                        $tabPp100Adversaire = array();
                        if($idTeam == $unMatchNt->getAwayBbId())
                        {
                            $idTeamAdverse = $unMatchNt->getHomeBbId();
                            $offStrat = $unMatchNt->getStrategyAwayOffense();
                            $defStrat = $unMatchNt->getStrategyAwayDefense();
                            
                            $tabPp100Adversaire['PG'] = $unMatchNt->getPp100HomePg();
                            $tabPp100Adversaire['SG'] = $unMatchNt->getPp100HomeSg();
                            $tabPp100Adversaire['SF'] = $unMatchNt->getPp100HomeSf();
                            $tabPp100Adversaire['PF'] = $unMatchNt->getPp100HomePf();
                            $tabPp100Adversaire['C'] = $unMatchNt->getPp100HomeC(); 
                        }
                        else
                        {
                            $idTeamAdverse = $unMatchNt->getAwayBbId();
                            $offStrat = $unMatchNt->getStrategyHomeOffense();
                            $defStrat = $unMatchNt->getStrategyHomeDefense();
                            
                            $tabPp100Adversaire['PG'] = $unMatchNt->getPp100AwayPg();
                            $tabPp100Adversaire['SG'] = $unMatchNt->getPp100AwaySg();
                            $tabPp100Adversaire['SF'] = $unMatchNt->getPp100AwaySf();
                            $tabPp100Adversaire['PF'] = $unMatchNt->getPp100AwayPf();
                            $tabPp100Adversaire['C'] = $unMatchNt->getPp100AwayC();
                        } 
                        
                        $tabPp100Adversaire[] = $tabPpTmp;
                        
                        $tabAdversaireTmp = array(); 
                        $tabJoueurAdversaireGame = $em->getRepository('AppBundle:MatchJoueur')->findBy(array(
                                'idTeam'=>$idTeamAdverse,
                                'idMatch'=>$unMatchNt->getId(),
                                'position'=>$tabPositionFinal[$indiceMatch],
                            ));
                        

                        $tabNbShootAdversaire['PG'] = 0;
                        $tabNbShootAdversaire['SG'] = 0;
                        $tabNbShootAdversaire['SF'] = 0;
                        $tabNbShootAdversaire['PF'] = 0;
                        $tabNbShootAdversaire['C'] = 0;
                        foreach($tabJoueurAdversaireGame as $unAdversaire)
                        { 
                            $tabNbShootAdversaire[$unAdversaire->getPosition()] = $tabNbShootAdversaire[$unAdversaire->getPosition()] + $unAdversaire->getFgTotal();
                        }
                        $tabCoefShootAdversaire = array();
                        $tabCoefShootAdversaire[$unAdversaire->getPosition()] = round(100 / $tabNbShootAdversaire[$unAdversaire->getPosition()],2);

                        foreach($tabJoueurAdversaireGame as $unAdversaire)
                        {
                            $tabDataAdversaire = array();

                            $tabDataAdversaire['idMatchNt'] = $unIdMatchNt;
                            $tabDataAdversaire['bbIdMatch'] = $unBbIdMatch;
                            $tabDataAdversaire['pp100'] = $tabPp100Adversaire[$unAdversaire->getPosition()];
                            $tabDataAdversaire['nbShootPosition'] = $tabNbShootAdversaire[$unAdversaire->getPosition()];
                            
                            if($unAdversaire->getFgTotal() == 0)
                            {
                                $valPp100Adverssaire = 0;
                            }
                            else
                            {
                               $valPp100Adverssaire = round($tabPp100Adversaire[$unAdversaire->getPosition()] * $unAdversaire->getFgTotal() / 100 * $tabCoefShootAdversaire[$unAdversaire->getPosition()],1); 
                               
                               if($valPp100Adverssaire > $tabPp100Adversaire[$unAdversaire->getPosition()])
                               {
                                   $valPp100Adverssaire = $tabPp100Adversaire[$unAdversaire->getPosition()];
                               }
                            }
                    
                            $tabDataAdversaire['pp100Joueur'] = $valPp100Adverssaire;
                            $tabDataAdversaire['bbId'] = $unAdversaire->getBbId();
                            $tabDataAdversaire['nom'] = $unAdversaire->getName();
                            $tabDataAdversaire['position'] = $unAdversaire->getPosition();
                            $tabDataAdversaire['offStrat'] = $offStrat;
                            $tabDataAdversaire['defStrat'] = $defStrat;
                            $tabDataAdversaire['forme'] = $unAdversaire->getForme();
                            $tabDataAdversaire['minutes'] = $unAdversaire->getMinutes();
                            
                            $tabDataAdversaire['fg'] = $unAdversaire->getFg();
                            $tabDataAdversaire['fgTotal'] = $unAdversaire->getFgTotal();
                            if($unAdversaire->getFgTotal() == 0)
                            {
                                $tabDataAdversaire['fgPourcentage'] = 0;
                            }
                            else
                            {
                                $tabDataAdversaire['fgPourcentage'] = round($unAdversaire->getFg() * 100 / $unAdversaire->getFgTotal(),2); 
                            }
                            $tabDataAdversaire['threePts'] = $unAdversaire->getThreePts();
                            $tabDataAdversaire['threePtsTotal'] = $unAdversaire->getThreePtsTotal();
                            if($unAdversaire->getThreePtsTotal() == 0)
                            {
                                $tabDataAdversaire['threePtsPourcentage'] = 0;
                            }
                            else
                            {
                                $tabDataAdversaire['threePtsPourcentage'] = round($unAdversaire->getThreePts() * 100 / $unAdversaire->getThreePtsTotal(),2); 
                            }
                            $tabDataAdversaire['ft'] = $unAdversaire->getFt();
                            $tabDataAdversaire['ftTotal'] = $unAdversaire->getFtTotal();
                            if($unAdversaire->getFtTotal() == 0)
                            {
                                $tabDataAdversaire['ftPourcentage'] = 0;
                            }
                            else
                            {
                                $tabDataAdversaire['ftPourcentage'] = round($unAdversaire->getFt() * 100 / $unAdversaire->getFtTotal(),2); 
                            }
                            $tabDataAdversaire['offReb'] = $unAdversaire->getOffReb();
                            $tabDataAdversaire['defReb'] = $unAdversaire->getDefReb();
                            $tabDataAdversaire['totReb'] = $unAdversaire->getTotReb();
                            $tabDataAdversaire['assists'] = $unAdversaire->getAssists();
                            $tabDataAdversaire['turnovers'] = $unAdversaire->getTurnover();
                            $tabDataAdversaire['steals'] = $unAdversaire->getSteals();
                            $tabDataAdversaire['blocks'] = $unAdversaire->getBlocks();
                            $tabDataAdversaire['fouls'] = $unAdversaire->getFouls();
                            $tabDataAdversaire['points'] = $unAdversaire->getPoints();
                            $tabDataAdversaire['ratings'] = $unAdversaire->getRating();
    
                            $tabAdversaireTmp[] = $tabDataAdversaire;
                        }
                        $tabAdversaireFinal[] = $tabAdversaireTmp;
                    }
                    $indiceMatch++;
                }
                
                $tabTmp['adversaires'] = $tabAdversaireFinal;
                $tabJoueurFinal[$unBbIdJoueur] = $tabTmp;
            }

            $tabDataTeamTmpFinal['infoJoueurGlobal'] = $tabJoueurFinal;

            $tabPositionFinal = array();  
            
            $tabListePosition = array();
            $tabListePosition[] = 'PG';
            $tabListePosition[] = 'SG';
            $tabListePosition[] = 'SF';
            $tabListePosition[] = 'PF';
            $tabListePosition[] = 'C';
            
            foreach($tabListePosition as $unePosition)
            {
                $tabDataMatch = array();
                foreach($tabDataIdMatchNtFinal as $unIdMatchNt)
                {
                    $unMatchNt = $em->getRepository('AppBundle:MatchNt')->find($unIdMatchNt);
 
                    if($idTeam == $unMatchNt->getAwayBbId())
                    {
                        $idTeamAdverse = $unMatchNt->getHomeBbId();
                        $nameTeam = $unMatchNt->getAwayName();
                        $nameTeamAdversaire = $unMatchNt->getHomeName();
                        
                        switch($unePosition)
                        {
                            case 'PG':
                                $pp100Team = $unMatchNt->getPp100AwayPg();
                                $pp100Adversaire = $unMatchNt->getPp100HomePg();
                                break;
                            case 'SG':
                                $pp100Team = $unMatchNt->getPp100AwaySg();
                                $pp100Adversaire = $unMatchNt->getPp100HomeSg();
                                break;
                            case 'SF':
                                $pp100Team = $unMatchNt->getPp100AwaySf();
                                $pp100Adversaire = $unMatchNt->getPp100HomeSf();
                                break;
                            case 'PF':
                                $pp100Team = $unMatchNt->getPp100AwayPf();
                                $pp100Adversaire = $unMatchNt->getPp100HomePf();
                                break;
                            case 'C':
                                $pp100Team = $unMatchNt->getPp100AwayC();
                                $pp100Adversaire = $unMatchNt->getPp100HomeC();
                                break;
                        }
                                   
                        $offStratTeam = $unMatchNt->getStrategyAwayOffense();
                        $defStratTeam = $unMatchNt->getStrategyAwayDefense();
                        $offStratAdversaire = $unMatchNt->getStrategyHomeOffense();
                        $defStratAdversaire = $unMatchNt->getStrategyHomeDefense();
                    }
                    else
                    {
                        $idTeamAdverse = $unMatchNt->getAwayBbId();
                        $nameTeam = $unMatchNt->getHomeName();
                        $nameTeamAdversaire = $unMatchNt->getAwayName();
                        
                        switch($unePosition)
                        {
                            case 'PG':
                                $pp100Team = $unMatchNt->getPp100HomePg();
                                $pp100Adversaire = $unMatchNt->getPp100AwayPg();
                                break;
                            case 'SG':
                                $pp100Team = $unMatchNt->getPp100HomeSg();
                                $pp100Adversaire = $unMatchNt->getPp100AwaySg();
                                break;
                            case 'SF':
                                $pp100Team = $unMatchNt->getPp100HomeSf();
                                $pp100Adversaire = $unMatchNt->getPp100AwaySf();
                                break;
                            case 'PF':
                                $pp100Team = $unMatchNt->getPp100HomePf();
                                $pp100Adversaire = $unMatchNt->getPp100AwayPf();
                                break;
                            case 'C':
                                $pp100Team = $unMatchNt->getPp100HomeC();
                                $pp100Adversaire = $unMatchNt->getPp100AwayC();
                                break;
                        }
                        
                        $offStratTeam = $unMatchNt->getStrategyHomeOffense();
                        $defStratTeam = $unMatchNt->getStrategyHomeDefense();
                        $offStratAdversaire = $unMatchNt->getStrategyAwayOffense();
                        $defStratAdversaire = $unMatchNt->getStrategyAwayDefense();
                    }
                    
                    $tabTmp = array();
                    $tabTmpTmp = array();
                    
                    $tabJoueur = $em->getRepository('AppBundle:MatchJoueur')->findBy(array(
                        'idTeam'=>$idTeam,
                        'idMatch'=>$unIdMatchNt,
                        'position'=>$unePosition
                    ));
                    
                    $nbShoot = 0;
                    foreach($tabJoueur as $unJoueur)
                    {
                       $nbShoot = $nbShoot + $unJoueur->getFgTotal(); 
                    }
                    $coefPosition = round(100 / $nbShoot,2);
                    
                    $tabPp100Joueur = array();
                    foreach($tabJoueur as $unJoueur)
                    {
                        if($unJoueur->getFgTotal() == 0)
                        {
                            $pp100Joueur = 0;
                        }
                        else
                        {
                            $pp100Joueur = round($pp100Team * $unJoueur->getFgTotal() / 100 * $coefPosition,1);

                            if($pp100Joueur > $pp100Team)
                            {
                                $pp100Joueur = $pp100Team;
                            }
                        } 
                        
                        $tabPp100Joueur[$unJoueur->getId()] = $pp100Joueur;
                    }                 
                    
                    $tabTmpTmp['name'] = $nameTeam;
                    $tabTmpTmp['pp100'] = $pp100Team;
                    $tabTmpTmp['pp100Joueur'] = $tabPp100Joueur;
                    $tabTmpTmp['nbShoot'] = $nbShoot;
                    $tabTmpTmp['offStrat'] = $offStratTeam;
                    $tabTmpTmp['defStrat'] = $defStratTeam;
                    $tabTmpTmp['joueurs'] = $tabJoueur;
                    $tabTmp['team'] = $tabTmpTmp;
                    
                    $tabAdversaire = $em->getRepository('AppBundle:MatchJoueur')->findBy(array(
                        'idTeam'=>$idTeamAdverse,
                        'idMatch'=>$unIdMatchNt,
                        'position'=>$unePosition
                    ));
                    $nbShoot = 0;
                    foreach($tabAdversaire as $unJoueur)
                    {
                       $nbShoot = $nbShoot + $unJoueur->getFgTotal(); 
                    }
                    $coefPosition = round(100 / $nbShoot,2);
                    
                    $tabPp100JoueurAdversaire = array();
                    foreach($tabAdversaire as $unJoueur)
                    {
                        if($unJoueur->getFgTotal() == 0)
                        {
                            $pp100JoueurAdversaire = 0;
                        }
                        else
                        {
                            $pp100JoueurAdversaire = round($pp100Adversaire * $unJoueur->getFgTotal() / 100 * $coefPosition,1);

                            if($pp100JoueurAdversaire > $pp100Adversaire)
                            {
                                $pp100JoueurAdversaire = $pp100Adversaire;
                            }
                        } 
                        
                        $tabPp100JoueurAdversaire[$unJoueur->getId()] = $pp100JoueurAdversaire;
                    }  
                    $tabTmpTmp['name'] = $nameTeamAdversaire;
                    $tabTmpTmp['pp100'] = $pp100Adversaire;
                    $tabTmpTmp['pp100Joueur'] = $tabPp100JoueurAdversaire;
                    $tabTmpTmp['nbShoot'] = $nbShoot;
                    $tabTmpTmp['offStrat'] = $offStratAdversaire;
                    $tabTmpTmp['defStrat'] = $defStratAdversaire;
                    $tabTmpTmp['joueurs'] = $tabAdversaire;     
                    
                    $tabTmp['adversaire'] = $tabTmpTmp;
                    
                    $tabDataMatch[$unMatchNt->getBbId()] = $tabTmp;
                }
                
                $tabPositionFinal[$unePosition] = $tabDataMatch;
            }
 
            $tabDataTeamTmpFinal['infoPositionGlobal'] = $tabPositionFinal;
            
            //echo "<pre>";
            //print_r($tabPositionFinal);
            //echo "</pre>";
            
            $tabDataTeamFinal[$unNomTeam] = $tabDataTeamTmpFinal;
            
        }
        
        $tabRetour = array();
        $tabRetour['fullData'] = $tabFullData;
        $tabRetour['tabDataTeamFinal'] = $tabDataTeamFinal;
        return $tabRetour;
    }
}