<?php

namespace AppBundle\Repository;

use AppBundle\Entity\GameAnalysis;
use Doctrine\ORM\EntityRepository;

class GameAnalysisRepository extends EntityRepository
{
    public function create($idAccount,$nomChoisi,$session)
    {
        $em = $this->getEntityManager();
        
        $uneAnalyse = $em->getRepository('AppBundle:GameAnalysis')->findOneBy(
            array(
                'nom'=>$nomChoisi,
                'idAccount'=>$idAccount,
            ));
        
        if($uneAnalyse)
        {
            $messageError = 'Game Analysis name already existing';
            $session->set('messageAccountError',$messageError);
            $uneAnalyse = 'null';
        }
        else
        {
            $uneAnalyse = new GameAnalysis();
            $uneAnalyse->setIdAccount($idAccount);
            $uneAnalyse->setNom($nomChoisi);
            $dateCreation = new \DateTime();
            $uneAnalyse->setDateCreation($dateCreation);
            $em->persist($uneAnalyse);
            $em->flush();
        }
        return $uneAnalyse;
    }   
    
    public function update($idAnalyse,$nomChoisi,$commentaireAnalyse)
    {
        $em = $this->getEntityManager();
        
        $uneAnalyse = $em->getRepository('AppBundle:GameAnalysis')->find($idAnalyse);
        
        $uneAnalyse->setNom($nomChoisi);
        $uneAnalyse->setCommentaire($commentaireAnalyse);
        $em->persist($uneAnalyse);
        $em->flush();
        
        return $uneAnalyse;
    }
    
    public function remove($idAnalyse,$user)
    {
        $em = $this->getEntityManager();
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
                 
        $uneAnalyse = $em->getRepository('AppBundle:GameAnalysis')->findOneBy(
            array(
                'id'=>$idAnalyse,
                'idAccount'=>$infoUser->getId(),
            ));
        
        if($uneAnalyse)
        {
            $em->remove($uneAnalyse);
            $em->flush();
        }
        else
        {
            echo "Not your game analysis...";
            die();
        }
    }
}