<?php

namespace AppBundle\Repository;

use Doctrine\ORM\EntityRepository;

use AppBundle\Entity\Recherche;

class JoueurNtScoutRepository extends EntityRepository
{   
    public function count()
    {
        $em = $this->getEntityManager();
        $requete = 'SELECT COUNT(1) as nb FROM AppBundle:JoueurNtScout j';
        $query = $em->createQuery($requete);
        $count = $query->getResult();
        return $count[0];
    }
    
    public function findJoueursNtScoutReqCustom($dataSearch,$session,$forSale,$forSaleByManager,$nationalTeam,$showSkills)
    {
        switch ($dataSearch['requeteCustom']) 
        {
            case '1':
                $dataSearch['potentielMin'] = '11';
                $dataSearch['potentielMax'] = '11';
                $dataSearch['nationalite'] = '';
                break;
            case '2':
                $dataSearch['aVendre'] = '1';
                $dataSearch['nationalite'] = '';
                break;
            case '3':
                $dataSearch['caracConnues'] = '1';
                $dataSearch['nationalite'] = '';
                break;
            case '4':
                $dataSearch['botBientot'] = '1';
                $dataSearch['nationalite'] = '';
                break;
            case '5':
                $dataSearch['equipeNationale'] = 'A';
                $dataSearch['nationalite'] = '';
                break;
            case '6':
                $dataSearch['equipeNationale'] = 'U21';
                $dataSearch['nationalite'] = '';
                break;
            case '7':
                $dataSearch['aVendreByManager'] = '1';
                $dataSearch['nationalite'] = '';
                break;
            default:
                break;
        }
        
        $session->remove('dataSearch');
        $session->set('dataSearch', $dataSearch);
        
        $joueurs = $this->findJoueursNtScout($dataSearch,$forSale,$forSaleByManager,$nationalTeam,$showSkills);
        
        return $joueurs;
    }
    
    public function findJoueursNtScout($dataSearch,$forSale,$forSaleByManager,$nationalTeam,$showSkills)
    {
        $em = $this->getEntityManager();
        
        $nom = $dataSearch['nom'];
        $prenom = $dataSearch['prenom'];
        $ownerBbId = $dataSearch['ownerBbId'];
        $ageMin = $dataSearch['ageMin'];
        $ageMax = $dataSearch['ageMax'];
        $salaireMin = $dataSearch['salaireMin'];
        $salaireMax = $dataSearch['salaireMax'];
        $tailleMin = $dataSearch['tailleMin'];
        $tailleMax = $dataSearch['tailleMax'];
        $potentielMin = $dataSearch['potentielMin'];
        $potentielMax = $dataSearch['potentielMax'];
        $nationalite = $dataSearch['nationalite'];
        $pays = $dataSearch['pays'];
        $position = $dataSearch['position'];
        $dmiMin = $dataSearch['dmiMin'];
        $dmiMax = $dataSearch['dmiMax'];
        $blessure = $dataSearch['blessure'];
        $formeMin = $dataSearch['formeMin'];
        $formeMax = $dataSearch['formeMax'];
        if($nationalTeam == 'on')
        {
            $equipeNationale = $dataSearch['equipeNationale'];
        }
        if($forSale == 'on')
        {
            $aVendre = $dataSearch['aVendre'];
        }
        if($forSaleByManager == 'on')
        {
            $aVendreByManager = $dataSearch['aVendreByManager'];
        }
        if($showSkills == 'on')
        {
            $caracConnues = $dataSearch['caracConnues'];
        }
        $botBientot = $dataSearch['botBientot'];
        $draftId = $dataSearch['draftId'];
        $teamIdDraft = $dataSearch['teamIdDraft'];
        $tabId = $dataSearch['tabBbId'];
        
        $nbJourAlarmeBot = $em->getRepository('AppBundle:Configuration')->findOneBy(
            array(
                'idParam'=>'nbJourAlarmeBot',
            ));
        $nbJourAlarmeBotVal = $nbJourAlarmeBot->getValParam();
        
        $select = '
                SELECT 
                    j.nom, 
                    j.prenom, 
                    j.bbId, 
                    j.age, 
                    ttai.anglais as tailleAnglais, 
                    ttai.francais as tailleFrancais, 
                    j.proprietaireBbId,
                    j.proprietaireNom,
                    tpos.anglais as positionAnglais,
                    tpos.francais as positionFrancais,
                    j.potentiel,
                    tpot.anglais as potentielAnglais,
                    tpot.francais as potentielFrancais,
                    j.salaire,
                    j.derniereMaj,
                    j.nationalite,
                    p.nom as playIn,
                    j.dmi,
                    j.blessure,
                    j.forme,
                    tcar.anglais as formeAnglais,
                    tcar.francais as formeFrancais,
                    j.equipeNationale,
                    j.equipeU21,
                    j.aVendre,
                    j.derniereConnexion,
                    date_add(j.derniereConnexion,'.$nbJourAlarmeBotVal.',\'day\') as dateAlarmeBotification,
                    date_add(j.derniereConnexion,(50 - DayOfWeekTransco(j.derniereConnexion)),\'day\') as dateReelleBotification,
                    (SELECT jcarJs.js FROM AppBundle:JoueurCarac jcarJs WHERE jcarJs.bbId = j.bbId) as JS,
                    (SELECT jcarPs.ps FROM AppBundle:JoueurCarac jcarPs WHERE jcarPs.bbId = j.bbId) as PS,
                    (SELECT jcarDe.de FROM AppBundle:JoueurCarac jcarDe WHERE jcarDe.bbId = j.bbId) as DE,
                    (SELECT jcarAgi.agi FROM AppBundle:JoueurCarac jcarAgi WHERE jcarAgi.bbId = j.bbId) as AGI,
                    (SELECT jcarDri.dri FROM AppBundle:JoueurCarac jcarDri WHERE jcarDri.bbId = j.bbId) as DRI,
                    (SELECT jcarPa.pa FROM AppBundle:JoueurCarac jcarPa WHERE jcarPa.bbId = j.bbId) as PA,
                    (SELECT jcarSi.si FROM AppBundle:JoueurCarac jcarSi WHERE jcarSi.bbId = j.bbId) as SI,
                    (SELECT jcarDi.di FROM AppBundle:JoueurCarac jcarDi WHERE jcarDi.bbId = j.bbId) as DI,
                    (SELECT jcarReb.reb FROM AppBundle:JoueurCarac jcarReb WHERE jcarReb.bbId = j.bbId) as REB,
                    (SELECT jcarCo.co FROM AppBundle:JoueurCarac jcarCo WHERE jcarCo.bbId = j.bbId) as CO,
                    (SELECT jcarEnd.end FROM AppBundle:JoueurCarac jcarEnd WHERE jcarEnd.bbId = j.bbId) as ENDU,
                    (SELECT jcarLf.lf FROM AppBundle:JoueurCarac jcarLf WHERE jcarLf.bbId = j.bbId) as LF,
                    (SELECT jcarExp.exp FROM AppBundle:JoueurCarac jcarExp WHERE jcarExp.bbId = j.bbId) as EXP,
                    (SELECT jcarDateValid.dateMaj FROM AppBundle:JoueurCarac jcarDateValid WHERE jcarDateValid.bbId = j.bbId) as dateValide,
                    j.draftId,
                    j.teamIdDraft,
                    (SELECT jvbmResult.bbId FROM AppBundle:JoueurVenteByManager jvbmResult WHERE jvbmResult.bbId = j.bbId) as aVendreByManager';
        
        $from = '
                FROM 
                    AppBundle:JoueurNtScout j,
                    AppBundle:TranscoTaille ttai,
                    AppBundle:TranscoPosition tpos,
                    AppBundle:TranscoPotentiel tpot, 
                    AppBundle:TranscoCarac tcar,
                    AppBundle:Pays p ';
        
        $where = '
                WHERE 
                    j.taille = ttai.bbapi
                    AND
                    j.idPays = p.id
                    AND
                    j.potentiel = tpot.id
                    AND
                    j.forme = tcar.id
                    AND
                    j.meilleurPosition = tpos.anglais ';
        if($dataSearch == null)
        {
            $where .= ' AND 1 = 0 '; 
        }
        else
        {
            if($tabId == '')
            {
                $uneRecherche = new Recherche();
                $dateRecherche = new \DateTime();
                $criteresNoms = implode(',', array_keys($dataSearch));

                $criteresvaleurs =  implode(',', $dataSearch);
                $uneRecherche->setDateRecherche($dateRecherche);
                $uneRecherche->setCriteresNoms($criteresNoms);
                $uneRecherche->setCriteresValeurs($criteresvaleurs);
                $em->persist($uneRecherche);
                $em->flush();
            }
        }
        if($nom <> '')
        {
            $where .= ' AND j.nom LIKE :nom ';
        }
        if($prenom <> '')
        {
            $where .= ' AND j.prenom LIKE :prenom ';
        }
        if($ownerBbId <> '')
        {
            $where .= ' AND j.proprietaireBbId = :ownerBbId ';
        }
        if($ageMin <> '')
        {
            $where .= ' AND j.age >= :ageMin ';
        }
        if($ageMax <> '')
        {
            $where .= ' AND j.age <= :ageMax ';
        }
        if($salaireMin <> '')
        {
            $where .= ' AND j.salaire >= :salaireMin ';
        }
        if($salaireMax <> '')
        {
            $where .= ' AND j.salaire <= :salaireMax ';
        }
        if($tailleMin <> '')
        {
            $where .= ' AND j.taille >= :tailleMin ';
        }
        if($tailleMax <> '')
        {
            $where .= ' AND j.taille <= :tailleMax ';
        }
        if($potentielMin <> '')
        {
            $where .= ' AND j.potentiel >= :potentielMin ';
        }
        if($potentielMax <> '')
        {
            $where .= ' AND j.potentiel <= :potentielMax ';
        }
        if($nationalite <> '')
        {
            if($nationalite < 999)
            {
                $where .= ' AND j.nationalite LIKE :nationalite ';
            }
            else
            {
                $where .= ' AND j.nationalite IN (:listeNationalite) ';
            }
            
        }
        if($pays <> '')
        {
            if($pays < 999)
            {
                $where .= ' AND j.idPays LIKE :pays ';
            }
            else
            {
                $where .= ' AND j.idPays IN (:listePays) ';
            }
        }
        if($position <> '')
        {
            $where .= " AND j.meilleurPosition IN (:listePosition) ";
        }
        if($dmiMin <> '')
        {
            $where .= ' AND j.dmi >= :dmiMin ';
        }
        if($dmiMax <> '')
        {
            $where .= ' AND j.dmi <= :dmiMax ';
        }
        if($blessure <> '')
        {
            $where .= ' AND j.blessure ';
            if($blessure == '1')
            {
                $where .= ' >= ';
            }
            else
            {
                $where .= ' = ';
            }
            $where .= ' :blessure ';
        }
        if($formeMin <> '')
        {
            $where .= ' AND j.forme >= :formeMin ';
        }
        if($formeMax <> '')
        {
            $where .= ' AND j.forme <= :formeMax ';
        }
        if($nationalTeam == 'on')
        {
            if($equipeNationale <> '')
            {
                if($equipeNationale == 'A')
                {
                    $where .= ' AND j.equipeNationale = 1 ';
                }
                elseif($equipeNationale == 'U21')
                {
                    $where .= ' AND j.equipeU21 = 1 ';
                }
            }
        }
        if($forSale == 'on')
        {
            if($aVendre <> '')
            {
                $where .= ' AND j.aVendre = :aVendre ';
            }
        }
        if($forSaleByManager == 'on')
        {
            if($aVendreByManager <> '')
            {
                $where .= ' AND j.bbId ';
                if($aVendreByManager == '0')
                {
                    $where .= ' NOT IN ';
                }
                elseif($aVendreByManager == '1')
                {
                    $where .= ' IN ';
                }
                $where .= ' (SELECT jvbm.bbId FROM AppBundle:JoueurVenteByManager jvbm WHERE jvbm.bbId = j.bbId) ';
            }
        }
        if($showSkills == 'on')
        {
            if($caracConnues <> '')
            {
                $where .= ' AND j.bbId ';
                if($caracConnues == '0')
                {
                    $where .= ' NOT IN ';
                }
                elseif($caracConnues == '1')
                {
                    $where .= ' IN ';
                }
                $where .= ' (SELECT jcar.bbId FROM AppBundle:JoueurCarac jcar WHERE jcar.bbId = j.bbId) ';
            }
        }
        if($botBientot <> '')
        {
            $where .= ' AND CURRENT_DATE() ';
            if($botBientot == '1')
            {
                $where .= ' >= ';
            }
            else
            {
                $where .= ' < ';
            }
            $where .= ' DATE_ADD(j.derniereConnexion,'.$nbJourAlarmeBotVal.',\'day\') ';
        }
        if($draftId <> '')
        {
            $where .= ' AND j.draftId = :draftId ';
        }
        if($teamIdDraft <> '')
        {
            $where .= ' AND j.teamIdDraft = :teamIdDraft ';
        }
        if($tabId <> '')
        {
            $where .= " AND j.bbId IN (:tabId) ";
        }
        $order = ' ORDER BY j.equipeU21 DESC, j.equipeNationale DESC, j.salaire DESC ';
        
        //echo $select.$from.$where.$order;
        $query = $em->createQuery($select.$from.$where.$order);
        
        $parameters = array();
        if($nom <> '')
        {
            $parameters['nom'] = $nom;
        }
        if($prenom <> '')
        {
            $parameters['prenom'] = $prenom;
        }
        if($ownerBbId <> '')
        {
            $parameters['ownerBbId'] = $ownerBbId;
        }
        if($ageMin <> '')
        {
            $parameters['ageMin'] = $ageMin;
        }
        if($ageMax <> '')
        {
            $parameters['ageMax'] = $ageMax;
        }
        if($salaireMin <> '')
        {
            $parameters['salaireMin'] = $salaireMin;
        }
        if($salaireMax <> '')
        {
            $parameters['salaireMax'] = $salaireMax;
        }
        if($tailleMin <> '')
        {
            $objTaille = $em->getRepository('AppBundle:TranscoTaille')->find($tailleMin);
            $parameters['tailleMin'] = $objTaille->getBBapi();
        }
        if($tailleMax <> '')
        {
            $objTaille = $em->getRepository('AppBundle:TranscoTaille')->find($tailleMax);
            $parameters['tailleMax'] = $objTaille->getBBapi();
        }
        if($potentielMin <> '')
        {
            $parameters['potentielMin'] = $potentielMin;
        }
        if($potentielMax <> '')
        {
            $parameters['potentielMax'] = $potentielMax;
        }
        if($nationalite <> '')
        {
            if($nationalite < 999)
            {
                $objNationalite = $em->getRepository('AppBundle:Nationalite')->find($nationalite);
                $parameters['nationalite'] = $objNationalite->getLibelle();
            }
            else
            {
                $objConfederationPaysNat = $em->getRepository('AppBundle:ConfederationPaysNat')->findByIdConfederation($nationalite);
                $listeNationalite = array();
                foreach($objConfederationPaysNat as $uneConfederationPaysNat)
                {
                    if($uneConfederationPaysNat->getBbIdPaysnat() < 100) //cas particulier fusion pays
                    {
                        $objNationalite = $em->getRepository('AppBundle:Nationalite')->findOneByBbId($uneConfederationPaysNat->getBbIdPaysnat());
                        $listeNationalite[] = $objNationalite->getLibelle();
                    }
                }
                $parameters['listeNationalite'] = $listeNationalite;
            }
        }
        if($pays <> '')
        {
            if($pays < 999)
            {
                $parameters['pays'] = $pays;
            }
            else
            {
                $objConfederationPaysNat = $em->getRepository('AppBundle:ConfederationPaysNat')->findByIdConfederation($pays);
                $listePays = array();
                foreach($objConfederationPaysNat as $uneConfederationPaysNat)
                {
                    $listePays[] = $uneConfederationPaysNat->getBbIdPaysnat();
                }
                $parameters['listePays'] = $listePays;
            }
        }
        if($position <> '')
        {
            $tabPosition = explode('_',$position);
            $listePosition = array();
            foreach($tabPosition as $unePosition)
            {
                $objPosition = $em->getRepository('AppBundle:TranscoPosition')->find($unePosition);
                $listePosition[] = $objPosition->getAnglais();
            }
            $parameters['listePosition'] = $listePosition;
        }
        if($dmiMin <> '')
        {
            $parameters['dmiMin'] = $dmiMin;
        }
        if($dmiMax <> '')
        {
            $parameters['dmiMax'] = $dmiMax;
        }
        if($blessure <> '')
        {
            $parameters['blessure'] = $blessure;
        }
        if($formeMin <> '')
        {
            $parameters['formeMin'] = $formeMin;
        }
        if($formeMax <> '')
        {
            $parameters['formeMax'] = $formeMax;
        }
        if($forSale == 'on')
        {
            if($aVendre <> '')
            {
                $parameters['aVendre'] = $aVendre;
            }
        }
        if($draftId <> '')
        {
            $parameters['draftId'] = $draftId->getId();
        }
        if($teamIdDraft <> '')
        {
            $parameters['teamIdDraft'] = $teamIdDraft;
        }
        if($tabId <> '')
        {
            $tabIdFinal = array();
            foreach($tabId as $unId => $uneVal)
            {
                $tabIdFinal[] = $unId;
            }
            $parameters['tabId'] = $tabIdFinal;
        }
        $query->setParameters($parameters);
        
        $joueurs = $query->getResult();

        return $joueurs;
    }
}