<?php

namespace AppBundle\Repository;

use Doctrine\ORM\EntityRepository;

class JoueurRepository extends EntityRepository
{
    public function findJoueurs($dataSearch)
    {
        $draftId = $dataSearch['draftId'];
        $nom = $dataSearch['nom'];
        $prenom = $dataSearch['prenom'];
        $bbId = $dataSearch['bbId'];
        
        $em = $this->getEntityManager();
        
        $select = '
                SELECT 
                    j.nom, 
                    j.prenom, 
                    j.bbId, 
                    j.draftId,
                    j.age, 
                    ttai.anglais as tailleAnglais, 
                    ttai.francais as tailleFrancais, 
                    j.proprietaireBbId,
                    j.proprietaireNom,
                    tpos.francais as positionFrancais,
                    j.potentiel,
                    tpot.anglais as potentielAnglais,
                    tpot.francais as potentielFrancais,
                    j.salaire ';
        
        $from = '
                FROM 
                    AppBundle:Joueur j,
                    AppBundle:TranscoTaille ttai,
                    AppBundle:TranscoPosition tpos,
                    AppBundle:TranscoPotentiel tpot ';
        
        $where = '
                WHERE 
                    j.taille = ttai.bbapi
                    AND
                    j.potentiel = tpot.id
                    AND
                    j.meilleurPosition = tpos.anglais ';
        if($dataSearch == null)
        {
            $where .= ' AND 1 = 0 '; 
        }
        if($draftId <> '')
        {
            $where .= ' AND j.draftId = :draftId ';
        }
        if($nom <> '')
        {
            $where .= ' AND j.nom LIKE :nom ';
        }
        if($prenom <> '')
        {
            $where .= ' AND j.prenom LIKE :prenom ';
        }
        if($bbId <> '')
        {
            $where .= ' AND j.bbId = :bbId ';
        }
        
        $order = '
                ORDER BY
                    j.draftId,
                    j.age,
		    tpos.id,
                    j.taille,
                    j.nom,
                    j.prenom
                    ASC';
        
        $query = $em->createQuery($select.$from.$where.$order);
        if($draftId <> '')
        {
            $query->setParameter('draftId', $draftId);
        }
        if($nom <> '')
        {
            $query->setParameter('nom', $nom);
        }
        if($prenom <> '')
        {
            $query->setParameter('prenom', $prenom);
        }
        if($bbId <> '')
        {
            $query->setParameter('bbId', $bbId);
        }
        $joueurs = $query->getResult();
        
        return $joueurs;
    }
}