<?php

namespace AppBundle\Repository;

use AppBundle\Entity\MatchJoueur;
use Doctrine\ORM\EntityRepository;

class MatchJoueurRepository extends EntityRepository
{
    public function create($unMatch,$idTeam,$typeEquipe,$objJoueur)
    {
        $em = $this->getEntityManager();

        $idMatch = $unMatch->getId();
        $dateMatch = $unMatch->getDateMatch();
        
        $forme = $em->getRepository('AppBundle:EvolutionFormeDmi')->getForme($objJoueur->bbId,$dateMatch);
        
        $unJoueur = new MatchJoueur();
        $unJoueur->setIdMatch($idMatch);
        $unJoueur->setIdTeam($idTeam);
        $unJoueur->setTypeEquipe($typeEquipe);
        $unJoueur->setBbId($objJoueur->bbId);
        $unJoueur->setName($objJoueur->name);
        $unJoueur->setForme($forme);
        $unJoueur->setPosition($objJoueur->position);
        $unJoueur->setMinutes($objJoueur->minutes);
        $tab = explode('-',$objJoueur->fg);
        if($tab[0] == '')
        {
            $tab[0] = null;
        }
        $unJoueur->setFg($tab[0]);
        $unJoueur->setFgTotal($tab[1]);
        $tab = explode('-',$objJoueur->threepts);
        if($tab[0] == '')
        {
            $tab[0] = null;
        }
        $unJoueur->setThreePts($tab[0]);
        $unJoueur->setThreePtsTotal($tab[1]);
        $tab = explode('-',$objJoueur->ft);
        if($tab[0] == '')
        {
            $tab[0] = null;
        }
        $unJoueur->setFt($tab[0]);
        $unJoueur->setFtTotal($tab[1]);
        $unJoueur->setPlusMinus($objJoueur->plusminus);
        $unJoueur->setOffReb($objJoueur->offreb);
        if($objJoueur->totreb == null)
        {
            $unJoueur->setDefReb(null);
        }
        else
        {
            $unJoueur->setDefReb($objJoueur->totreb - $objJoueur->offreb);
        }
        $unJoueur->setTotReb($objJoueur->totreb);
        $unJoueur->setAssists($objJoueur->assists);
        $unJoueur->setTurnover($objJoueur->to);
        $unJoueur->setSteals($objJoueur->steals);
        $unJoueur->setBlocks($objJoueur->blocks);
        $unJoueur->setFouls($objJoueur->fouls);
        $unJoueur->setPoints($objJoueur->points);
        $unJoueur->setRating($objJoueur->rating);
        $em->persist($unJoueur);
        $em->flush();
        
        return $unJoueur;
    }   
}