<?php

namespace AppBundle\Repository;

use Doctrine\ORM\EntityRepository;

class PaysNbUsersRepository extends EntityRepository
{
    public function getNbAllUserLast()
    {
        $em = $this->getEntityManager();
        $requete = "SELECT MAX(ToDate(SUBSTR(p.dateInfo,1,10),'%d/%m/%Y')) as lastLaunch FROM AppBundle:PaysNbUsers p";
        $query = $em->createQuery($requete);
        $result = $query->getResult();
        $lastLaunch = $result[0];
        $tabDate = explode('-' , $lastLaunch['lastLaunch']);
        $lastLaunch  = $tabDate[2].'/'.$tabDate[1].'/'.$tabDate[0];
        
        $requete = "SELECT SUM(p.nbUserActifs) as nbUsers FROM AppBundle:PaysNbUsers p WHERE SUBSTR(p.dateInfo,1,10) = :lastLaunch AND p.bbId NOT IN (:bbIdUtopia)";
        $parameters = array();
        $parameters['lastLaunch'] =  $lastLaunch;
        $parameters['bbIdUtopia'] =  '99';
        $query = $em->createQuery($requete);
        $query->setParameters($parameters);
        $result = $query->getResult();
        $nbUsers = $result[0];
        
        $tabRetour = array();
        $tabRetour['description'] = 'Number of users active on '.$lastLaunch ;
        $tabRetour['valeur'] = $nbUsers['nbUsers'];
        
        return $tabRetour;
    }
    
    public function getNbAllUserEvol($pays)
    {
        $em = $this->getEntityManager();
        $requete = "SELECT DISTINCT(ToDate(SUBSTR(p.dateInfo,1,10),'%d/%m/%Y')) as dateInfo FROM AppBundle:PaysNbUsers p ORDER BY ToDate(SUBSTR(p.dateInfo,1,10),'%d/%m/%Y') DESC";
        $query = $em->createQuery($requete);
        $result = $query->getResult();
        
        $tabRetour = array();
        foreach($result as $unResult)
        {
            $tabDate = explode('-' , $unResult['dateInfo']);
            $dateInfo = $tabDate[2].'/'.$tabDate[1].'/'.$tabDate[0];

            $requete = "SELECT SUM(p.nbUserActifs) as nbUsers FROM AppBundle:PaysNbUsers p WHERE SUBSTR(p.dateInfo,1,10) = :dateInfo AND p.bbId NOT IN (:bbIdUtopia)";
            if($pays <> 'all')
            {
                if($pays < 999)
                {
                    $requete .= ' AND p.bbId LIKE :pays ';
                }
                else
                {
                    $requete .= ' AND p.bbId IN (:listePays) ';
                }
            }
            
            $parameters = array();
            $parameters['dateInfo'] =  $dateInfo;
            $parameters['bbIdUtopia'] =  '99';
            if($pays <> 'all')
            {
                if($pays < 999)
                {
                    $parameters['pays'] = $pays;
                }
                else
                {
                    $objConfederationPaysNat = $em->getRepository('AppBundle:ConfederationPaysNat')->findByIdConfederation($pays);
                    $listePays = array();
                    foreach($objConfederationPaysNat as $uneConfederationPaysNat)
                    {
                        $listePays[] = $uneConfederationPaysNat->getBbIdPaysnat();
                    }
                    $parameters['listePays'] = $listePays;
                }
            }
            $query = $em->createQuery($requete);
            $query->setParameters($parameters);
            $result = $query->getResult();
            $nbUsers = $result[0];
            
            $tabRetour[] = $dateInfo." => ".$nbUsers['nbUsers'];
        }

        return $tabRetour;
    }
}