<?php

namespace AppBundle\Repository;

use AppBundle\Entity\Roster;
use AppBundle\Entity\AccountJoueurCarac;
use AppBundle\Entity\AccountJoueurPosition;
use AppBundle\Entity\AccountJoueur;

use Doctrine\ORM\EntityRepository;

class RosterRepository extends EntityRepository
{
    public function copyMovePersoToRoster($type,$user,$session,$bbId,$idRoster,$idRosterDestination)
    {
        $em = $this->getEntityManager();
        
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        $idAccount = $infoUser->getId();
        
        $unRosterOrigine = $em->getRepository('AppBundle:Roster')->findOneBy(
            array(
                'id'=>$idRoster,
                'idAccount'=>$idAccount,
            ));
        
        $unRosterDestination = $em->getRepository('AppBundle:Roster')->findOneBy(
            array(
                'id'=>$idRosterDestination,
                'idAccount'=>$idAccount,
            ));
        
        if($unRosterOrigine && $unRosterDestination)
        {
            $unAccountJoueurOrigine = $em->getRepository('AppBundle:AccountJoueur')->findOneBy(
                array(
                    'idAccount' => $idAccount,
                    'bbId' => $bbId,
                    'idRoster' => $idRoster,
                )
            );
            
            $unAccountJoueurDestination = $em->getRepository('AppBundle:AccountJoueur')->findOneBy(
                array(
                    'idAccount' => $idAccount,
                    'bbId' => $bbId,
                    'idRoster' => $idRosterDestination,
                )
            );

            if($unAccountJoueurOrigine)
            {
                if($unAccountJoueurDestination)
                {
                    $messageAccountError = ucfirst($type)." unsuccessfull. Player allready in the destination roster.";
                    $session->set('messageAccountError',$messageAccountError);
                }
                else
                {
                    $unAccountJoueurDestination = new AccountJoueur();
                    $unAccountJoueurDestination->setIdAccount($idAccount);
                    $unAccountJoueurDestination->setIdRoster($idRosterDestination);
                    $unAccountJoueurDestination->setBbId($bbId);
                    $em->persist($unAccountJoueurDestination);
                    
                    $unAccountJoueurCaracOrigine = $em->getRepository('AppBundle:AccountJoueurCarac')->findOneBy(
                        array(
                            'idAccount' => $idAccount,
                            'bbId' => $bbId,
                            'idRoster' => $idRoster,
                        )
                    );

                    $js = $unAccountJoueurCaracOrigine->getJs();
                    $ps = $unAccountJoueurCaracOrigine->getPs();
                    $de = $unAccountJoueurCaracOrigine->getDe();
                    $agi = $unAccountJoueurCaracOrigine->getAgi();
                    $dri = $unAccountJoueurCaracOrigine->getDri();
                    $pa = $unAccountJoueurCaracOrigine->getPa();
                    $si = $unAccountJoueurCaracOrigine->getSi();
                    $di = $unAccountJoueurCaracOrigine->getDi();
                    $reb = $unAccountJoueurCaracOrigine->getReb();
                    $co = $unAccountJoueurCaracOrigine->getCo();
                    $end = $unAccountJoueurCaracOrigine->getEnd();
                    $lf = $unAccountJoueurCaracOrigine->getLf();
                    $exp = $unAccountJoueurCaracOrigine->getExp();
                    $commentaire = $unAccountJoueurCaracOrigine->getCommentaire();

                    $unAccountJoueurCaracDestination = new AccountJoueurCarac();
                    $unAccountJoueurCaracDestination->setIdAccount($idAccount);
                    $unAccountJoueurCaracDestination->setIdRoster($idRosterDestination);
                    $unAccountJoueurCaracDestination->setBbId($bbId);
                    $unAccountJoueurCaracDestination->setJs($js);
                    $unAccountJoueurCaracDestination->setPs($ps);
                    $unAccountJoueurCaracDestination->setDe($de);
                    $unAccountJoueurCaracDestination->setAgi($agi);
                    $unAccountJoueurCaracDestination->setDri($dri);
                    $unAccountJoueurCaracDestination->setPa($pa);
                    $unAccountJoueurCaracDestination->setSi($si);
                    $unAccountJoueurCaracDestination->setDi($di);
                    $unAccountJoueurCaracDestination->setReb($reb);
                    $unAccountJoueurCaracDestination->setCo($co);
                    $unAccountJoueurCaracDestination->setEnd($end);
                    $unAccountJoueurCaracDestination->setLf($lf);
                    $unAccountJoueurCaracDestination->setExp($exp);
                    $unAccountJoueurCaracDestination->setCommentaire($commentaire);

                    $tabCarac = array($js,$ps,$de,$agi,$dri,$pa,$si,$di,$reb,$co,$end,$lf,$exp);
                    $unAccountJoueurCaracDestination = $em->getRepository('AppBundle:AccountJoueurCarac')->calculScore($bbId,$unAccountJoueurCaracDestination,$tabCarac);

                    $em->persist($unAccountJoueurCaracDestination);
                    
                    if($type == 'move')
                    {
                        $em->remove($unAccountJoueurOrigine);
                        $em->remove($unAccountJoueurCaracOrigine);
                    }
                    
                    $em->flush();

                    $messageAccountSuccess = ucfirst($type)." successfull.";
                    $session->set('messageAccountSuccess',$messageAccountSuccess);
                }
            }
        }
    }
    
    public function updateRoster($user,$nomRoster,$idRoster,$session)
    {
        $em = $this->getEntityManager();
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
            array(
                'id'=>$idRoster,
                'idAccount'=>$infoUser->getId(),
            ));
        
        if($unRoster)
        {
            $unAutreRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
                array(
                    'nom'=>$nomRoster,
                    'idAccount'=>$infoUser->getId(),
                ));
            if($unAutreRoster)
            {
                $messageError = 'Roster Name already existing';
                $session->set('messageAccountError',$messageError);
            }
            else
            {
                $messageAccountSuccess = "Name changed";
                $session->set('messageAccountSuccess',$messageAccountSuccess);    
                
                $unRoster->setNom($nomRoster);
                $em->persist($unRoster);
                $em->flush();
            }
        }
    }     
    
    public function deleteRoster($idRoster,$user)
    {
        $em = $this->getEntityManager();
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
            array(
                'id'=>$idRoster,
                'idAccount'=>$infoUser->getId(),
            ));
        
        if($unRoster)
        {
            $tabAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findBy(
            array(
                'idRoster'=>$idRoster,
                'idAccount'=>$infoUser->getId(),
            )); 
            foreach($tabAccountJoueur as $unAccountJoueur)
            {
                $em->remove($unAccountJoueur);
            }
            
            $tabAccountJoueurPosition = $em->getRepository('AppBundle:AccountJoueurPosition')->findBy(
            array(
                'idRoster'=>$idRoster,
                'idAccount'=>$infoUser->getId(),
            )); 
            foreach($tabAccountJoueurPosition as $unAccountJoueurPosition)
            {
                $em->remove($unAccountJoueurPosition);
            }
            
            $tabAccountJoueurCarac = $em->getRepository('AppBundle:AccountJoueurCarac')->findBy(
            array(
                'idRoster'=>$idRoster,
                'idAccount'=>$infoUser->getId(),
            )); 
            foreach($tabAccountJoueurCarac as $unAccountJoueurCarac)
            {
                $em->remove($unAccountJoueurCarac);
            }
            
            $unRosterShare = $em->getRepository('AppBundle:RosterShare')->findOneBy(
                array(
                    'id'=>$idRoster,
                    'idAccountOwner'=>$infoUser->getId(),
                ));
                        
            if(is_object($unRosterShare))
            {
                $em->remove($unRosterShare);
            }
            
            $em->remove($unRoster);
            $em->flush();
        }
        else
        {
            echo "Not your roster...";
            die();
        }
    }
    
    public function resetSelection($user,$idRoster)
    {
        $em = $this->getEntityManager();

        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        $tabAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findBy(
            array(
                'idRoster'=>$idRoster,
                'idAccount'=>$infoUser->getId(),
            )); 
        
        if($tabAccountJoueur)
        {
            foreach($tabAccountJoueur as $unAccountJoueur)
            {
                $em->getRepository('AppBundle:AccountJoueur')->remove($user,$unAccountJoueur->getBbId(),$idRoster);
            }
        }     
    }

    public function removeFromPosition($position,$session,$user)
    {
        $em = $this->getEntityManager();
         
        $idRoster = $session->get('idRoster');
        
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        
        $unAccountJoueurPosition = $em->getRepository('AppBundle:AccountJoueurPosition')->findOneBy(
            array(
                'position'=>$position,
                'idAccount'=>$infoUser->getId(),
                'idRoster' => $idRoster,
            ));
        
        if($unAccountJoueurPosition)
        {
            $em->remove($unAccountJoueurPosition);
            $em->flush();
        }
    }
    
    public function removeFromRoster($bbId,$user,$idRoster)
    {
        $em = $this->getEntityManager();
         
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        
        $tabAccountJoueurPosition = $em->getRepository('AppBundle:AccountJoueurPosition')->findBy(
            array(
                'idAccount'=>$infoUser->getId(),
                'bbId'=>$bbId,
                'idRoster'=>$idRoster,
            ));
        
        if($tabAccountJoueurPosition)
        {
            foreach($tabAccountJoueurPosition as $unAccountJoueurPosition)
            {
                $em->remove($unAccountJoueurPosition);
                $em->flush();
            }
        }
    }
    
    public function addPersoToRoster($bbId,$position,$idRoster,$user)
    {
        $em = $this->getEntityManager();
                 
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        
        if($position == 'pool')
        {
            $this->removeFromRoster($bbId,$user,$idRoster);
        }
        else
        {
            $this->removeFromPool($bbId,$user,$idRoster);
        }
        
        $unAccountJoueurPosition = $em->getRepository('AppBundle:AccountJoueurPosition')->findOneBy(
            array(
                'position'=>$position,
                'idAccount'=>$infoUser->getId(),
                'bbId'=>$bbId,
                'idRoster' => $idRoster,
            ));
        
        if($unAccountJoueurPosition)
        {
            //rien
        }
        else
        {
            $unAccountJoueurPosition = new AccountJoueurPosition();
            $unAccountJoueurPosition->setIdAccount($infoUser->getId());
            $unAccountJoueurPosition->setBbId($bbId);
            $unAccountJoueurPosition->setPosition($position);
            $unAccountJoueurPosition->setIdRoster($idRoster);
            $em->persist($unAccountJoueurPosition);
            $em->flush();
        }
    }
    
    public function removeFromPool($bbId,$user,$idRoster)
    {
        $em = $this->getEntityManager();
         
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        
        $unAccountJoueurPosition = $em->getRepository('AppBundle:AccountJoueurPosition')->findOneBy(
            array(
                'position'=>'pool',
                'idAccount'=>$infoUser->getId(),
                'bbId'=>$bbId,
                'idRoster'=>$idRoster,
            ));
        
        if($unAccountJoueurPosition)
        {
            $em->remove($unAccountJoueurPosition);
            $em->flush();
        }
    }
    
    public function exportRosterCsv($session,$user)
    {
        \ini_set('memory_limit', '2048M');
        $em = $this->getEntityManager();
        
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        $idAccount = $infoUser->getId();
        $idRoster = $session->get('idRoster');
        $lectureSeule = $session->get('lectureSeule');
        
        $forSale = $em->getRepository('AppBundle:Configuration')->findOneBy(
          array(
              'idParam'=>'forSale',
          ));
        $forSaleVal = $forSale->getValParam();
        $forSaleByManager = $em->getRepository('AppBundle:Configuration')->findOneBy(
          array(
              'idParam'=>'forSaleByManager',
          ));
        $forSaleByManagerVal = $forSaleByManager->getValParam();
        $nationalTeam = $em->getRepository('AppBundle:Configuration')->findOneBy(
          array(
              'idParam'=>'nationalTeam',
          ));
        $nationalTeamVal = $nationalTeam->getValParam();

        if($lectureSeule == 'off')
        {
            $tabAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findBy(
                array(
                    'idRoster'=>$idRoster,
                    'idAccount'=>$infoUser->getId(),
                ));
        }
        else
        {
            $tabAccountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findBy(
                array(
                    'idRoster'=>$idRoster,
                ));
        }
        $tabRosterGeneration = array();
        if($tabAccountJoueur)
        {
            foreach($tabAccountJoueur as $unAccountJoueur)
            {
                $tabRosterGeneration[$unAccountJoueur->getBbId()] = 'on';
            }
        }
        
        $dataSearch = array();
        $dataSearch['nom'] = '';
        $dataSearch['prenom'] = '';
        $dataSearch['ownerBbId'] = '';
        $dataSearch['pays'] = '';
        $dataSearch['blessure'] = '';
        $dataSearch['paysLancement'] = '';
        $dataSearch['ageMin'] = '';
        $dataSearch['ageMax'] = '';
        $dataSearch['salaireMin'] = '';
        $dataSearch['salaireMax'] = '';
        $dataSearch['tailleMin'] = '';
        $dataSearch['tailleMax'] = '';
        $dataSearch['potentielMin'] = '';
        $dataSearch['potentielMax'] = '';
        $dataSearch['pays'] = '';
        $dataSearch['nationalite'] = '';
        $dataSearch['position'] = '';
        $dataSearch['dmiMin'] = '';
        $dataSearch['dmiMax'] = '';
        $dataSearch['formeMin'] = '';
        $dataSearch['formeMax'] = '';
        $dataSearch['requeteCustom'] = '';
        $dataSearch['equipeNationale'] = '';
        $dataSearch['caracConnues'] = '';
        $dataSearch['botBientot'] = '';
        $dataSearch['aVendre'] = '';
        $dataSearch['draftId'] = '';
        $dataSearch['teamIdDraft'] = '';
        $dataSearch['aVendreByManager'] = ''; 
        $dataSearch['tabBbId'] = $tabRosterGeneration;
          
        if(count($tabRosterGeneration) > 0)
        {
            $joueurs = $em->getRepository('AppBundle:JoueurNtScout')->findJoueursNtScout(
                $dataSearch,
                $forSaleVal,
                $forSaleByManagerVal,
                $nationalTeamVal,
                'off'
                );
        }
        else
        {
            $joueurs = null;
        }

        if($lectureSeule == 'off')
        {
            $tabAccountJoueurPosition = $em->getRepository('AppBundle:AccountJoueurPosition')->findBy(
                array(
                    'idRoster'=>$idRoster,
                    'idAccount'=>$idAccount,
                )); 
        }
        else
        {
            $tabAccountJoueurPosition = $em->getRepository('AppBundle:AccountJoueurPosition')->findBy(
                array(
                    'idRoster'=>$idRoster,
                )); 
        }
        $tabNomJoueur = array();
        $tabNomJoueurPool = array();
        foreach($tabAccountJoueurPosition as $unAccountJoueurPosition)
        {
            $nomJoueur = $em->getRepository('AppBundle:JoueurNtScout')->findOneByBbId($unAccountJoueurPosition->getBbId());
            if($unAccountJoueurPosition->getPosition() <> 'pool')
            {
                $tabNomJoueur[$unAccountJoueurPosition->getPosition()] = $nomJoueur;
            }
            else
            {
                $tabNomJoueurPool[] = $nomJoueur;
            }
        }

        $connexionOk = $em->getRepository('AppBundle:Account')->connexionOk($user);
        $tabCaracJoueur = array();
        if($connexionOk == 'oui')
        {
            foreach($joueurs as $unJoueur)
            {
                if($lectureSeule == 'off')
                {
                    $accountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findOneBy(
                        array(
                            'idAccount' => $idAccount,
                            'bbId' => $unJoueur['bbId'],
                            'idRoster' => $idRoster,
                        )
                    );

                    if($accountJoueur)
                    {
                        $accountJoueurCarac = $em->getRepository('AppBundle:AccountJoueurCarac')->findOneBy(
                            array(
                                'idAccount' => $idAccount,
                                'bbId' => $unJoueur['bbId'],
                                'idRoster' => $idRoster,
                            )
                        );

                        $tabCaracJoueur[$unJoueur['bbId']] = $accountJoueurCarac;
                    }
                    else
                    {
                        $tabCaracJoueur[$unJoueur['bbId']] = '';
                    }
                }
                else
                {
                    $accountJoueur = $em->getRepository('AppBundle:AccountJoueur')->findOneBy(
                        array(
                            'bbId' => $unJoueur['bbId'],
                            'idRoster' => $idRoster,
                        )
                    );

                    if($accountJoueur)
                    {
                        $accountJoueurCarac = $em->getRepository('AppBundle:AccountJoueurCarac')->findOneBy(
                            array(
                                'bbId' => $unJoueur['bbId'],
                                'idRoster' => $idRoster,
                            )
                        );

                        $tabCaracJoueur[$unJoueur['bbId']] = $accountJoueurCarac;
                    }
                    else
                    {
                        $tabCaracJoueur[$unJoueur['bbId']] = '';
                    }
                }
            }
        }
        else
        {
            $tabCaracJoueur = null;
        }
       
        $handle = fopen('php://memory', 'r+');
        
        if($lectureSeule == 'off')
        {
            $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
                array(
                    'id'=>$idRoster,
                    'idAccount'=>$idAccount,
                ));
        }
        else
        {
            $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
                array(
                    'id'=>$idRoster,
                ));
        }
        fputcsv(
            $handle, 
            array(
                'NTSO Name : ',
                $unRoster->getNom(),
            ),
            ';');
        
        if($lectureSeule == 'off')
        {
            fputcsv(
                $handle, 
                array(
                    'NTSO Key : ',
                    $unRoster->getClefNtso(),
                ),
                ';');
        }
        fputcsv(
            $handle, 
            array(
            ),
            ';');
        
        if($tabCaracJoueur)
        {
            fputcsv(
                $handle, 
                array(
                    'Injury',
                    'For Sale',
                    'Name',
                    'First Name',
                    'Buzzer Beater Id',
                    'Age',
                    'Height Feets Inches',
                    'Height Centimeters',
                    'Potential',
                    'Salary',
                    'Best Position',
                    'Dmi',
                    'Game Shape',
                    'JS','JR','OD','HA','DR','PA','IS','ID','RB','SB','ST','FT','XP','Outside','Small F.','Inside', 	
                    'BB Link',
                ),
                ';');
        }
        else
        {
            fputcsv(
                $handle, 
                array(
                    'Injury',
                    'For Sale',
                    'Name',
                    'First Name',
                    'Buzzer Beater Id',
                    'Age',
                    'Height Feets Inches',
                    'Height Centimeters',
                    'Potential',
                    'Salary',
                    'Best Position',
                    'Dmi',
                    'Game Shape',
                    'BB Link',
                ),
                ';');
        }
        
        foreach ($joueurs as $unJoueur) {

            $tabData = array();
            $tabData[] = $unJoueur['aVendre'];
            $tabData[] = $unJoueur['blessure'];
            $tabData[] = $unJoueur['nom'];
            $tabData[] = $unJoueur['prenom'];
            $tabData[] = $unJoueur['bbId'];
            $tabData[] = $unJoueur['age'];
            $tabData[] = $unJoueur['tailleAnglais'];
            $tabData[] = $unJoueur['tailleFrancais'];
            $tabData[] = $unJoueur['potentiel'];
            $tabData[] = $unJoueur['salaire'];
            $tabData[] = $unJoueur['positionAnglais'];
            $tabData[] = $unJoueur['dmi'];
            $tabData[] = $unJoueur['forme']; 
                
            if($tabCaracJoueur)
            {
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getJs();
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getPs();
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getDe();
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getAgi();
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getDri();
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getPa();
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getSi();
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getDi();
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getReb();
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getCo();
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getEnd();
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getLf();
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getExp();
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getScoreExt();
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getScoreAs();
                $tabData[] = $tabCaracJoueur[$unJoueur['bbId']]->getScoreInt();
            }
            $tabData[] = "http://www.buzzerbeater.com/player/".$unJoueur['bbId']."/overview.aspx";
            
            fputcsv(
               $handle, // The file pointer
               $tabData,
               ';');
        }

        fputcsv(
            $handle, 
            array(
            ),
            ';');
        
        fputcsv(
            $handle, 
            array(
                '',
                'Starter',
                'Substitute',
                'Reservist',
            ),
            ';');

        $pos1 = $this->nomJoueurPosition($tabNomJoueur,'mTit');
        $pos2 = $this->nomJoueurPosition($tabNomJoueur,'mRem');
        $pos3 = $this->nomJoueurPosition($tabNomJoueur,'mRes');
        fputcsv(
            $handle, 
            array(
                'PG',
                $pos1,
                $pos2,
                $pos3,
            ),
            ';');
        $pos1 = $this->nomJoueurPosition($tabNomJoueur,'arTit');
        $pos2 = $this->nomJoueurPosition($tabNomJoueur,'arRem');
        $pos3 = $this->nomJoueurPosition($tabNomJoueur,'arRes');
        fputcsv(
            $handle, 
            array(
                'SG',
                $pos1,
                $pos2,
                $pos3,
            ),
            ';');
        $pos1 = $this->nomJoueurPosition($tabNomJoueur,'asTit');
        $pos2 = $this->nomJoueurPosition($tabNomJoueur,'asRem');
        $pos3 = $this->nomJoueurPosition($tabNomJoueur,'asRes');
        fputcsv(
            $handle, 
            array(
                'SF',
                $pos1,
                $pos2,
                $pos3,
            ),
            ';');
        $pos1 = $this->nomJoueurPosition($tabNomJoueur,'afTit');
        $pos2 = $this->nomJoueurPosition($tabNomJoueur,'afRem');
        $pos3 = $this->nomJoueurPosition($tabNomJoueur,'afRes');
        fputcsv(
            $handle, 
            array(
                'PF',
                $pos1,
                $pos2,
                $pos3,
            ),
            ';');
        $pos1 = $this->nomJoueurPosition($tabNomJoueur,'pTit');
        $pos2 = $this->nomJoueurPosition($tabNomJoueur,'pRem');
        $pos3 = $this->nomJoueurPosition($tabNomJoueur,'pRes');
        fputcsv(
            $handle, 
            array(
                'C',
                $pos1,
                $pos2,
                $pos3,
            ),
            ';');
        
        fputcsv(
            $handle, 
            array(
            ),
            ';');
        
        fputcsv(
            $handle, 
            array(
                'Pool',
            ),
            ';');
        foreach ($tabNomJoueurPool as $unJoueur) {

            $tabData = array();
            $tabData[] = '';
            $tabData[] = $unJoueur->getNom();

            fputcsv(
               $handle, // The file pointer
               $tabData,
               ';');
        }

        rewind($handle);
        $content = stream_get_contents($handle);
        fclose($handle);

        return $content;
    }
    
    public function nomJoueurPosition($tabNomJoueur,$position)
    {
        $nom = '';
        if (array_key_exists($position, $tabNomJoueur)) {
            $nom = $tabNomJoueur[$position]->getNom();
        }
        return $nom;
    }
}