<?php

namespace AppBundle\Repository;

use AppBundle\Entity\RosterShare;

use Doctrine\ORM\EntityRepository;

class RosterShareRepository extends EntityRepository
{
    public function shareListByMe($idOwner)
    {
        $em = $this->getEntityManager();
        
        $tabRosterShare = $em->getRepository('AppBundle:RosterShare')->findByIdAccountOwner($idOwner);
        
        $tabRetour = array();
        foreach($tabRosterShare as $unRosterShare)
        {            
            $unAccount = $em->getRepository('AppBundle:Account')->find($unRosterShare->getIdAccountShare());
            
            $tabRetour[] = array(
              'idRoster' => $unRosterShare->getIdRoster(),
              'accountShared'  => $unAccount,
            );
        }
                
        return $tabRetour;
    }

    public function shareListForMe($idUser)
    {
        $em = $this->getEntityManager();
        
        $tabRosterShare = $em->getRepository('AppBundle:RosterShare')->findByIdAccountShare($idUser);
        
        $tabRetour = array();
        foreach($tabRosterShare as $unRosterShare)
        {            
            $unAccount = $em->getRepository('AppBundle:Account')->find($unRosterShare->getIdAccountOwner());
            
            $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
                    array(
                        'id'=>$unRosterShare->getIdRoster(),
                        'idAccount'=>$unRosterShare->getIdAccountOwner(),
                    ));
         
            $tabRetour[] = array(
              'roster' => $unRoster,
              'accountOwner'  => $unAccount,
            );
        }
                
        return $tabRetour;
    }
    
    public function share($user,$idRoster,$nameAccoutShare,$session)
    {
        $em = $this->getEntityManager();
        
        $infoUserShare = $em->getRepository('AppBundle:Account')->infoAccount($nameAccoutShare);
        if(is_object($infoUserShare))
        {
            $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
            
            if($infoUser->getId() != $infoUserShare->getId())
            {
                $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
                    array(
                        'id'=>$idRoster,
                        'idAccount'=>$infoUser->getId(),
                    ));

                if($unRoster)
                {
                    $unRosterShare = $em->getRepository('AppBundle:RosterShare')->findOneBy(
                        array(
                            'idRoster'=>$idRoster,
                            'idAccountOwner'=>$infoUser->getId(),
                            'idAccountShare'=>$infoUserShare->getId(),
                        ));
                    if(is_object($unRosterShare))
                    {
                        $messageError = 'Roster already shared with this user';
                        $session->set('messageAccountError',$messageError);
                    }
                    else
                    {
                        $unRosterShare = new RosterShare();
                        $unRosterShare->setIdAccountOwner($infoUser->getId());
                        $unRosterShare->setIdAccountShare($infoUserShare->getId());
                        $unRosterShare->setIdRoster($idRoster);
                        $em->persist($unRosterShare);
                        $em->flush();

                        $messageSuccess = 'Roster shared';
                        $session->set('messageAccountSuccess',$messageSuccess);
                    }
                }
            }
            else
            {
                $messageError = 'Cant share with yourself...';
                $session->set('messageAccountError',$messageError);
            }
        }
        else
        {
            $messageError = 'Unknow account to share with';
            $session->set('messageAccountError',$messageError);
        }
    }     
    
    public function unshare($user,$idRoster,$idUserShared,$session)
    {
        $em = $this->getEntityManager();
        
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
            array(
                'id'=>$idRoster,
                'idAccount'=>$infoUser->getId(),
            ));
        
         if($unRoster)
         {
            $unRosterShare = $em->getRepository('AppBundle:RosterShare')->findOneBy(
                array(
                    'idRoster'=>$idRoster,
                    'idAccountOwner'=>$infoUser->getId(),
                    'idAccountShare'=>$idUserShared,
                ));
                        
            if(is_object($unRosterShare))
            {
                $em->remove($unRosterShare);
                $em->flush();

                $messageSuccess = 'Roster unshared';
                $session->set('messageAccountSuccess',$messageSuccess);
            }
         }
    }
    
    public function unshareforMe($user,$idRoster,$session)
    {
        $em = $this->getEntityManager();
        
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
        $unRoster = $em->getRepository('AppBundle:Roster')->findOneBy(
            array(
                'id'=>$idRoster,
            ));

        if($unRoster)
         {
            $unRosterShare = $em->getRepository('AppBundle:RosterShare')->findOneBy(
                array(
                    'idRoster'=>$idRoster,
                    'idAccountShare'=>$infoUser->getId(),
                ));
                        
            if(is_object($unRosterShare))
            {
                $em->remove($unRosterShare);
                $em->flush();

                $messageSuccess = 'Roster unshared';
                $session->set('messageAccountSuccess',$messageSuccess);
            }
         }
    }
}