<?php

namespace AppBundle\Repository;

use AppBundle\Entity\TrainingSimulatorCalendar;
use Doctrine\ORM\EntityRepository;

class TrainingSimulatorCalendarRepository extends EntityRepository
{
    public function addTrainings($tabTrainings,$unTrainingSimulator)
    {
        $em = $this->getEntityManager();
        
        if(count($tabTrainings) > 0)
        {
            foreach($tabTrainings as $unTraining)
            {
                $unTrainingSimulatorCalendar = new TrainingSimulatorCalendar();
                $unTrainingSimulatorCalendar->setIdTrainingSimulator($unTrainingSimulator->getId());
                $unTrainingSimulatorCalendar->setSaison($unTraining['s']);
                $unTrainingSimulatorCalendar->setSemaine($unTraining['w']);
                $unTrainingSimulatorCalendar->setEntrainement($unTraining['t']);
                $participe = 'NON';
                if($unTraining['1'] == 'O')
                {
                    $participe = 'OUI';
                }
                $unTrainingSimulatorCalendar->setJoueurUn($participe);
                $participe = 'NON';
                if($unTraining['2'] == 'O')
                {
                    $participe = 'OUI';
                }
                $unTrainingSimulatorCalendar->setJoueurDeux($participe);
                $participe = 'NON';
                if($unTraining['3'] == 'O')
                {
                    $participe = 'OUI';
                }
                $unTrainingSimulatorCalendar->setJoueurTrois($participe);
                $participe = 'NON';
                if($unTraining['4'] == 'O')
                {
                    $participe = 'OUI';
                }
                $unTrainingSimulatorCalendar->setJoueurQuatre($participe);
                $participe = 'NON';
                if($unTraining['5'] == 'O')
                {
                    $participe = 'OUI';
                }
                $unTrainingSimulatorCalendar->setJoueurCinq($participe);
                $participe = 'NON';
                if($unTraining['6'] == 'O')
                {
                    $participe = 'OUI';
                }
                $unTrainingSimulatorCalendar->setJoueurSix($participe);
                $em->persist($unTrainingSimulatorCalendar);
                $em->flush();
            }
        }
    }
    
    public function removeTrainings($unTrainingSimulator)
    {
        $em = $this->getEntityManager();
        
        $tabTrainingSimulatorCalendar = $em->getRepository('AppBundle:TrainingSimulatorCalendar')->findBy(
            array(
                'idTrainingSimulator'=>$unTrainingSimulator->getId(),
            ));
        foreach($tabTrainingSimulatorCalendar as $unTrainingSimulatorCalendar)
        {
            $em->remove($unTrainingSimulatorCalendar);
            $em->flush();
        }
    }
    
    public function getTrainings($unTrainingSimulator)
    {
        $em = $this->getEntityManager();
        
        $tabTrainingSimulatorCalendar = $em->getRepository('AppBundle:TrainingSimulatorCalendar')->findBy(
            array(
                'idTrainingSimulator'=>$unTrainingSimulator->getId(),
            ));
        
        $tabRetour = array();
        foreach($tabTrainingSimulatorCalendar as $unTrainingSimulatorCalendar)
        {
            $tabTraining = array();
            $tabTraining['saison'] = $unTrainingSimulatorCalendar->getSaison();
            $tabTraining['semaine'] = $unTrainingSimulatorCalendar->getSemaine();
            $tabTraining['entrainement'] = $unTrainingSimulatorCalendar->getEntrainement();
            $tabTraining['joueurUn'] = $unTrainingSimulatorCalendar->getJoueurUn();
            $tabTraining['joueurDeux'] = $unTrainingSimulatorCalendar->getJoueurDeux();
            $tabTraining['joueurTrois'] = $unTrainingSimulatorCalendar->getJoueurTrois();
            $tabTraining['joueurQuatre'] = $unTrainingSimulatorCalendar->getJoueurQuatre();
            $tabTraining['joueurCinq'] = $unTrainingSimulatorCalendar->getJoueurCinq();
            $tabTraining['joueurSix'] = $unTrainingSimulatorCalendar->getJoueurSix();
            $tabRetour[] = $tabTraining;
        }
        
        return $tabRetour;
    }
}