<?php

namespace AppBundle\Repository;

use AppBundle\Entity\TrainingSimulator;
use Doctrine\ORM\EntityRepository;

class TrainingSimulatorRepository extends EntityRepository
{
    public function create($idAccount,$nomChoisi,$lvlEntraineur,$dateDebutSimulation,$session)
    {
        $em = $this->getEntityManager();
        
        $unTrainingSimulator = $em->getRepository('AppBundle:TrainingSimulator')->findOneBy(
            array(
                'nom'=>$nomChoisi,
                'idAccount'=>$idAccount,
            ));
        
        if($unTrainingSimulator)
        {
            $messageError = 'Training Simulation name already existing';
            $session->set('messageAccountError',$messageError);
            $unTrainingSimulator = 'null';
        }
        else
        {
            $trainingNtsoClef = sha1(time().rand());

            $unTrainingSimulator = new TrainingSimulator();
            $unTrainingSimulator->setIdAccount($idAccount);
            $unTrainingSimulator->setNom($nomChoisi);
            $unTrainingSimulator->setClefNtso($trainingNtsoClef);
            $unTrainingSimulator->setLvlEntraineur($lvlEntraineur);
            $unTrainingSimulator->setDateDebutSimulation($dateDebutSimulation);
            $dateCreation = new \DateTime();
            $unTrainingSimulator->setDateCreation($dateCreation);
            $em->persist($unTrainingSimulator);
            $em->flush();
        }
        return $unTrainingSimulator;
    }   
    
    public function update($nomChoisi,$lvlEntraineur,$dateDebutSimulation,$clefNtso)
    {
        $em = $this->getEntityManager();
        
        $unTrainingSimulator = $em->getRepository('AppBundle:TrainingSimulator')->findOneBy(
            array(
                'clefNtso'=>$clefNtso,
            ));
        
        $unTrainingSimulator->setNom($nomChoisi);
        $unTrainingSimulator->setLvlEntraineur($lvlEntraineur);
        $unTrainingSimulator->setDateDebutSimulation($dateDebutSimulation);
        $em->persist($unTrainingSimulator);
        $em->flush();
        
        return $unTrainingSimulator;
    }
    
    public function remove($idTrainingSimulation,$user)
    {
        $em = $this->getEntityManager();
        $infoUser = $em->getRepository('AppBundle:Account')->infoAccount($user);
                 
        $unTrainingSimulator = $em->getRepository('AppBundle:TrainingSimulator')->findOneBy(
            array(
                'id'=>$idTrainingSimulation,
                'idAccount'=>$infoUser->getId(),
            ));
        
        if($unTrainingSimulator)
        {
            $em->getRepository('AppBundle:TrainingSimulatorPlayer')->removePlayers($unTrainingSimulator);
            $em->getRepository('AppBundle:TrainingSimulatorCalendar')->removeTrainings($unTrainingSimulator);
            $em->remove($unTrainingSimulator);
            $em->flush();
        }
        else
        {
            echo "Not your simulation...";
            die();
        }
    }
}